package algorithms;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.bcel.classfile.JavaClass;
import de.fub.bytecode.generic.MethodGen;

/**
@ Class: AlterIfElse
@ Author: Suma Venkatesh
@ Description: This algorithm alters the logical blocks of instructions inside if-else loop.
*/
public class AlterIfElse {

  de.fub.bytecode.generic.ConstantPoolGen cp;
  de.fub.bytecode.generic.MethodGen mg;
  de.fub.bytecode.generic.ClassGen cg;
  de.fub.bytecode.classfile.JavaClass java_class;
  
  utils.controlflowgraph.MethodCFG cfg;
  utils.controlflowgraph.BasicBlock endblk;
  utils.controlflowgraph.BasicBlock block;
  utils.controlflowgraph.BasicBlock curr;
  utils.controlflowgraph.BasicBlock left;
  utils.controlflowgraph.BasicBlock right;
  java.util.ArrayList rlist;
  java.util.ArrayList llist;
  java.util.ArrayList ldom;
  java.util.ArrayList rdom;
  
 

	public boolean apply(JavaClass clazz) {
     boolean sucess = false;
		try{
		String classname = clazz.getClassName();
		//classname = classname.substring(classname.indexOf("examples."));
		classname = classname.replaceAll("examples.","");
		System.out.println("classname..." + classname);
  		
		java_class = getClass(classname);
  		cp = new de.fub.bytecode.generic.ConstantPoolGen(java_class.getConstantPool());
  		de.fub.bytecode.classfile.Method[] methods =
		java_class.getMethods();
    	cg=new de.fub.bytecode.generic.ClassGen(java_class);
		for(int i=0;i<methods.length;i++)
  		{
  		  mg = new MethodGen(methods[i],null, cp);
  		  cfg = new utils.controlflowgraph.MethodCFG(mg,cp,true);
  		  modifyifelse();
  		sucess = true;
  		  methods[i]=mg.getMethod();
  		}
  		cg.setMethods(methods);
  		cg.setConstantPool(cp);
  		cg.getJavaClass().setConstantPool(cp.getFinalConstantPool());
  		de.fub.bytecode.classfile.JavaClass newClass = cg.getJavaClass();
  		
  		addClass(newClass);
  		convertToHTML(newClass,"Obf");
  		
 
	}catch(Exception e){e.printStackTrace(); }
	  return sucess;
	}
      
	 public de.fub.bytecode.classfile.JavaClass getClass(String classname) throws java.io.IOException {
		
		java.io.File f = new java.io.File("C:/JHide/examples/" + classname + ".class");
		de.fub.bytecode.classfile.ClassParser p = new de.fub.bytecode.classfile.ClassParser("C:/JHide/examples/" + classname + ".class");
		return p.parse();
	 }
	 /**
	  *  Adds or replaces a class in this collection, given a JavaClass.
	  */
	 public void addClass(de.fub.bytecode.classfile.JavaClass c) throws java.io.IOException {
		c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
	 }
	 public static void convertToHTML(de.fub.bytecode.classfile.JavaClass clazz,String type)   throws java.io.IOException {
	    de.fub.bytecode.util.Class2HTML conObj = new de.fub.bytecode.util.Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
	 }
 
	
     public void display() {
     	for(int j=0; j<cfg.nodes().size(); j++)  {
     		System.out.println("START");
     		utils.controlflowgraph.BasicBlock block =
           (utils.controlflowgraph.BasicBlock) cfg.nodes().get(j);
            System.out.println(block);
            java.util.List succ = block.getSuccessors();
            for(int i = 0; i < succ.size(); i++)
            	System.out.println("succ="+((utils.controlflowgraph.BasicBlock)
            succ.get(i)).getIH() );
            System.out.println("END");
     	}
     }

     private void prepareList(){
     	int k;
	    rlist=new java.util.ArrayList();
		rlist.add(right);
		llist=new java.util.ArrayList();
		llist.add(left);
        for( k=0;k<cfg.nodes().size(); k++)  {
	        block=(utils.controlflowgraph.BasicBlock)cfg.nodes().get(k);
	        if(block==left||block==right||block==endblk||block==curr)
				continue;
	        if(curr.dominates(block)&& endblk.postDominates(block)) {
		  		if(left.dominates(block))
		  			llist.add(block);
		 	    if(right.dominates(block))
					rlist.add(block);
	  	    }

      	}
}

     private void preparePdomList() {
     	ldom = new java.util.ArrayList();
     	block = left.getPostDominator();
     	while(block!=null && block.getIH()!=null)  {
     		 ldom.add(block);
     		 block=block.getPostDominator();
     	}
     	rdom = new java.util.ArrayList();
     	block = right.getPostDominator();
     	while(block!=null && block.getIH()!=null)  {
     		rdom.add(block);
     		block=block.getPostDominator();
     	}
}

     private int getEndBlock() {
     	endblk=null;
     	int k;
	    for(int i = 0; i < rdom.size(); i++) { 
	    	for(k=0; k<  ldom.size(); k++)
				if(rdom.get(i)==ldom.get(k)) break;
	       	if(k!=ldom.size()){
	       		endblk =(utils.controlflowgraph.BasicBlock)rdom.get(i);
	       		break;
	       	}
	    }
	    if(endblk==null) return 0;
      return 1;
    }

     private int checkList(){
     	int k;

     	//All the predecessors & successors must be in the same list
     	for(int i = 0; i < llist.size(); i++)	{
     		block = (utils.controlflowgraph.BasicBlock)llist.get(i);
     		for(k=0;k<block.getPredecessors().size();k++) {
     			if(block.getPredecessors().get(k)==curr)
				  continue;
     			if(llist.indexOf(block.getPredecessors().get(k))==-1)
				  return 0;
            }
  	    }
   	   for(int i = 0; i < llist.size(); i++) {
           block = (utils.controlflowgraph.BasicBlock)llist.get(i);
           for(k=0;k<block.getSuccessors().size();k++) {
           	   if(block.getSuccessors().get(k)==endblk)
				 continue;
  			   if(llist.indexOf(block.getSuccessors().get(k))==-1)
				 return 0;
          }
	  }
  	  for(int i = 0; i < rlist.size(); i++)	{
         block = (utils.controlflowgraph.BasicBlock)rlist.get(i);
         for(k=0;k<block.getPredecessors().size();k++)  {
         	if(block.getPredecessors().get(k)==curr)
			  continue;
 		    if(rlist.indexOf(block.getPredecessors().get(k))==-1)
			  return 0;
         }
	 }
    
	 for(int i = 0; i < rlist.size(); i++) {
        block = (utils.controlflowgraph.BasicBlock)rlist.get(i);
        for(k=0;k<block.getSuccessors().size();k++) { 
        	if(block.getSuccessors().get(k)==endblk)
			  continue;
			if(rlist.indexOf(block.getSuccessors().get(k))==-1)
 			  return 0;
         }
    }
    return 1;
}

 public void modifyifelse() {
     de.fub.bytecode.generic.InstructionList il=mg.getInstructionList();
     int k;
  
     //parse over all basic blocks
     System.out.println(" modifyifelse");
     for( int j=0;j<cfg.nodes().size(); j++)  {
        curr = (utils.controlflowgraph.BasicBlock)
		cfg.nodes().get(j);
        if(curr.getSuccessors().size()!=2) continue;

        java.util.ArrayList currInstList = curr.getInstList();
        int length = currInstList.size();
        if(length==0) continue;
        de.fub.bytecode.generic.InstructionHandle lastInstHandle =
        (de.fub.bytecode.generic.InstructionHandle) currInstList.get(length-1);
        de.fub.bytecode.generic.Instruction lastInst =
           		lastInstHandle.getInstruction();

        //check if the last instruction is a if instruction else continue
        if(!(lastInst instanceof de.fub.bytecode.generic.IfInstruction))
        	continue;
        de.fub.bytecode.generic.IfInstruction iInst =
              (de.fub.bytecode.generic.IfInstruction)lastInst;
        de.fub.bytecode.generic.InstructionHandle nextHandle =
              lastInstHandle.getNext();
        de.fub.bytecode.generic.InstructionHandle thandle =
              iInst.getTarget();
        System.out.println(" FOUND IF");

        //find the block that is the target block make it right
        block = null;
        for(int i = 0; i < cfg.nodes().size(); i++) {
        	block = (utils.controlflowgraph.BasicBlock)cfg.nodes().get(i);
        	if(block.getIH() == thandle)
                i = cfg.nodes().size();

        }
        right = block;

        //find the fallthrough block make it left
        block = null;
        for(int i = 0; i < cfg.nodes().size(); i++) {
        	block = (utils.controlflowgraph.BasicBlock)cfg.nodes().get(i);
        	if(block.getIH() == nextHandle)
              i =cfg. nodes().size();
        }
        left = block;
        if(left.getPredecessors().size()!=1) continue;
        if(right.getPredecessors().size()!=1) continue;
        if(left==right) continue;
        preparePdomList();
        if(getEndBlock()==0) continue;
        prepareList();
        if(checkList()==0) continue;
        //get the highest numbered block in the right list
       utils.controlflowgraph.BasicBlock high=null;
        k=-1;
        for(int i = 0; i < rlist.size(); i++){
        	block = (utils.controlflowgraph.BasicBlock)rlist.get(i);
        	if(block.getIH().getPosition()>k){
        		k=block.getIH().getPosition();
        		high=block;
        	}
        }
        if(high==null) continue;
        
        for(k=0; k < cfg.nodes().size();k++){
        	block=(utils.controlflowgraph.BasicBlock)cfg.nodes().get(k);
        	if(block.getIH()==null) continue;
        	if(block.getIH().getPosition()>=right.getIH().getPosition()
        			&& block.getIH().getPosition()<=high.getIH().getPosition())
       		if(rlist.indexOf(block)==-1)
			break;
        }
        if(k!=cfg.nodes().size()) continue;

        	//get the highest numbered block in the left list
        	utils.controlflowgraph.BasicBlock lhigh=null;
        k=-1;
        for(int i = 0; i < llist.size(); i++){
                block = (utils.controlflowgraph.BasicBlock)llist.get(i);
                if(block.getIH().getPosition()>k)
                {       k=block.getIH().getPosition();
                        lhigh=block;
                }
        }
        if(lhigh==null) continue;



	//They blocks should all be continuous
        for(k=0; k < cfg.nodes().size();k++)
        {
          block=(utils.controlflowgraph.BasicBlock) cfg.nodes().get(k);
          if(block.getIH()==null) continue;
          if(block.getIH().getPosition()>=left.getIH().getPosition()
                &&
           block.getIH().getPosition()<=lhigh.getIH().getPosition())
                if(llist.indexOf(block)==-1)
                        break;

        }
        if(k!=cfg.nodes().size()) continue;
 		de.fub.bytecode.generic.InstructionHandle lendih=null;

 		lendih=(de.fub.bytecode.generic.InstructionHandle)
               lhigh.getInstList().get(lhigh.getInstList().size()-1);

 		if(lendih.getNext()!=right.getIH()) continue;
 		de.fub.bytecode.generic.CodeExceptionGen[] exceptions =
        mg.getExceptionHandlers();



		de.fub.bytecode.generic.InstructionHandle endih=null;
		de.fub.bytecode.generic.InstructionHandle myih=null;
		de.fub.bytecode.generic.GOTO  myinst;
	
		endih=(de.fub.bytecode.generic.InstructionHandle)
		high.getInstList().get(high.getInstList().size()-1);


	    for(int i = 0; i < exceptions.length; i++){
	       de.fub.bytecode.generic.CodeExceptionGen ceg =  exceptions[i];
	       de.fub.bytecode.generic.InstructionHandle start = ceg.getStartPC();
           int startPos = start.getPosition();
           de.fub.bytecode.generic.InstructionHandle end =  ceg.getEndPC();
           int endPos = end.getPosition();
           if(end==endih && startPos <= curr.getIH().getPosition())
              ceg.setEndPC(lendih);
	    }
	    il.setPositions(true);
	    il.redirectBranches(right.getIH(),left.getIH());
	    il.setPositions(true);
	    il.move(right.getIH(),endih,lastInstHandle);
	    il.setPositions(true);
	    for(int i = 0; i < rlist.size(); i++){
	    	block = (utils.controlflowgraph.BasicBlock)rlist.get(i);
	    	if(block.fallthrough()==endblk)	{
		 
	    		block.setFallthrough(null);
			    myinst=new
			    de.fub.bytecode.generic.GOTO((de.fub.bytecode.generic.InstructionHandle)
			    endblk.getInstList().get(0));
			    //endblk.getIH()
			    myih=new de.fub.bytecode.generic.InstructionList(
			    myinst).getStart();
		        block.addInst(myih);
	            il.append(endih,myinst);
	    	}
	    }


	    il.setPositions(true);

	    lastInstHandle.setInstruction
	             ( ((de.fub.bytecode.generic.IfInstruction)lastInst).negate());
		lastInst=lastInstHandle.getInstruction();
	
	    curr.setFallthrough(right);
	   
		il.update();
	
		mg.setInstructionList(il);
		mg.update();
		cfg = new utils.controlflowgraph.MethodCFG(mg,cp,true);
		il=mg.getInstructionList();
	
     }// End FOR
 }

 public static void copy(String inFile, String outFile) throws IOException {

	 FileInputStream fin = null;
	 FileOutputStream fout = null;

	 try {
	   fin  = new FileInputStream(inFile);
	   fout = new FileOutputStream(outFile);
	   StreamCopier(fin, fout);
	 }
	 finally {
	   try {
	     if (fin != null) fin.close();
	   }
	   catch (IOException e) {System.out.println("Exception " +e );}
	   try {
	     if (fout != null) fout.close();
	    }
	   catch (IOException e) { System.out.println("Exception " +e ); }
	 }

}

public static void StreamCopier(InputStream in, OutputStream out) throws IOException {

   synchronized (in) {
     synchronized (out) {

       byte[] buffer = new byte[256];
       while (true) {
         int bytesRead = in.read(buffer);
         if (bytesRead == -1) break;
         out.write(buffer, 0, bytesRead);
       }
     }
   }
}

}
