package algorithms;

import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import algorithms.random1;
import java.io.*;
import java.util.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: ConstantsPoolReordering
@ Author: Suma Venkatesh
@ Description: This algorithm is one kind of reordering which reorders 
  the constants in the constant pool and assigns random indices to them.
*/

public class ConstantsPoolReordering {

	
	boolean errflag=false;
	private java.util.Hashtable htcopy=null;
	private ConstantPoolGen  copycpg=null;
	private ConstantPoolGen  anothercopy=null;
	private CodeException [][] codexc=null;
	int cur_mtd=0;
	int cplen=-1;
	MethodGen mgen;
	Method [] methods;



	public boolean apply(String classname) {
		 ClassGen cgen = null;
		 boolean sucess = false;
		 try {

		   	JavaClass clazz = Repository.lookupClass("examples/"+ classname);
			cgen = new ClassGen(clazz);
			Method [] methods = cgen.getMethods();

			ConstantsPoolReordering obj = new ConstantsPoolReordering();
			obj.randomCPindexgen(classname,clazz,cgen);

	    	JavaClass c = cgen.getJavaClass();
			c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
			convertToHTML(c,"Obf");
			sucess = true;

	     }

	     catch(Exception e) {System.out.println("Exception" + e.getMessage() + e.fillInStackTrace());return sucess;}
		return sucess;
     }

	/**
	 * The main function that coordinates the calls to all other functions which actually do the algorithm
	 */
	public ClassGen randomCPindexgen(String classname,JavaClass clazz,ClassGen cgen) throws IOException  {

	   int no_of_locals=0;
	   ConstantPoolGen  cpg1=cgen.getConstantPool();
	   int total_incr=0,oldip=-1;
	   Instruction[] local_in =null;
	   InstructionList local_il=null;
	   String classname1 = cgen.getClassName();
	   int local_pos[],astart_bc=-1,aend_bc=-1,astart_ip=-1,aend_ip=-1;
  	   cgen = new ClassGen(clazz);
	   File outputFile = new File("C:/JHide/Obfuscated_Classes/"+ classname+"_src"+".txt");
	   FileWriter out = new FileWriter(outputFile);

	   if(cgen.getSuperclassName().indexOf("IOException")!=-1) {
		 System.out.println(" Encountered IOexception ... reverting ");
		 return cgen;
		}
		cpg1=cgen.getConstantPool();
		ConstantPool tempc= cpg1.getConstantPool().copy();
		copycpg= new ConstantPoolGen(tempc);
		classname1 = cgen.getClassName();
		cplen= cpg1.getSize();
		if(cplen > 300 || cgen.isStatic() || cgen.isFinal() )
			return cgen;
		java.util.HashSet hs=null;
		Field [] f=cgen.getFields();
		for(int i=0;i<f.length;i++)	{
			if(f[i].isStatic() && f[i].isFinal()) {
				if(hs==null)
				  hs= new java.util.HashSet();
				hs.add(new Integer(f[i].getNameIndex()));
				hs.add(new Integer(f[i].getSignatureIndex()));
				if(f[i].getConstantValue()!=null)
				  hs.add(new Integer(f[i].getConstantValue().getConstantValueIndex()));
			}
		}
		for(int i=1;i<cplen;i++) {
			Constant constant = copycpg.getConstant(i);
			if(constant.getTag() == (byte)5 || constant.getTag() == (byte)6) {
			  if(hs==null)
				hs= new java.util.HashSet();
  			  hs.add(new Integer(i));
			  hs.add(new Integer(i+1));
			  i++;
			}else if(constant.getTag() == (byte)7 )	{
				ConstantClass cc = (ConstantClass)copycpg.getConstant(i);
			
  			  System.out.println(" INDEX: " +i);
			  if(hs==null)
				hs= new java.util.HashSet();
			  hs.add(new Integer(i));
			}
			else if(constant.getTag() == (byte)1 )	{
			  		ConstantUtf8 utf = (ConstantUtf8)copycpg.getConstant(i);
			  		String val = utf.getBytes();
					if(val.endsWith(".java") || val.equals("LineNumberTable") || val.equals("LocalVariableTable")
					   || val.equals("ConstantValue") || val.equals("InnerClasses") || val.indexOf('$')!=-1)
					{
						
							System.out.println (" Val is " + val + " so goin to add to hs");
						if(hs==null)
							hs= new java.util.HashSet();
						System.out.println(" Adding to hashset" + i);
						hs.add(new Integer(i));
					}
			}
		}

		Attribute [] att= clazz.getAttributes();
		for(int i=0;i<att.length;i++)
		{

		}


	
		  System.out.println(" ConstantPoolLength:"+cplen);
		  System.out.println(" Original CP:");
		  for(int k=1;k<cplen;k++)	{
			 //System.out.println("["+k+"]: "+copycpg.getConstant(k).toString());
			out.write("["+k+"]: "+copycpg.getConstant(k).toString());
			out.write("/n");

			 if(copycpg.getConstant(k).getTag() == (byte)5 || copycpg.getConstant(k).getTag() == (byte)6)
				k++;
			 }
	  	
  		  Hashtable ht= null;
		  if(hs==null)
			ht= random1.reorderCPIndexes(cplen);
		  else
			ht= random1.reorderCPIndexes(cplen,hs);
			htcopy=ht;
			makechangestoClassGen(ht,cgen);
		int curval=0;
		for(int j=1;j<cplen;j++)
			for(int i=1;i<ht.size();i++){
				Integer in=(Integer)ht.get(new Integer(i));
  			    if( in.intValue() != j )
				  continue;
				   int cur_cpindex = i;
				   Constant constant = copycpg.getConstant(cur_cpindex);
				   if(constant.getTag() == (byte)1)  // utf8
				   {
						cpg1.setConstant(j,constant);
				   }
				   else if(constant.getTag() == (byte)3)  // integer
				   {
						cpg1.setConstant(j,constant);
				   }
				   else if(constant.getTag() == (byte)4)  // float
				   {
						cpg1.setConstant(j,constant);
				   }
				   else if(constant.getTag() == (byte)5)  // long
				   {
						cpg1.setConstant(j,constant);
						j++;
						break;
				   }
				   else if(constant.getTag() == (byte)6)  // double
				   {
						cpg1.setConstant(j,constant);
						j++;
						break;
				   }
				   else if(constant.getTag() == (byte)7)  // class
				   {
						ConstantClass cc =(ConstantClass)copycpg.getConstant(cur_cpindex);
						int oldnameindex= cc.getNameIndex();
						Integer tem= (Integer)ht.get(new Integer(oldnameindex));
						int newnameindex= tem.intValue();
						cc.setNameIndex(newnameindex);
						cpg1.setConstant(j,cc);
				   }
				   else if(constant.getTag() == (byte)8)  // String
				   {
						ConstantString cs=(ConstantString)copycpg.getConstant(cur_cpindex);
						int oldstringindex= cs.getStringIndex();
						Integer tem= (Integer)ht.get(new Integer(oldstringindex));
						int newnameindex= tem.intValue();
						cs.setStringIndex(newnameindex);
						cpg1.setConstant(j,cs);
				   }
				   else if(constant.getTag() == (byte)9)  // fieldref
				   {
						ConstantFieldref cfr =(ConstantFieldref)copycpg.getConstant(cur_cpindex);

						int oldclassindex= cfr.getClassIndex();
						Integer tem= (Integer)ht.get(new Integer(oldclassindex));
						int newclassindex= tem.intValue();
						cfr.setClassIndex(newclassindex);

						int oldntindex= cfr.getNameAndTypeIndex();
						tem= (Integer)ht.get(new Integer(oldntindex));
						int newntindex= tem.intValue();
						cfr.setNameAndTypeIndex(newntindex);
						cpg1.setConstant(j,cfr);
				   }
				   else if(constant.getTag() == (byte)10)  // methodref
				   {
						ConstantMethodref cmr =(ConstantMethodref)copycpg.getConstant(cur_cpindex);

						int oldclassindex= cmr.getClassIndex();
						Integer tem= (Integer)ht.get(new Integer(oldclassindex));
						int newclassindex= tem.intValue();
						cmr.setClassIndex(newclassindex);

						int oldntindex= cmr.getNameAndTypeIndex();
						tem= (Integer)ht.get(new Integer(oldntindex));
						int newntindex= tem.intValue();
						cmr.setNameAndTypeIndex(newntindex);
						cpg1.setConstant(j,cmr);
				   }
				   else if(constant.getTag() == (byte)11)  // interfacemethodref
				   {
						ConstantInterfaceMethodref imr =(ConstantInterfaceMethodref)copycpg.getConstant(cur_cpindex);

						int oldclassindex= imr.getClassIndex();
						Integer tem= (Integer)ht.get(new Integer(oldclassindex));
						int newclassindex= tem.intValue();
						imr.setClassIndex(newclassindex);

						int oldntindex= imr.getNameAndTypeIndex();
						tem= (Integer)ht.get(new Integer(oldntindex));
						int newntindex= tem.intValue();
						imr.setNameAndTypeIndex(newntindex);
						cpg1.setConstant(j,imr);
				   }
				   else if(constant.getTag() == (byte)12)  // nameandtype
				   {
						ConstantNameAndType cnt =(ConstantNameAndType)copycpg.getConstant(cur_cpindex);

						int oldnameindex= cnt.getNameIndex();
						Integer tem= (Integer)ht.get(new Integer(oldnameindex));
						int newnameindex= tem.intValue();
						cnt.setNameIndex(newnameindex);

						int oldsigindex= cnt.getSignatureIndex();
						tem= (Integer)ht.get(new Integer(oldsigindex));
						int newsigindex= tem.intValue();
						cnt.setSignatureIndex(newsigindex);
						cpg1.setConstant(j,cnt);
				   }
				   else
				   {
						System.out.println(" Cant understand tag " + constant.getTag());
				   }
				}


				ConstantPool finalcp=cpg1.getFinalConstantPool();
				
						for(int i=0;i< finalcp.getLength();i++)
						{
						   if(finalcp.getConstant(i)!=null && finalcp.getConstant(i).getTag() != (byte)0  )
							System.out.println(" [ " +i+" ] " + finalcp.getConstant(i).toString());
						   else if (finalcp.getConstant(i)!=null && finalcp.getConstant(i).getTag() == (byte)0)
								System.out.println(" Found an item with invalid tag at " +i);
						}
				


				cgen.setConstantPool(cpg1);
				makechangestoCode(ht,cpg1,cgen);
				if(errflag==true)
						return cgen;
				methods = cgen.getMethods();
				for(int i=0;i<methods.length;i++)
				{
						CodeException [] coe =cgen.getMethods()[i].getCode().getExceptionTable();
						if(coe.length >0)
						{
								errflag=true;
								return cgen;
						}
						CodeException [] coecopy = new CodeException[coe.length];
						for (int coeindex=0;coeindex < coe.length;coeindex++)
						{
								coecopy[coeindex]= coe[coeindex].copy();
						}
						adjustExceptions(codexc[i],coecopy,oldip,total_incr,total_incr);
						cgen.getMethods()[i].getCode().setExceptionTable(codexc[i]);
						coe =cgen.getMethods()[cur_mtd].getCode().getExceptionTable();
						for(int t=0;t<coe.length;t++)
							System.out.println(" EXCEPTION%" + coe[t].getCatchType());
					


						Attribute[] attribute = methods[i].getAttributes();
						for(int j=0;j<attribute.length;j++)
						{
								int oldindex= attribute[j].getNameIndex();
								Integer imp = (Integer)ht.get(new Integer(oldindex));
								attribute[j].setNameIndex(imp.intValue());
								System.out.println("\n methodsAttribute  : Oldindex : "+ oldindex + " NewIndex :" + imp.intValue());
						}
						methods[i].setAttributes(attribute);

						Method tempf = methods[i];
						int oldindex= methods[i].getNameIndex();
						Integer imp = (Integer)ht.get(new Integer(oldindex));
						methods[i].setNameIndex(imp.intValue());
						
						System.out.println(" Method  :" +i+ " OldNameindex : "+ oldindex + " NewNameIndex :" + imp.intValue());

						oldindex= methods[i].getSignatureIndex();
						imp = (Integer)ht.get(new Integer(oldindex));
						methods[i].setSignatureIndex(imp.intValue());
						
						System.out.println(" Method  :" +i+ " OldSignatureindex : "+ oldindex + " NewSignatureIndex :" + imp.intValue());

						methods[i].setConstantPool(cpg1.getConstantPool());
						cgen.replaceMethod(cgen.getMethods()[i],methods[i]);
				}


				methods = cgen.getMethods();

				for(int i=0;i<methods.length;i++)
				{

						
						System.out.println(" Method  :" +methods[i].getName() + " CurrentNameindex : "+methods[i].getNameIndex()+ " NewSignatureIndex :" +methods[i].getSignatureIndex());
						
						
							   CodeException [] coe =methods[i].getCode().getExceptionTable();
								for(int t=0;t<coe.length;t++)
								{
										System.out.println(" final EXCEPTION%" + coe[t].getCatchType());
								}
								System.out.println("***************After  Modifications*************");
								System.out.println(methods[i].getCode().toString());
								//out1.write(methods[i].getCode().toString());
								System.out.println("***************88888888888888888888888*************");
						}
				

				Integer classindex= (Integer)ht.get(new Integer(cgen.getClassNameIndex()));
				int ci =classindex.intValue();
				cgen.setClassNameIndex(ci);
				
				System.out.println("ClassNameIndex : "+cgen.getClassNameIndex());

				Integer superclassindex= (Integer)ht.get(new Integer(cgen.getSuperclassNameIndex()));
				ci =superclassindex.intValue();
				cgen.setSuperclassNameIndex(ci);
				
				System.out.println("SuperClassNameIndex : "+cgen.getSuperclassNameIndex());
				out.close();

				return(cgen);
			}

			public void makechangestoCode(java.util.Hashtable ht,ConstantPoolGen newone,ClassGen cgen)
			{
			  try{
				Instruction[] local_in =null;
				InstructionList local_il=null;

				File outputFile1 = new File("C:/JHide/Obfuscated_Classes/"+ "TestConstantsPoolReordering"+"_obf"+".txt");
				FileWriter out1 = new FileWriter(outputFile1);

				int local_pos[];
				ConstantPoolGen  cpg1=cgen.getConstantPool();
				
						System.out.println(" NewConstantPoolLength:"+cplen);
						System.out.println(" NEW CP:");
						for(int k=1;k<cplen;k++)
						{
								System.out.println("["+k+"]: "+cpg1.getConstant(k).toString());
								out1.write("["+k+"]: "+ cpg1.getConstant(k).toString());


								if(cpg1.getConstant(k).getTag() == (byte)5 || cpg1.getConstant(k).getTag() == (byte)6)
										k++;

						}
				

				String classname1 = cgen.getClassName();

				methods = cgen.getMethods();
				int total_incr=0,oldip=-1;

				codexc = new CodeException[methods.length][];

				   for(int i=0;i<methods.length;i++)
				   {

						codexc[i]=cgen.getMethods()[i].getCode().getExceptionTable();
						if(codexc[i]!=null)
						{
								for(int t=0;t<codexc[i].length;t++)
								
								
								System.out.println(" Makechangestocode EXCEP{TION :S "+ codexc[i][t].getStartPC() +" E "+ codexc[i][t].getEndPC() +"H "+ codexc[i][t].getHandlerPC());
								
						}
				   }


				for(int i=0;i<methods.length;i++)
				{

						mgen= new MethodGen(methods[i],classname1,cpg1);


					   Attribute[] attribute = mgen.getCodeAttributes();
						for(int j=0;j<attribute.length;j++)
						{
						int oldindex= attribute[j].getNameIndex();
							
								System.out.println("\n methodsCodeAttribute  : Oldindex : "+ oldindex );
						}

						cur_mtd=i;

						
						System.out.println(" \n \n ******(Applying Reorder CP for " + mgen.getName());

						local_il = mgen.getInstructionList();
						local_pos = local_il.getInstructionPositions();
						local_in = local_il.getInstructions();

						boolean []cantouch= new boolean[local_in.length];
						for(int o=0;o<local_in.length;o++)
						{
								cantouch[o]=true;
						}

						CodeException [] coe =cgen.getMethods()[cur_mtd].getCode().getExceptionTable();
						CodeException [] coecopy
								= new CodeException[coe.length];
						for (int coeindex=0;coeindex < coe.length;coeindex++)
						{
								coecopy[coeindex]= coe[coeindex].copy();
						}

			
				{
				   System.out.println("**************************");
				   System.out.println(" Method : " +methods[i].getName() );
				   System.out.println("**************************");
				   for(int c=0;c<local_in.length;c++)
				   {
						System.out.println(local_in[c].toString());
				   }
				}

						total_incr=0;

						for(int k=0;k<local_in.length;k++)
						{

						   
								 System.out.println("               Reading .. " +local_in[k].toString() );
						   if(local_in[k] instanceof CPInstruction)
						   {
							CPInstruction cpinstr=null;

								 oldip=local_pos[k];
								 int j=((CPInstruction)local_in[k]).getIndex() ;
								 Integer temp =(Integer) (ht.get(new Integer(j)));
								 int newvalue =temp.intValue();

								 if(local_in[k] instanceof GETFIELD)
								 {
												total_incr=editIndex(0,k, newvalue ,local_il,local_pos);
								 }
								 else if(local_in[k] instanceof PUTFIELD)
								 {
												total_incr=editIndex(1,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof GETSTATIC)
								 {

												total_incr=editIndex(2,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof PUTSTATIC)
								 {
												total_incr=editIndex(3,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof INVOKEINTERFACE)
								 {
												total_incr=editIndex(4,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof INVOKESPECIAL)
								 {
												total_incr=editIndex(5,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof INVOKESTATIC)
								 {
												total_incr=editIndex(6,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof INVOKEVIRTUAL)
								 {
												total_incr=editIndex(7,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof ANEWARRAY)
								 {
												total_incr=editIndex(8,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof CHECKCAST)
								 {
												total_incr=editIndex(9,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof INSTANCEOF)
								 {
												total_incr=editIndex(10,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof LDC)
								 {
												total_incr=editIndex(11,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof LDC_W)
								 {
												total_incr=editIndex(12,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof MULTIANEWARRAY)
								 {
												total_incr=editIndex(13,k, newvalue ,local_il,local_pos);

								 }
								 else if(local_in[k] instanceof NEW)
								 {
												total_incr=editIndex(14,k, newvalue ,local_il,local_pos);

								 }


								local_in=local_il.getInstructions();
								local_pos=local_il.getInstructionPositions();

						}
					  }

						mgen.setInstructionList(local_il);
						mgen.stripAttributes(true);
						cgen.replaceMethod(cgen.getMethods()[cur_mtd],mgen.getMethod());

				}
				out1.close();
			  }catch(Exception e)
				 {
						System.out.println("****** Null pointer exception occured \n");
						errflag=true;
				 }

			}

			public int editIndex(int instrtype,int k,int newval,InstructionList local_il,int []local_pos)
			{

				int local_incr=0;
				InstructionHandle ih=null;
			 if(instrtype==0)
			 {
				local_il.setPositions();
				
				System.out.println(" insert getfield_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new GETFIELD(newval));
				local_il.setPositions();
				local_incr+= ( new GETFIELD(newval)).getLength();
			 }
			 else if(instrtype==1)
			 {
				local_il.setPositions();
				
				System.out.println(" insert putfield_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new PUTFIELD(newval));
				local_il.setPositions();
				local_incr+= ( new PUTFIELD(newval)).getLength();
			 }
			 else if(instrtype==2)
			 {
				local_il.setPositions();
				
				System.out.println(" insert GETSTATIC_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new GETSTATIC(newval));
				local_il.setPositions();
				local_incr+= ( new GETSTATIC(newval)).getLength();
			 }
			 else if(instrtype==3)
			 {
				local_il.setPositions();
				
				System.out.println(" insert PUTSTATIC_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new PUTSTATIC(newval));
				local_il.setPositions();
				local_incr+= ( new PUTSTATIC(newval)).getLength();
			 }
			 else if(instrtype==4)
			 {

				INVOKEINTERFACE iif=null;
				iif =(INVOKEINTERFACE)local_il.findHandle(local_pos[k]+local_incr).getInstruction();
				int nargs =iif.getCount();
				local_il.setPositions();
				
				System.out.println(" insert invokinterface_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new INVOKEINTERFACE(newval,nargs));
				local_il.setPositions();
				local_incr+= ( new INVOKEINTERFACE(newval,nargs)).getLength();

			 }
			 else if(instrtype==5)
			 {
				local_il.setPositions();
				
				System.out.println(" insert INVOKESPECIAL_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new INVOKESPECIAL(newval));
				local_il.setPositions();
				local_incr+= ( new INVOKESPECIAL(newval)).getLength();
			 }
			 else if(instrtype==6)
			 {
				local_il.setPositions();
				
				System.out.println(" insert INVOKESTATIC_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new INVOKESTATIC(newval));
				local_il.setPositions();
				local_incr+= ( new INVOKESTATIC(newval)).getLength();
			 }
			 else if(instrtype==7)
			 {
				local_il.setPositions();
			
				System.out.println(" insert INVOKEVIRTUAL_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new INVOKEVIRTUAL(newval));
				local_il.setPositions();
				local_incr+= ( new INVOKEVIRTUAL(newval)).getLength();
			 }
			 else if(instrtype==8)
			 {
				local_il.setPositions();
				
				System.out.println(" insert ANEWARRAY_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new ANEWARRAY(newval));
				local_il.setPositions();
				local_incr+= ( new ANEWARRAY(newval)).getLength();
			 }
			 else if(instrtype==9)
			 {
				local_il.setPositions();
				
				System.out.println(" insert CHECKCAST_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new CHECKCAST(newval));
				local_il.setPositions();
				local_incr+= ( new CHECKCAST(newval)).getLength();
			 }
			 else if(instrtype==10)
			 {

				local_il.setPositions();
				
				System.out.println(" insert INSTANCEOF_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new INSTANCEOF(newval));
				local_il.setPositions();
				local_incr+= ( new INSTANCEOF(newval)).getLength();
			 }
			 else if(instrtype==11)
			 {
				local_il.setPositions();
				
				System.out.println(" insert LDC_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new LDC(newval));
				local_il.setPositions();
				local_incr+= ( new LDC(newval)).getLength();
			 }
			 else if(instrtype==12)
			 {
				local_il.setPositions();
				
				System.out.println(" insert LDC_Wnewindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new LDC_W(newval));
				local_il.setPositions();
				local_incr+= ( new LDC_W(newval)).getLength();
			 }
			 else if(instrtype==13)
			 {
				MULTIANEWARRAY man=null;
				man =(MULTIANEWARRAY)local_il.findHandle(local_pos[k]+local_incr).getInstruction();
				short dim =man.getDimensions();
				local_il.setPositions();
				
				System.out.println(" insert MULTIANEWARRAYnewindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new MULTIANEWARRAY(newval,dim));
				local_il.setPositions();
				local_incr+= ( new MULTIANEWARRAY(newval,dim)).getLength();

			 }
			 else if(instrtype==14)
			 {
				local_il.setPositions();
				
				System.out.println(" insert NEW_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
				ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new NEW(newval));
				local_il.setPositions();
				local_incr+= ( new NEW(newval)).getLength();
			 }



				int len=-100;
				try{
						local_il.setPositions();

						System.out.println(" Trying to redirect all branches that had  " +
						local_il.findHandle(local_pos[k]+local_incr).toString() +  " to " +
						local_il.findHandle(ih.getPosition()).toString());
						local_il.redirectBranches(local_il.findHandle(local_pos[k]+local_incr),local_il.findHandle(ih.getPosition()));

						
						System.out.println(" delete orig: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());

						len= local_il.findHandle(local_pos[k]+local_incr).getInstruction().getLength();
						local_il.delete(local_il.findHandle(local_pos[k]+local_incr));
						local_incr -= len;
						local_il.setPositions();

				}catch(Exception e6)
				{
				 local_incr -= len;
				 local_il.setPositions();

				}

				System.out.println(" Local_incr " + local_incr);
				return local_incr;

		}

		    /* This function is called whenever code is added inside in a try-catch block. Modifies the
			 * startPC,endPC and handlerPC of the exception table to reflect the changes to the code.
			 *
			 * @param coe ExceptionTable Object
			 * @param coecopy A deep copy of the exception table of the unmodified code.
			 * @param cur_pos Position of the bytecode instruction that is modified in the unmodifed code.
			 * @param count Number of new instructions added to the method in place of the current instruction.
			 * @param addcount A cumulative count of the instructions added to the method.
			 */
			private void adjustExceptions(CodeException []coe,CodeException []coecopy,int cur_pos,int count,int addcount)
			{
				int epc;
				int spc;
				int hpc;
				int ct;
				int newct=0;

				for (int i=0;i<coe.length;i++)
				{
						ct=coecopy[i].getCatchType();
						Integer it = (Integer)htcopy.get(new Integer(ct));
						int newcatchindex = it.intValue();
						System.out.println(" Old catch index :  " + ct + " New CatchIndex: " +newcatchindex);
						coe[i].setCatchType(newcatchindex);
				}
						System.out.println( " EXCEPTION TABLE:");
						for (int i=0;i<coe.length;i++)
						{
								System.out.println(coe[i].getStartPC() +"  "+ coe[i].getEndPC()+"  "+coe[i].getHandlerPC() + "  " + coe[i].getCatchType());
						}
				
		}

		 public void makechangestoClassGen(java.util.Hashtable ht,ClassGen cgen)
			{

				Attribute[] attribute = cgen.getAttributes();
				for(int i=0;i<attribute.length;i++)
				{
						cgen.removeAttribute(attribute[i]);
						int oldindex= attribute[i].getNameIndex();
						Integer imp = (Integer)ht.get(new Integer(oldindex));
						attribute[i].setNameIndex(imp.intValue());
						
						System.out.println(" Attribute  :" +i+ " Oldindex : "+ oldindex + " NewIndex :" + imp.intValue());
						cgen.addAttribute(attribute[i]);
				}

				Field[] fields = cgen.getFields();
				for(int i=0;i<fields.length;i++)
				{
						attribute = fields[i].getAttributes();
						for(int j=0;j<attribute.length;j++)
						{

						int oldindex= attribute[j].getNameIndex();
						Integer imp = (Integer)ht.get(new Integer(oldindex));
						attribute[j].setNameIndex(imp.intValue());
						
						System.out.println(" FieldAttribute  : Oldindex : "+ oldindex + " NewIndex :" + imp.intValue());

						}
						fields[i].setAttributes(attribute);

						Field tempf = fields[i];
						int oldindex= fields[i].getNameIndex();
						Integer imp = (Integer)ht.get(new Integer(oldindex));
						fields[i].setNameIndex(imp.intValue());
						
						System.out.println(" Field  :" +i+ " OldNameindex : "+ oldindex + " NewNameIndex :" + imp.intValue());

						oldindex= fields[i].getSignatureIndex();
						imp = (Integer)ht.get(new Integer(oldindex));
						fields[i].setSignatureIndex(imp.intValue());
						
						System.out.println(" Field  :" +i+ " OldSignatureindex : "+ oldindex + " NewSignatureIndex :" + imp.intValue());
						cgen.replaceField(tempf,fields[i]);
				}




		}

		public static void printCode(String classname,String msg) throws IOException  {

				File outputFile = new File("C:/JHide/Obfuscated_Classes/"+ classname+".txt");
				FileWriter out = new FileWriter(outputFile);
				out.write(msg.toString());
				out.close();


		}
		public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
			   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
       }
}