package algorithms;


/**
  * IntArraySplitter ,as the name suggests , does Data Obfuscation by splitting
  * an integer array in the original program into two arrays ,and based on some
  * encoding meothd , the elements are put in either of the two arrays .The current
  * implementation suppots the following form of encoding : Even elements are put in
  * one array and odd in another
  *
  */

public class DataAggregation {

    private de.fub.bytecode.classfile.JavaClass jc1;
    private de.fub.bytecode.classfile.ClassParser cp;
    private de.fub.bytecode.generic.ClassGen cg1;

    private de.fub.bytecode.generic.MethodGen mg1;
    private de.fub.bytecode.classfile.Method [] methods1;
    private String classname2,fname;

    de.fub.bytecode.generic.Instruction[] in=null ;
    de.fub.bytecode.generic.InstructionHandle[] todel =null;


    int arraycount=0;
    int returnhandle=-1;
    int no_of_locals=0;
    int len_of_array=0;
    int arr1_lvindex=-1;
    int arr2_lvindex=-1;
    int arr_assign_start=-1;
    int arr_assign_end=-1;
    int lvindex=-1;
    int poscount=0;
    int delcount=0;
    byte arraytype;
    int increase=0;
    int cur_mtd=0;

    /** Gets all the BCEL bytecode editing class objects up and running
    */

    public int aggregate(String classname) {
       System.out.println("Processing "+classname);
       classname2 = classname.substring(0,classname.length()-6)+"_new.class";
       try {
       	  jc1= getClass(classname);
       }
       catch(Exception ioe)  {
       	  ioe.printStackTrace();
       }
       cg1 = new de.fub.bytecode.generic.ClassGen(jc1);
       if ( cg1.isInterface() || cg1.isAbstract())
       	return -1;
       methods1 = cg1.getMethods();
       return 1;
    }

    /** Obtain the length of an array ,whose length is constant ,from bytecode
     * @param i Offset of the newarray instruction
     * @param l Instruction array for this method .
     */

    public int getLength(int i,de.fub.bytecode.generic.Instruction[] l) {
    	de.fub.bytecode.generic.Instruction[] local_in=l;
    	if(local_in[i-1] instanceof de.fub.bytecode.generic.BIPUSH)	{
		de.fub.bytecode.generic.BIPUSH bipush =(de.fub.bytecode.generic.BIPUSH)local_in[i-1];
		Integer integ = (Integer)bipush.getValue();
		return integ.intValue();

	}
	else if(local_in[i-1]instanceof de.fub.bytecode.generic.SIPUSH)	{
		de.fub.bytecode.generic.SIPUSH sipush =(de.fub.bytecode.generic.SIPUSH)local_in[i-1];
		Integer integ = (Integer)sipush.getValue();
		return integ.intValue();

	}
	else if (local_in[i-1]instanceof de.fub.bytecode.generic.ICONST){
		de.fub.bytecode.generic.ICONST iconst =(de.fub.bytecode.generic.ICONST)local_in[i-1];
		Integer integ = (Integer)iconst.getValue();
		return integ.intValue();
	}
	return -1;
    }


    /** If the array 's length will be known only at runtime , use this meothd to add two new integer arrays and delete the old array
     * @param type The type of the array
     * @param xastores_offset
     * @param lens_offset The offset in bytecode where you can find the instruction that specifies the length of the array
     * @param local_il Instruction List Array
     * @param local_pos Instruction Position Array
     * @param cpg1 ConstantPoolGen
     */

    public int addDynaNewArr(byte type,int xastores_offset,int lens_offset,int newarrays_offset,
    				de.fub.bytecode.generic.InstructionList local_il,int[]local_pos,
				de.fub.bytecode.generic.ConstantPoolGen  cpg1)  {
			
    		int local_incr=0;
			arr1_lvindex =no_of_locals++;
			arr2_lvindex =no_of_locals++;
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert istore before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			int whichvar=no_of_locals++;
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ISTORE(whichvar) );
			local_incr+= ( new de.fub.bytecode.generic.ISTORE(no_of_locals++)).getLength();
		
			local_il.setPositions();
		
			System.out.println(" NEW ARR :: insert iload before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ILOAD(whichvar) );
			local_incr+= ( new de.fub.bytecode.generic.ILOAD(whichvar)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert iconst_2 before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ICONST(2) );
			local_incr+= ( new de.fub.bytecode.generic.ICONST(2)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert idiv before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.IDIV() );
			local_incr+= ( new de.fub.bytecode.generic.IDIV()).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert iload before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ILOAD(whichvar) );
			local_incr+= ( new de.fub.bytecode.generic.ILOAD(whichvar)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert iconst_2 before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ICONST(2) );
			local_incr+= ( new de.fub.bytecode.generic.ICONST(2)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert iREM before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.IREM() );
			local_incr+= ( new de.fub.bytecode.generic.IREM()).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert iadd before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.IADD() );
			local_incr+= ( new de.fub.bytecode.generic.IADD()).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert newarray before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.NEWARRAY(type) );
			local_incr+= ( new de.fub.bytecode.generic.NEWARRAY(type)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert astore before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ASTORE(arr1_lvindex) );
			local_incr+= ( new de.fub.bytecode.generic.ASTORE(arr1_lvindex)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert iload before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ILOAD(whichvar) );
			local_incr+= ( new de.fub.bytecode.generic.ILOAD(whichvar)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert iconst_2 before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ICONST(2) );
			local_incr+= ( new de.fub.bytecode.generic.ICONST(2)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert idiv before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.IDIV() );
			local_incr+= ( new de.fub.bytecode.generic.IDIV()).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert newarray before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.NEWARRAY(type) );
			local_incr+= ( new de.fub.bytecode.generic.NEWARRAY(type)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert astore before: " +local_il.findHandle(local_pos[newarrays_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[newarrays_offset]+local_incr),new de.fub.bytecode.generic.ASTORE(arr2_lvindex) );
			local_incr+= ( new de.fub.bytecode.generic.ASTORE(arr2_lvindex)).getLength();
		
			return local_incr;
    }

    /** Add two new integer arrays and delete the old array
     * @param type The type of the array
     * @param xastores_offset
     * @param lens_offset The offset in bytecode where you can find the instruction that specifies the length of the array
     * @param local_il Instruction List Array
     * @param local_pos Instruction Position Array
     * @param cpg1 ConstantPoolGen
     */

    public int addNewArrays(byte type,int xastores_offset,int lens_offset,de.fub.bytecode.generic.InstructionList local_il,int[] local_pos,
    				de.fub.bytecode.generic.ConstantPoolGen  cpg1)
    {
    
    	
		    int flag=0;
			int cp_index,odd=-1;
			int local_incr=0;
			cp_index=cpg1.addInteger(len_of_array/2);
			if(len_of_array%2==1)
			{
			  odd=cpg1.addInteger((len_of_array/2)+1);
			  flag=1;
			}
			arr1_lvindex =no_of_locals++;
			arr2_lvindex =no_of_locals++;
		
			if(flag==0)
			{
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert ldc before: " +local_il.findHandle(local_pos[lens_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[lens_offset]+local_incr),new de.fub.bytecode.generic.LDC(cp_index) );
			local_incr+= ( new de.fub.bytecode.generic.LDC(cp_index)).getLength();
			}
			else
			{
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert ldc before: " +local_il.findHandle(local_pos[lens_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[lens_offset]+local_incr),new de.fub.bytecode.generic.LDC(odd));
			local_incr+= ( new de.fub.bytecode.generic.LDC(odd)).getLength();
			}
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert newarray before: " +local_il.findHandle(local_pos[lens_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[lens_offset]+local_incr),new de.fub.bytecode.generic.NEWARRAY(type) );
			local_incr+= ( new de.fub.bytecode.generic.NEWARRAY(type)).getLength();
		
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert astore before: " +local_il.findHandle(local_pos[lens_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[lens_offset]+local_incr),new de.fub.bytecode.generic.ASTORE(arr1_lvindex) );
			local_incr+= ( new de.fub.bytecode.generic.ASTORE(arr1_lvindex)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert ldc before: " +local_il.findHandle(local_pos[lens_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[lens_offset]+local_incr),new de.fub.bytecode.generic.LDC(cp_index) );
			local_incr+= ( new de.fub.bytecode.generic.LDC(cp_index)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert newarray before: " +local_il.findHandle(local_pos[lens_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[lens_offset]+local_incr),new de.fub.bytecode.generic.NEWARRAY(type) );
			local_incr+= ( new de.fub.bytecode.generic.NEWARRAY(type)).getLength();
		
			local_il.setPositions();
			
			System.out.println(" NEW ARR :: insert astore before: " +local_il.findHandle(local_pos[lens_offset]+local_incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[lens_offset]+local_incr),new de.fub.bytecode.generic.ASTORE(arr2_lvindex) );
			local_incr+= ( new de.fub.bytecode.generic.ASTORE(arr2_lvindex)).getLength();
		
			return local_incr;

    }


    public int setIndex(int aload,de.fub.bytecode.generic.InstructionList local_il,int []local_pos,
    	de.fub.bytecode.generic.InstructionHandle ih)   {

		    int local_incr=0;
			local_il.setPositions();
			
			System.out.println(" ARR WRITE:: insert aload_2ndarray before: " +local_il.findHandle(aload).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(aload),new de.fub.bytecode.generic.ALOAD(arr2_lvindex));
			local_il.setPositions();
			local_incr+= ( new de.fub.bytecode.generic.ALOAD(arr2_lvindex)).getLength();
		
			int len=-100;
			try{
				local_il.setPositions();
		
				
				System.out.println(" ARR WRITE:: TRying to redirect all branches that had  " +
		
				local_il.findHandle(aload+local_incr).toString() +  " to " +
				local_il.findHandle(ih.getPosition()).toString());
				local_il.redirectBranches(local_il.findHandle(aload+local_incr),local_il.findHandle(ih.getPosition()));
		
				System.out.println(" ARR WRITE:: delete aload_orig: " +local_il.findHandle(aload+local_incr).getInstruction().toString());
		
				len= local_il.findHandle(aload+local_incr).getInstruction().getLength();
				local_il.delete(local_il.findHandle(aload+local_incr));
				local_incr -= len;
				local_il.setPositions();
		
			}catch(Exception e6)
			{
			 local_incr -= len;
			 local_il.setPositions();
			
			}
		
			return local_incr;

    }

    public int deleteIlist(int sip,int eip,de.fub.bytecode.generic.InstructionList local_il,int[] local_pos)  {

			int ii=0,len=0;
			int local_incr=0;
			for(int k=sip;k<=eip;k+=ii) {
				try{
					local_il.setPositions();
					System.out.println(" ARR WRITE:: deleting original index list : " +local_il.findHandle(k+local_incr).getInstruction().toString());
					len= local_il.findHandle(k+local_incr).getInstruction().getLength();
					local_il.delete(local_il.findHandle(k+local_incr));
					local_incr -= len;
					local_il.setPositions();
				}catch(Exception e6)
				{
			 		local_incr -= len;
			 		local_il.setPositions();
			 		
				}
				ii=len;
		
			}
		
			return local_incr;
    }


    public int insert_iby_2(de.fub.bytecode.generic.InstructionList local_il,int []local_pos,int index_end_ip,int incr_tillnow){
    	
			    int local_incr=0;
			    local_il.setPositions();
				
			    
				System.out.println(" ARR WRITE:: append idiv after: " +local_il.findHandle(index_end_ip+incr_tillnow).getInstruction().toString());
				local_il.append(local_il.findHandle(index_end_ip+incr_tillnow),new de.fub.bytecode.generic.IDIV());
				local_incr+= ( new de.fub.bytecode.generic.IDIV()).getLength();
			
				local_il.setPositions();
				
				System.out.println(" ARR WRITE:: append iconst2 after: " +local_il.findHandle(index_end_ip+incr_tillnow).getInstruction().toString());
				local_il.append(local_il.findHandle(index_end_ip+incr_tillnow),new de.fub.bytecode.generic.ICONST(2));
				local_incr+= ( new de.fub.bytecode.generic.ICONST(2)).getLength();
				local_il.setPositions();
				System.out.println(" fun 2 :" +local_incr);
				return local_incr;
    }
			
	public int finish_insert(de.fub.bytecode.generic.InstructionList local_il,int []local_pos,
				int aloads_offset, int Ilistlen, int Vlistlen, de.fub.bytecode.generic.InstructionList Ilist,
			     de.fub.bytecode.generic.InstructionList Vlist,int cur_xastore_ip) {
			    
				int local_incr=0;
				de.fub.bytecode.generic.InstructionHandle ttemp=null;
				de.fub.bytecode.generic.InstructionList Ilistcopy = Ilist.copy();
			
				local_il.setPositions();
				
				System.out.println(" ARR WRITE:: insert index list before: " +local_il.findHandle(aloads_offset).getInstruction().toString());
				ttemp=local_il.insert(local_il.findHandle(aloads_offset),Ilist);
				local_il.setPositions();
				System.out.println(" ARR WRITE:: index list RETURNED: " +ttemp.toString());
				
				local_incr+= Ilistlen;
				local_il.setPositions();
			
			
				
				System.out.println(" ARR WRITE:: TRying to redirect all branches that had  " +
					local_il.findHandle(aloads_offset+local_incr).toString() +  " to " +
					local_il.findHandle(ttemp.getPosition()).toString());
				local_il.redirectBranches(local_il.findHandle(aloads_offset+local_incr),local_il.findHandle(ttemp.getPosition()));
			
			
			
				
				System.out.println(" ARR WRITE:: insert istore before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				int temp_var = no_of_locals++;
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.ISTORE(temp_var));
				local_incr+= (new de.fub.bytecode.generic.ISTORE(temp_var)).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert iLOAD before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.ILOAD(temp_var));
				local_incr+= (new de.fub.bytecode.generic.ILOAD(temp_var)).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert iconst_2 before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.ICONST(2));
				local_incr+= (new de.fub.bytecode.generic.ICONST(2)).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert irem before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.IREM());
				local_incr+= (new de.fub.bytecode.generic.IREM()).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert ifne before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),
					new de.fub.bytecode.generic.IFNE(local_il.findHandle(aloads_offset+local_incr)));
				local_incr+= (new de.fub.bytecode.generic.IFNE(local_il.findHandle(aloads_offset+local_incr) ) ).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert aload_1st array before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.ALOAD(arr1_lvindex));
				local_incr+= (new de.fub.bytecode.generic.ALOAD(arr1_lvindex)).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert iLOAD before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.ILOAD(temp_var));
				local_incr+= (new de.fub.bytecode.generic.ILOAD(temp_var)).getLength();
				local_il.setPositions();
			
			
				System.out.println(" ARR WRITE:: insert iconst_2 before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.ICONST(2));
				local_incr+= (new de.fub.bytecode.generic.ICONST(2)).getLength();
				local_il.setPositions();
			
			
				System.out.println(" ARR WRITE:: insert idiv before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.IDIV());
				local_incr+= (new de.fub.bytecode.generic.IDIV()).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert value list before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),Vlist);
				local_incr+= Vlistlen;
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: insert iastore before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+local_incr),new de.fub.bytecode.generic.IASTORE());
				local_incr+= (new de.fub.bytecode.generic.IASTORE()).getLength();
				local_il.setPositions();
			
			
				System.out.println(" ARR WRITE:: insert goto before: " +local_il.findHandle(aloads_offset+local_incr).getInstruction().toString());
				int oldincr=local_incr;
				
				System.out.println(" ARR WRITE:: Target of goto stmt is : " +local_il.findHandle(cur_xastore_ip+local_incr).getInstruction().toString());
				local_il.insert(local_il.findHandle(aloads_offset+oldincr),new de.fub.bytecode.generic.GOTO(local_il.findHandle(cur_xastore_ip+local_incr)));
				local_incr+= (new de.fub.bytecode.generic.GOTO(local_il.findHandle(cur_xastore_ip+local_incr) ) ).getLength();
				local_il.setPositions();
			
				int incr_tillnow = local_incr;
			
				
				System.out.println(" ARR WRITE:: insert idiv before: " +local_il.findHandle(aloads_offset+incr_tillnow).getInstruction().toString());
				local_il.append(local_il.findHandle(aloads_offset+incr_tillnow),new de.fub.bytecode.generic.IDIV());
				local_incr+= (new de.fub.bytecode.generic.IDIV()).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: append iconst_2 after: " +local_il.findHandle(aloads_offset+incr_tillnow).getInstruction().toString());
				local_il.append(local_il.findHandle(aloads_offset+incr_tillnow),new de.fub.bytecode.generic.ICONST(2));
				local_incr+= (new de.fub.bytecode.generic.ICONST(2)).getLength();
				local_il.setPositions();
			
				
				System.out.println(" ARR WRITE:: append iLOAD after: " +local_il.findHandle(aloads_offset+incr_tillnow).getInstruction().toString());
				local_il.append(local_il.findHandle(aloads_offset+incr_tillnow),new de.fub.bytecode.generic.ILOAD(temp_var));
				local_incr+= (new de.fub.bytecode.generic.ILOAD(temp_var)).getLength();
				local_il.setPositions();
			
				return local_incr;
    }


    public int editingReads(de.fub.bytecode.generic.InstructionList local_il,
     			int []local_pos, int aloadsoffset,int ialoadsoffset)  {
    	
    	int local_incr=0;
    	int len=0;
    	try{
			local_il.setPositions();
			
			System.out.println(" ARR READS:: deleting original aload : " +local_il.findHandle(local_pos[aloadsoffset]).getInstruction().toString());
			len= local_il.findHandle(local_pos[aloadsoffset]).getInstruction().getLength();
			local_il.delete(local_il.findHandle(local_pos[aloadsoffset]));
			local_incr -= len;
			local_il.setPositions();
    	}catch(Exception e6){
    		local_incr -= len;
    		local_il.setPositions();
    	}


    	
		System.out.println(" ARR READ:: insert istore before: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		int temp_var = no_of_locals++;
		local_il.insert(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ISTORE(temp_var));
		len=(new de.fub.bytecode.generic.ISTORE(temp_var)).getLength();
		local_incr+= len;
		local_il.setPositions();


		System.out.println(" ARR READ:: append iaload after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.IALOAD());
		int newincr =local_incr+ (new de.fub.bytecode.generic.IALOAD()).getLength();
		local_il.setPositions();
	
		System.out.println(" ARR READ:: append idiv after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.IDIV());
		newincr += (new de.fub.bytecode.generic.IDIV()).getLength();
		local_il.setPositions();
	
	
		System.out.println(" ARR READ:: append iconst2 after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ICONST(2));
		newincr += (new de.fub.bytecode.generic.ICONST(2)).getLength();
		local_il.setPositions();
	
	
		System.out.println(" ARR READ:: append iLOAD after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ILOAD(temp_var));
		newincr+= (new de.fub.bytecode.generic.ILOAD(temp_var)).getLength();
		local_il.setPositions();
	
	
		System.out.println(" ARR READ:: append ALOAD after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		de.fub.bytecode.generic.InstructionHandle ihtemp=
			local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ALOAD(arr2_lvindex));
		local_il.setPositions();
		int temp=ihtemp.getPosition();
		newincr+= (new de.fub.bytecode.generic.ALOAD(arr2_lvindex)).getLength();
		local_il.setPositions();
	
	
		System.out.println(" ARR READ:: append goto after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		int oldincr=local_incr;
	
		System.out.println(" ARR READ:: Target of goto stmt is : " +local_il.findHandle(local_pos[ialoadsoffset+1]+ newincr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.GOTO(local_il.findHandle(local_pos[ialoadsoffset+1]+ newincr)));
		int gotolen=(new de.fub.bytecode.generic.GOTO(local_il.findHandle(local_pos[ialoadsoffset+1]+ newincr) ) ).getLength();
		newincr+=gotolen;
		temp+= gotolen;
		local_il.setPositions();
	
	
		
		System.out.println(" ARR READ:: append iaload after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.IALOAD());
		newincr += (new de.fub.bytecode.generic.IALOAD()).getLength();
		temp += (new de.fub.bytecode.generic.IALOAD()).getLength();
		local_il.setPositions();
	
		
		System.out.println(" ARR READ:: append idiv after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.IDIV());
		newincr += (new de.fub.bytecode.generic.IDIV()).getLength();
		temp += (new de.fub.bytecode.generic.IDIV()).getLength();
		local_il.setPositions();
	
		
		System.out.println(" ARR READ:: append iconst2 after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ICONST(2));
		newincr += (new de.fub.bytecode.generic.ICONST(2)).getLength();
		temp += (new de.fub.bytecode.generic.ICONST(2)).getLength();
		local_il.setPositions();
	
		
		System.out.println(" ARR READ:: append iLOAD after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ILOAD(temp_var));
		newincr+= (new de.fub.bytecode.generic.ILOAD(temp_var)).getLength();
		temp+= (new de.fub.bytecode.generic.ILOAD(temp_var)).getLength();
		local_il.setPositions();
	
	
		
		System.out.println(" ARR READ:: append ALOAD after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ALOAD(arr1_lvindex));
		newincr+= (new de.fub.bytecode.generic.ALOAD(arr1_lvindex)).getLength();
		temp+= (new de.fub.bytecode.generic.ALOAD(arr1_lvindex)).getLength();
		local_il.setPositions();
	
		
		System.out.println(" ARR READ:: append  ifne after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),
			new de.fub.bytecode.generic.IFNE(local_il.findHandle(temp)));
		newincr+= (new de.fub.bytecode.generic.IFNE(local_il.findHandle(temp) ) ).getLength();
		local_il.setPositions();
	
	
		
		System.out.println(" ARR READ:: append irem after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.IREM());
		newincr += (new de.fub.bytecode.generic.IREM()).getLength();
		local_il.setPositions();
	
		
		System.out.println(" ARR READ:: append iconst2 after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ICONST(2));
		newincr += (new de.fub.bytecode.generic.ICONST(2)).getLength();
		local_il.setPositions();
	
		
		System.out.println(" ARR READ:: append iLOAD after: " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
		local_il.append(local_il.findHandle(local_pos[ialoadsoffset]+local_incr),new de.fub.bytecode.generic.ILOAD(temp_var));
		newincr+= (new de.fub.bytecode.generic.ILOAD(temp_var)).getLength();
		local_il.setPositions();
	
		try{
			local_il.setPositions();
			
			System.out.println(" ARR READS:: deleting iaload : " +local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().toString());
			len= local_il.findHandle(local_pos[ialoadsoffset]+local_incr).getInstruction().getLength();
			local_il.delete(local_il.findHandle(local_pos[ialoadsoffset]+local_incr));
			newincr-=len;
			local_incr -= len;
			local_il.setPositions();
		}catch(Exception e6)
		{
			local_incr -= len;
			newincr-=len;
			local_il.setPositions();
		 	
		}
	return newincr;

    }

    public void adjustArrLengths()   {
        
		    int total_incr=0,aload_ip=-1000;
			de.fub.bytecode.generic.ConstantPoolGen  cpg1 = cg1.getConstantPool();
			String classname1 = cg1.getClassName();
		
			de.fub.bytecode.classfile.Method[] localm= cg1.getMethods();
		   	de.fub.bytecode.generic.MethodGen localmg =
				new de.fub.bytecode.generic.MethodGen(cg1.getMethods()[cur_mtd],classname1,cpg1);
		    de.fub.bytecode.generic.InstructionList local_il= localmg.getInstructionList();
			de.fub.bytecode.generic.Instruction[] local_in=local_il.getInstructions();
			int[] local_pos=local_il.getInstructionPositions();
			de.fub.bytecode.generic.InstructionHandle ihr=null;
			System.out.println("ARR LENGTH: LVINDEX   :"+lvindex);
			System.out.println("ARR LENGTH: Method Getcode printout");
			System.out.println(localm[cur_mtd].getCode().toString());
			
		
			de.fub.bytecode.classfile.CodeException [] coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
			de.fub.bytecode.classfile.CodeException [] coecopy
					= new de.fub.bytecode.classfile.CodeException[coe.length];
			for (int coeindex=0;coeindex < coe.length;coeindex++)
			{
				coecopy[coeindex]= coe[coeindex].copy();
			}
		
		  	for(int i=0;i<local_in.length;i++)
			{
				
				System.out.println(" ARRLENGTHS:  Reading .. " +local_in[i].toString());
				de.fub.bytecode.generic.ALOAD aload =null;
		
				if(local_in[i] instanceof de.fub.bytecode.generic.ALOAD &&
				( ( (de.fub.bytecode.generic.ALOAD)local_in[i] ).getIndex()==lvindex)  &&
				local_in[i+1] instanceof de.fub.bytecode.generic.ARRAYLENGTH )
				{
					aload_ip=local_pos[i];
					total_incr+=editlength(local_il,local_pos,i);
					local_il.setPositions();
		
					adjustExceptions(coe,coecopy,aload_ip,total_incr,total_incr);
				 	cg1.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
				 	coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
		
					  for (int coeindex=0;coeindex < coe.length;coeindex++)
			  		  {
						coecopy[coeindex]= coe[coeindex].copy();
		  	        	  }
					local_in=local_il.getInstructions();
					local_pos=local_il.getInstructionPositions();
		
				}
			}
		 	localmg.setInstructionList(local_il);
			localmg.setMaxLocals(no_of_locals);
			localmg.setMaxStack();
		
			localmg.stripAttributes(true);
			cg1.replaceMethod(cg1.getMethods()[cur_mtd],localmg.getMethod());
			cg1.setConstantPool(cpg1);


    }
    public int editlength(de.fub.bytecode.generic.InstructionList local_il,
     			int []local_pos, int aloads_offset)
    {
	      int local_incr=0;
	      
		System.out.println(" ARR LENGTH:: insert aload_2ndarray before: " +local_il.findHandle(local_pos[aloads_offset]+local_incr).getInstruction().toString());
		local_il.insert(local_il.findHandle(local_pos[aloads_offset]+local_incr),new de.fub.bytecode.generic.ALOAD(arr2_lvindex));
		local_il.setPositions();
		local_incr+= ( new de.fub.bytecode.generic.ALOAD(arr2_lvindex)).getLength();
	
	
	      
		System.out.println(" ARR LENGTH:: insert arrayLENGTH before: " +local_il.findHandle(local_pos[aloads_offset]+local_incr).getInstruction().toString());
		local_il.insert(local_il.findHandle(local_pos[aloads_offset]+local_incr),new de.fub.bytecode.generic.ARRAYLENGTH());
		local_il.setPositions();
		local_incr+= ( new de.fub.bytecode.generic.ARRAYLENGTH() ).getLength();
	
	     
		System.out.println(" ARR LENGTH:: insert aload_1st array before: " +local_il.findHandle(local_pos[aloads_offset]+local_incr).getInstruction().toString());
		local_il.insert(local_il.findHandle(local_pos[aloads_offset]+local_incr),new de.fub.bytecode.generic.ALOAD(arr1_lvindex));
		local_incr+= (new de.fub.bytecode.generic.ALOAD(arr1_lvindex)).getLength();
		local_il.setPositions();
	
	     
		System.out.println(" ARR LENGTH:: insert arrayLENGTH before: " +local_il.findHandle(local_pos[aloads_offset]+local_incr).getInstruction().toString());
		local_il.insert(local_il.findHandle(local_pos[aloads_offset]+local_incr),new de.fub.bytecode.generic.ARRAYLENGTH());
		local_il.setPositions();
		local_incr+= ( new de.fub.bytecode.generic.ARRAYLENGTH() ).getLength();
	
	
	
	      
		System.out.println(" ARR LENGTH:: insert iadd before: " +local_il.findHandle(local_pos[aloads_offset]+local_incr).getInstruction().toString());
		local_il.insert(local_il.findHandle(local_pos[aloads_offset]+local_incr),new de.fub.bytecode.generic.IADD());
		local_il.setPositions();
		local_incr+= ( new de.fub.bytecode.generic.IADD() ).getLength();
	
	    int len=0;
		try{
			local_il.setPositions();
			
			System.out.println(" ARR length:: deleting original aload : " +local_il.findHandle(local_pos[aloads_offset]+local_incr).getInstruction().toString());
			len= local_il.findHandle(local_pos[aloads_offset]+local_incr).getInstruction().getLength();
			local_il.delete(local_il.findHandle(local_pos[aloads_offset]+local_incr));
			local_incr -= len;
			local_il.setPositions();
		}catch(Exception e6)
		{
			local_incr -= len;
			local_il.setPositions();
		 	e6.printStackTrace();
		}
	
		try{
			local_il.setPositions();
			
			System.out.println(" ARR length:: deleting original arraylength : " +local_il.findHandle(local_pos[aloads_offset+1]+local_incr).getInstruction().toString());
			len= local_il.findHandle(local_pos[aloads_offset+1]+local_incr).getInstruction().getLength();
			local_il.delete(local_il.findHandle(local_pos[aloads_offset+1]+local_incr));
			local_incr -= len;
			local_il.setPositions();
		}catch(Exception e6)
		{
			local_incr -= len;
			local_il.setPositions();
		 	e6.printStackTrace();
		}
		return local_incr;
	    }

    public void adjustArrReads()  {

        de.fub.bytecode.generic.ConstantPoolGen  cpg1 = cg1.getConstantPool();
        String classname1 = cg1.getClassName();
        de.fub.bytecode.classfile.Method[] localm= cg1.getMethods();
    	de.fub.bytecode.generic.MethodGen localmg =
		new de.fub.bytecode.generic.MethodGen(cg1.getMethods()[cur_mtd],classname1,cpg1);

        de.fub.bytecode.generic.InstructionList local_il= localmg.getInstructionList();
        de.fub.bytecode.generic.Instruction[] local_in=local_il.getInstructions();
        int[] local_pos=local_il.getInstructionPositions();

        de.fub.bytecode.generic.InstructionHandle ihr=null;

		System.out.println("ARR READS: LVINDEX               :"+lvindex);
		System.out.println("ARR READS: Method Getcode printout");
		System.out.println(localm[cur_mtd].getCode().toString());
	

		int decl_ip=-1;
		int count=0,finalflag=0;
		int total_incr=0,aload_ip=0;
		de.fub.bytecode.classfile.CodeException [] coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
		de.fub.bytecode.classfile.CodeException [] coecopy
				= new de.fub.bytecode.classfile.CodeException[coe.length];
		  for (int coeindex=0;coeindex < coe.length;coeindex++)
		  {
			coecopy[coeindex]= coe[coeindex].copy();
		  }
	
		for(int i=0;i<local_in.length;i++)
		{
			
			System.out.println(" ARR READS:  Reading .. " +local_in[i].toString());
			de.fub.bytecode.generic.ALOAD aload =null;
	
			if(local_in[i] instanceof de.fub.bytecode.generic.ALOAD &&
			( ((de.fub.bytecode.generic.ALOAD)local_in[i]).getIndex()==lvindex) )
			{
				count++;
	
				for(int j=i+1;j<local_in.length;j++)
				{
				   
				    System.out.println(" Reading .. " +local_in[j].toString());
	
				    if(local_in[j] instanceof de.fub.bytecode.generic.IALOAD) // modify for xastore
				    {
				    	count--;
					if(count==0) // found iastore for an aload i.e array write
					{
					aload_ip=local_pos[i];
				    	de.fub.bytecode.generic.InstructionHandle ih1=local_il.findHandle(local_pos[i]);
					de.fub.bytecode.generic.InstructionHandle ih2=local_il.findHandle(local_pos[j]);
	
					total_incr+=editingReads(local_il,local_pos,i,j);
	
					finalflag=1;
					break;
					}
					else
					continue;
	
				    }
				}
	
				if(finalflag==1)
				{
					finalflag=0;
					local_il.setPositions();
	
					adjustExceptions(coe,coecopy,aload_ip,total_incr,total_incr);
				 	cg1.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
				 	coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
	
					  for (int coeindex=0;coeindex < coe.length;coeindex++)
			  		  {
						coecopy[coeindex]= coe[coeindex].copy();
		  	        	  }
					local_in=local_il.getInstructions();
					local_pos=local_il.getInstructionPositions();
	
				}
	
			}
	
		}
	
	 	localmg.setInstructionList(local_il);
		localmg.setMaxLocals(no_of_locals);
		localmg.setMaxStack();
	
		localmg.stripAttributes(true);
		cg1.replaceMethod(cg1.getMethods()[cur_mtd],localmg.getMethod());
		cg1.setConstantPool(cpg1);


    }

    public void adjustArrWrites()
    {
		   	String classname1 = cg1.getClassName();
		    de.fub.bytecode.generic.ConstantPoolGen  cpg1 = cg1.getConstantPool();  /*/**/
			de.fub.bytecode.classfile.Method[] localm= cg1.getMethods();
		    	de.fub.bytecode.generic.MethodGen local_mg =
				new de.fub.bytecode.generic.MethodGen(localm[cur_mtd],classname1,cpg1);
			
			
		
			de.fub.bytecode.generic.InstructionList local_il= local_mg.getInstructionList();
			de.fub.bytecode.generic.Instruction[] local_in=local_il.getInstructions();
			int[] local_pos=local_il.getInstructionPositions();
		
			de.fub.bytecode.generic.InstructionList Ilist=new de.fub.bytecode.generic.InstructionList();
			de.fub.bytecode.generic.InstructionList Vlist=null;
		
			de.fub.bytecode.generic.InstructionHandle wr_start=null ,wr_end=null,index_end=null;
			de.fub.bytecode.generic.InstructionHandle[] value=null;
			de.fub.bytecode.generic.InstructionHandle dummy_ih=null;
		
			int index_st_ip=-1,index_end_ip=-1,incr=0,Ilistlen=-1,Vlistlen=-1,finalflag=0;
			int count=0; // this is to keep track of arrays ,using arrays as index
			int ip_end =-1; // ip in bytecode after the array write
			int total_incr=0,aload_ip=0;
			de.fub.bytecode.classfile.CodeException [] coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
			de.fub.bytecode.classfile.CodeException [] coecopy
					= new de.fub.bytecode.classfile.CodeException[coe.length];
			for (int coeindex=0;coeindex < coe.length;coeindex++)
			{
				coecopy[coeindex]= coe[coeindex].copy();
			}
		
				de.fub.bytecode.generic.InstructionHandle[] tt2 = local_il.getInstructionHandles();
			  	for(int z=0;z<tt2.length;z++)
				{
					System.out.println(tt2[z].toString());
				}
			
		
			for(int i=0;i<local_in.length;i++)
			{
		
				
				de.fub.bytecode.generic.ALOAD aload =null;
		
		
				if(local_in[i] instanceof de.fub.bytecode.generic.IASTORE)
				{
					wr_end=local_il.findHandle(local_pos[i]);
					de.fub.bytecode.generic.InstructionHandle arr_name=arr.getNameofArray(wr_end,local_mg,cpg1);
					       if(arr_name.getInstruction() instanceof de.fub.bytecode.generic.ALOAD &&
							( ((de.fub.bytecode.generic.ALOAD)(arr_name.getInstruction())).getIndex()==lvindex) )
					       {
						wr_start=arr_name;
		
						   int aloads_ip=wr_start.getPosition();
						  index_end=arr.getIndexInstructions(wr_end,local_mg,cpg1); // ih is got
						  index_end_ip=index_end.getPosition();
						  index_st_ip=wr_start.getPosition() + wr_start.getInstruction().getLength();
		
						  System.out.println(" aloadsipo "  + aloads_ip +" end ip = " +index_end_ip);
		
						  int toadd=  local_pos[i] + (new de.fub.bytecode.generic.IASTORE()).getLength();
						  Ilistlen=index_end_ip-index_st_ip+(local_il.findHandle(index_end_ip)).getInstruction().getLength();
		
						  Ilist=createIndexIlist(index_st_ip,index_end_ip,local_il,local_pos);
						  value=arr.getValueInstructions(wr_start,wr_end,local_mg,cpg1);
		
						 
						  System.out.println(" AFTER CALLING SS VALUE [0] : " +value[0].getInstruction().toString()  +" and VALUE[1] : " +
						  			value[1].getInstruction().toString());
		
						  Vlistlen=value[1].getPosition() + value[1].getInstruction().getLength() -(  value[0].getPosition() + value[0].getInstruction().getLength() );
		
						
						  System.out.println(" Value list len = " +Vlistlen + "Indexlstlen =" +Ilistlen);
		
						  Vlist= createValueIlist(value,local_il,local_pos);
						
						  int in_t_now=setIndex(aloads_ip,local_il,local_pos,dummy_ih);
						  total_incr+=in_t_now;
						  local_il.setPositions();
						  int fun2=deleteIlist(index_st_ip+in_t_now,index_end_ip+in_t_now,local_il,local_pos);
						  total_incr+=fun2;
		
		
						  int tempe=finish_insert(local_il,local_pos,aloads_ip,Ilistlen,Vlistlen,Ilist,Vlist,toadd+fun2+in_t_now);
						  total_incr+=tempe;
						 
						  {
						  	System.out.println("********************************************************");
						  	de.fub.bytecode.generic.InstructionHandle[] tt1 = local_il.getInstructionHandles();
						  	for(int z=0;z<tt1.length;z++)
						  	{
								System.out.println(tt1[z].toString());
						  	}
		
						  	System.out.println("********************************************************");
						  }
						  finalflag =1;
		
					    }  // end of if iastore
					 //} // eo for loop
		
					if(finalflag==1)
					{
					  finalflag=0;
					  local_il.setPositions();
					  adjustExceptions(coe,coecopy,aload_ip,total_incr,total_incr);
					  cg1.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
					  coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
		
					  for (int coeindex=0;coeindex < coe.length;coeindex++)
			  		  {
						coecopy[coeindex]= coe[coeindex].copy();
			  	          }
		
					  local_in=local_il.getInstructions();
					  local_pos=local_il.getInstructionPositions();
		
					}
				}  //eo if
			} //eo for  loop
		
		
			local_il.setPositions();
		 	local_mg.setInstructionList(local_il);
			local_mg.setMaxLocals(no_of_locals);
			local_mg.setMaxStack();
			local_mg.stripAttributes(true);
			cg1.replaceMethod(cg1.getMethods()[cur_mtd],local_mg.getMethod());
			cg1.setConstantPool(cpg1);

    }

    public de.fub.bytecode.generic.InstructionList createIndexIlist(int sip,int eip,
    	de.fub.bytecode.generic.InstructionList local_il,int[] local_pos)
    {
	de.fub.bytecode.generic.InstructionList temp = new de.fub.bytecode.generic.InstructionList();
	int ii=0;
	for(int k=sip;k<=eip;k+=ii)
	{
		
		System.out.println(" Appending " + local_il.findHandle(k).getInstruction().toString());
		temp.append(local_il.findHandle(k).getInstruction());
		ii=local_il.findHandle(k).getInstruction().getLength();
	}

	return temp;
    }

    public de.fub.bytecode.generic.InstructionList createValueIlist(de.fub.bytecode.generic.InstructionHandle[] val,
    	de.fub.bytecode.generic.InstructionList local_il,int[] local_pos)
    {
	de.fub.bytecode.generic.InstructionList temp = new de.fub.bytecode.generic.InstructionList();
	int ii=0;
	int sip= val[0].getPosition() + val[0].getInstruction().getLength();
	int eip= val[1].getPosition() ;

	
	System.out.println(" Going to append to value list  " + sip + "  " +eip);

	for(int k=sip;k<=eip;k+=ii)
	{
		
		System.out.println(" Appending " + local_il.findHandle(k).getInstruction().toString());
		temp.append(local_il.findHandle(k).getInstruction());
		ii=local_il.findHandle(k).getInstruction().getLength();
	}

	return temp;
    }

    public void split(int dup,int xstore,int flag,byte arrtype)
    {
    	int start_bc=-1,end_bc=-1;
	int start_ip=-1,end_ip=-1;
	int incr=0,ret=-1;
	int local_incr=0;
	int flag1=-1;
	int arrlen_offset=-100;
	int oldlens_offset=-1;
	int oldastore_ip=0,oldnarr_ip=0,oldlen_ip=0;
	de.fub.bytecode.classfile.CodeException [] coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
	de.fub.bytecode.classfile.CodeException [] coecopy
			= new de.fub.bytecode.classfile.CodeException[coe.length];
	  for (int coeindex=0;coeindex < coe.length;coeindex++)
	  {
		coecopy[coeindex]= coe[coeindex].copy();
	  }

    	if(flag==1)
	{
	  de.fub.bytecode.generic.ConstantPoolGen cpg1 = cg1.getConstantPool();  /*/**/
	  String classname1 = cg1.getClassName();
	  de.fub.bytecode.generic.MethodGen local_mg =
		new de.fub.bytecode.generic.MethodGen(cg1.getMethods()[cur_mtd],classname1,cpg1);
	  de.fub.bytecode.generic.InstructionList local_il= local_mg.getInstructionList();
	  de.fub.bytecode.generic.Instruction[] local_in=local_il.getInstructions();
	  int [] local_pos =local_il.getInstructionPositions();

    	  for(int k=0;k<local_in.length;k++)
  	  {
	         de.fub.bytecode.generic.NEWARRAY newarray=null;
		 if((local_in[k] instanceof de.fub.bytecode.generic.NEWARRAY) && (local_in[k+1] instanceof de.fub.bytecode.generic.DUP))
		 {
			for(int x=k+1;x<local_in.length;x++)
			{
				de.fub.bytecode.generic.ASTORE astore=null;

				if((local_in[x]instanceof de.fub.bytecode.generic.ASTORE)
				&& ( ((de.fub.bytecode.generic.ASTORE)local_in[x]).getIndex()!=lvindex) )
				{
					break;
				}
				else if ((local_in[x]instanceof de.fub.bytecode.generic.ASTORE)
				&& ( ((de.fub.bytecode.generic.ASTORE)local_in[x]).getIndex()==lvindex) )
				{
					start_bc=local_pos[k+1];   // dups
					start_ip=k+1;
					end_bc=local_pos[x];
					arrlen_offset=k-1;
					end_ip=x;
					flag1=1;
					break;
				}
				else
				continue;
		  	}
		 }
		 else
		 continue;

		 if(flag1==1)
		 	break;

           }
	   oldlens_offset=local_pos[arrlen_offset];
	   ret=addNewArrays(arrtype,end_ip,arrlen_offset,local_il,local_pos,cpg1);
	  local_il.setPositions();
	  adjustExceptions(coe,coecopy,oldlens_offset,ret,ret);
	  local_mg.setInstructionList(local_il);
	  local_mg.setMaxLocals(no_of_locals);
	  local_mg.setMaxStack();
	  local_mg.stripAttributes(true);
	  cg1.replaceMethod(cg1.getMethods()[cur_mtd],local_mg.getMethod());
	  cg1.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
	  cg1.setConstantPool(cpg1);   /*/**/

	}
	else
	{
	  de.fub.bytecode.generic.ConstantPoolGen cpg1 = cg1.getConstantPool();  /*/**/
	  String classname1 = cg1.getClassName();
	  de.fub.bytecode.generic.MethodGen local_mg =
		new de.fub.bytecode.generic.MethodGen(cg1.getMethods()[cur_mtd],classname1,cpg1);
	  de.fub.bytecode.generic.InstructionList local_il= local_mg.getInstructionList();
	  de.fub.bytecode.generic.Instruction[] local_in=local_il.getInstructions();
	  int [] local_pos =local_il.getInstructionPositions();

	  for(int k=0;k<local_in.length;k++)
  	  {
	     de.fub.bytecode.generic.NEWARRAY newarray=null;
		 if((local_in[k] instanceof de.fub.bytecode.generic.NEWARRAY) && (local_in[k+1] instanceof de.fub.bytecode.generic.ASTORE)
		     && ((de.fub.bytecode.generic.ASTORE)local_in[k+1]).getIndex()==lvindex)
		     {
		      arrlen_offset=k-1;
 		      oldlens_offset=local_pos[arrlen_offset];
		      ret=addDynaNewArr(arrtype,k+1,k-1,k,local_il,local_pos,cpg1);
		     }
          }
	  local_il.setPositions();
	  adjustExceptions(coe,coecopy,oldlens_offset,ret,ret);
	  local_mg.setInstructionList(local_il);
	  local_mg.setMaxLocals(no_of_locals);
	  local_mg.setMaxStack();
	  local_mg.stripAttributes(true);
	  cg1.replaceMethod(cg1.getMethods()[cur_mtd],local_mg.getMethod());
	  cg1.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
	  cg1.setConstantPool(cpg1);   /*/**/

	}

	de.fub.bytecode.classfile.Method[] localm= cg1.getMethods();
	String classname1 = cg1.getClassName();
	de.fub.bytecode.generic.ConstantPoolGen  cpg1=cg1.getConstantPool();
    	de.fub.bytecode.generic.MethodGen local_mg =
		new de.fub.bytecode.generic.MethodGen(localm[cur_mtd],classname1,cpg1);

	

	de.fub.bytecode.generic.InstructionList local_il= local_mg.getInstructionList();
    	de.fub.bytecode.generic.Instruction[] local_in=local_il.getInstructions();
    	int[] local_pos=local_il.getInstructionPositions();
	coe =cg1.getMethods()[cur_mtd].getCode().getExceptionTable();
	  for (int coeindex=0;coeindex < coe.length;coeindex++)
	  {
		coecopy[coeindex]= coe[coeindex].copy();
	  }
	flag1=-1;


    	if(flag==1)
	{
	  int locallen=0;
	  for(int k=0;k<local_in.length;k++)
  	  {
	         de.fub.bytecode.generic.NEWARRAY newarray=null;
		 if((local_in[k] instanceof de.fub.bytecode.generic.NEWARRAY) && (local_in[k+1] instanceof de.fub.bytecode.generic.DUP))
		 {
			for(int x=k+1;x<local_in.length;x++)
			{
				de.fub.bytecode.generic.ASTORE astore=null;

				if((local_in[x]instanceof de.fub.bytecode.generic.ASTORE)
				&& ( ((de.fub.bytecode.generic.ASTORE)local_in[x]).getIndex()!=lvindex) )
				{
					break;
				}
				else if ((local_in[x]instanceof de.fub.bytecode.generic.ASTORE)
				&& ( ((de.fub.bytecode.generic.ASTORE)local_in[x]).getIndex()==lvindex) )
				{

		      			oldlen_ip=local_pos[k-1];
					start_bc=local_pos[k+1];   // dups
					start_ip=k+1;
					end_bc=local_pos[x];
					end_ip=x;
					flag1=1;
					break;
				}
				else
				continue;
		  	}
		 }
		 else
		 continue;

		 if(flag1==1)
		 	break;

           }

	   //int inc=addNewArrays(arrtype,end_ip);
	   	boolean firstarray=true;
	   for(int i=start_ip;i<=end_ip;i++)
	   {
	   
		int arrayindex;
		int xastore_ip=-1,xastore_bc=-1;
		if(local_in[i] instanceof de.fub.bytecode.generic.DUP)
		{
		   arrayindex= getLength(i+2,local_in);

		   for(int j=i+1;j<=end_ip;j++)
		   {
			if(!(local_in[j] instanceof de.fub.bytecode.generic.IASTORE))
			continue;

			xastore_bc=local_pos[j];
			xastore_ip=j;
			break;
		   }
		   //delete dup and arrindex
		   try{

			local_il.setPositions();

		
			int len= local_il.findHandle(local_pos[i]+incr).getInstruction().getLength();
			local_il.delete(local_il.findHandle(local_pos[i]+incr));
			incr-=len;
			local_il.setPositions();

			
			local_il.setPositions();

			
			len= local_il.findHandle(local_pos[i+1]+incr).getInstruction().getLength();
			local_il.delete(local_il.findHandle(local_pos[i+1]+incr));
			local_il.setPositions();
			incr-=len;

			
		      }catch(Exception e)
		      {e.printStackTrace();}


		   if(firstarray==true)
		   {
		       firstarray=false;
			local_il.setPositions();
			System.out.println(" GOING TO INsert aload before: " +local_il.findHandle(local_pos[i+2]+incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[i+2]+incr),new de.fub.bytecode.generic.ALOAD(arr1_lvindex) );
			incr+= ( new de.fub.bytecode.generic.ALOAD(arr1_lvindex)).getLength();
			local_il.setPositions();

			System.out.println(" GOING TO INsert iconst before: " +local_il.findHandle(local_pos[i+2]+incr).getInstruction().toString());
			local_il.insert(local_il.findHandle(local_pos[i+2]+incr),new de.fub.bytecode.generic.ICONST(arrayindex/2) );
			incr+= ( new de.fub.bytecode.generic.ICONST(arrayindex/2)).getLength();
			local_il.setPositions();

		   }
		   else
		   {
			local_il.setPositions();
			
			local_il.insert(local_il.findHandle(local_pos[i+2]+incr),new de.fub.bytecode.generic.ALOAD(arr2_lvindex) );
			incr+= ( new de.fub.bytecode.generic.ALOAD(arr2_lvindex)).getLength();

			local_il.setPositions();
			
			local_il.insert(local_il.findHandle(local_pos[i+2]+incr),new de.fub.bytecode.generic.ICONST(arrayindex/2) );
			incr+= ( new de.fub.bytecode.generic.ICONST(arrayindex/2)).getLength();

			local_il.setPositions();

			firstarray=true;
		   }
		}   // if (dup)
	   }    //for

	            try{
			
			int len= local_il.findHandle(local_pos[end_ip]+incr).getInstruction().getLength();
			locallen=len;
			local_il.delete(local_il.findHandle(local_pos[end_ip]+incr));
 			local_il.setPositions();
			incr-=len;

		      }catch(Exception e)
		      {
		      	incr-=locallen;
			
		      }

		    try{

			
			int len= local_il.findHandle(local_pos[start_ip-1]).getInstruction().getLength();
			locallen=len;
			local_il.delete(local_il.findHandle(local_pos[start_ip-1]));
			local_il.setPositions();
			incr-=len;
			}catch(Exception e)
		      {
			incr-=locallen;

			
		      }

	            try{

			
			int len= local_il.findHandle(local_pos[start_ip-2]).getInstruction().getLength();
			locallen=len;
			local_il.delete(local_il.findHandle(local_pos[start_ip-2]));
			local_il.setPositions();
			incr-=len;
		      }catch(Exception e)
		      {
		      	incr-=locallen;
			
		      }

	   

	     de.fub.bytecode.generic.InstructionHandle[] tt2 = local_il.getInstructionHandles();
	     for(int z=0;z<tt2.length;z++)
		  {
			System.out.println(tt2[z].toString());
		  }
          

	   adjustExceptions(coe,coecopy,oldlen_ip,incr,incr);
	}else
	{


	  for(int k=0;k<local_in.length;k++)
  	  {

	     int del_len=0;
	     de.fub.bytecode.generic.NEWARRAY newarray=null;
		 if((local_in[k] instanceof de.fub.bytecode.generic.NEWARRAY) && (local_in[k+1] instanceof de.fub.bytecode.generic.ASTORE)
		     && ((de.fub.bytecode.generic.ASTORE)local_in[k+1]).getIndex()==lvindex)
		 {
		      oldastore_ip=local_pos[k+1];
	              oldnarr_ip=local_pos[k];
		      oldlen_ip=local_pos[k-1];
		     

	           int locallen=0;
		   try{
			local_il.setPositions();
			
			int len= local_il.findHandle(local_pos[k+1]).getInstruction().getLength();
			locallen=len;
			del_len-=len;
			local_il.delete(local_il.findHandle(local_pos[k+1]));
			incr-=len;

		      }catch(Exception e)
		      {
		 	incr-=locallen;
		      	
		      }


        	   try{
			local_il.setPositions();
			
			int len= local_il.findHandle(local_pos[k]).getInstruction().getLength();
			locallen=len;
			del_len-=len;
			local_il.delete(local_il.findHandle(local_pos[k]));
			incr-=len;
		      }catch(Exception e)
		      {
		        incr-=locallen;
		      }

		  adjustExceptions(coe,coecopy,oldlen_ip,del_len,del_len);
	   	  break;
	    	} // if
     	   } // for

	} // else

		   local_il.setPositions();
		   local_mg.setInstructionList(local_il);
		   local_mg.setMaxLocals(no_of_locals);
		   local_mg.setMaxStack();
		   local_mg.stripAttributes(true);

		   cg1.replaceMethod(cg1.getMethods()[cur_mtd],local_mg.getMethod());
		   cg1.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
		   cg1.setConstantPool(cpg1);

    }

    /**
      * The main function that coordinates the calls to all other functinos which actually do the algorithm
      */
    public void arr_creat_split()
    {
	de.fub.bytecode.generic.Instruction[] local_in =null;
	de.fub.bytecode.generic.InstructionList local_il=null;

	int pos[],astart_bc=-1,aend_bc=-1,astart_ip=-1,aend_ip=-1;
	de.fub.bytecode.generic.ConstantPoolGen  cpg1=cg1.getConstantPool();
	String classname1 = cg1.getClassName();

    	for(int i=0;i<methods1.length;i++)
	{
		mg1= new de.fub.bytecode.generic.MethodGen(methods1[i],classname1,cpg1);
		if(mg1.getName().equals("<init>") || mg1.getName().equals("<clinit>"))
			continue;
		
		System.out.println(" Finding arrays and Applying array splitting for " + mg1.getName());
		cur_mtd=i;
		no_of_locals = mg1.getMaxLocals();
		local_il = mg1.getInstructionList();
		pos = local_il.getInstructionPositions();

		local_in = local_il.getInstructions();

		for(int k=0;k<local_in.length;k++)
		{
		         de.fub.bytecode.generic.NEWARRAY newarray=null;
			 if(!(local_in[k] instanceof de.fub.bytecode.generic.NEWARRAY))
				continue;

			  len_of_array=arraycount=increase=0;

			  newarray= (de.fub.bytecode.generic.NEWARRAY)local_in[k];
			  arraytype=newarray.getTypecode();

			  astart_bc=pos[k];
			  astart_ip=k;

			  for(int x=k+1;x<local_in.length;x++)
			  {
			  	de.fub.bytecode.generic.ASTORE astore=null;
				if(!(local_in[x]instanceof de.fub.bytecode.generic.ASTORE))
					continue;

				astore =(de.fub.bytecode.generic.ASTORE)local_in[x];
				lvindex= astore.getIndex();

				aend_bc=pos[x];
				aend_ip=x;

				
				break;
			  }

			  if(local_in[k+1] instanceof de.fub.bytecode.generic.DUP)
			  {
			  	boolean res=testifok(local_in,pos,local_il,cpg1,mg1);
		          
				if(res==true)
			  	{
					len_of_array=getLength(k,local_in);
					if(len_of_array==-1)
			  		{
			   			System.out.println(" Cannot apply array splitting for this array ");
						break;
			  		}
					int dupstart_ip=k+1;
			  		split(dupstart_ip,aend_ip,1,arraytype);
					adjustArrWrites();
					adjustArrReads();
					adjustArrLengths();
				}
			  }
			  else if(local_in[k+1] instanceof de.fub.bytecode.generic.ASTORE)
			  {
			  	boolean res=testifok(local_in,pos,local_il,cpg1,mg1);
				
				if(res==true)
			  	{
					split(0,k+1,0,arraytype);
					adjustArrWrites();
					adjustArrReads();
					adjustArrLengths();
			  	}
			  }

			break;
		}

		
	}

    }

    /** The future work will include the integration of Array Merging with Array Splitting.
     * The reason I am saying this is that this function won't be needed then ..
     * @param local_in Instruction Array
     * @param local_il Instruction List Array (editing purposes)
     * @param local_pos Instruction Position Array
     * @param cpg1 ConstantPoolGen
     * @param local_mg MethodGen
    */
    public boolean testifok(de.fub.bytecode.generic.Instruction [] local_in,
    			int [] local_pos,
			de.fub.bytecode.generic.InstructionList local_il,
			de.fub.bytecode.generic.ConstantPoolGen cpg1,
    					de.fub.bytecode.generic.MethodGen local_mg)
    { 
    	boolean b=true;
	utils.stacksimulator.StackSimulator ss =
	    new utils.stacksimulator.StackSimulator(local_mg,cpg1);
	
    	for(int i=0;i<local_in.length;i++)
	{
		
		if(local_in[i] instanceof de.fub.bytecode.generic.INVOKESTATIC 	)
		{
		 de.fub.bytecode.generic.InvokeInstruction is=(de.fub.bytecode.generic.InvokeInstruction)local_in[i];
		 de.fub.bytecode.generic.Type[] argtypes =is.getArgumentTypes(cpg1);
		 int no_of_args=argtypes.length;
		 de.fub.bytecode.generic.InstructionHandle ih=local_il.findHandle(local_pos[i]);
		 b= arr.chekifarrayinstaticmtd(ih,lvindex,no_of_args,ss);
		 if(b==false)
		 	return false;
		 else if(b==true && i!=(local_in.length-1))
		 	continue;
		 else if(b==true && i==(local_in.length-1))
		 	return true;
		}
		else if (local_in[i] instanceof de.fub.bytecode.generic.INVOKEVIRTUAL)
		{
		 de.fub.bytecode.generic.InvokeInstruction is=(de.fub.bytecode.generic.InvokeInstruction)local_in[i];
		 de.fub.bytecode.generic.Type[] argtypes =is.getArgumentTypes(cpg1);
		 int no_of_args=argtypes.length;
		 de.fub.bytecode.generic.InstructionHandle ih=local_il.findHandle(local_pos[i]);
		 b= arr.chekifarrayinobjectsmtd(ih,lvindex,no_of_args,ss);
		 if(b==false)
		 	return false;
		 else if(b==true && i!=(local_in.length-1))
		 	continue;
		 else if(b==true && i==(local_in.length-1))
		 	return true;
		}
		else if (local_in[i] instanceof de.fub.bytecode.generic.ARETURN)
		{
		 de.fub.bytecode.generic.ReturnInstruction is=(de.fub.bytecode.generic.ReturnInstruction)local_in[i];
		 de.fub.bytecode.generic.InstructionHandle ih=local_il.findHandle(local_pos[i]);
		 b= arr.chekifarrayinreturn(ih,lvindex,ss);
		 if(b==false)
		 	return false;
		 else if(b==true && i!=(local_in.length-1))
		 	continue;
		 else if(b==true && i==(local_in.length-1))
		 	return true;
		}



	}
	return b;
    }

   
    /**
	 * Calls the other methods to obfuscate the class file
	 * @param	cfc
	 */

	 public boolean apply(String classname) throws Exception
	 {
	    boolean sucess = false;
	    classname = classname.replaceAll("examples.","");
		System.out.println("classname..." + classname);
		
		de.fub.bytecode.classfile.JavaClass jClass = null;
		jClass = getClass(classname);
		addClass(jClass);
  	    
		int canproceed = aggregate(classname);
		if(canproceed != -1){ 
			arr_creat_split();
			dump();
			sucess = true;
	  	}
	  	return sucess;
     }

   public de.fub.bytecode.classfile.JavaClass getClass(String classname) throws java.io.IOException {
   	        java.io.File f = new java.io.File("C:/JHide/examples/" + classname + ".class");
   			//java.io.File f = new java.io.File("C:/JHide/examples/TestDataAggregation.class");
   		    de.fub.bytecode.classfile.ClassParser p = new de.fub.bytecode.classfile.ClassParser(f.getPath());
   		    return p.parse();
   	}
   	public static void convertToHTML(de.fub.bytecode.classfile.JavaClass clazz,String type)   throws java.io.IOException {
   	   	    de.fub.bytecode.util.Class2HTML conObj = new de.fub.bytecode.util.Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
   	}

   	/**
   	 *  Adds or replaces a class in this collection, given a JavaClass.
   	 */
   	public void addClass(de.fub.bytecode.classfile.JavaClass c) throws java.io.IOException {
   			c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
	}

    /**
     * Dump the changes back to the jar file
     * @param	cfc
     */
    private void dump()
    {
	try
	{
	   addClass(cg1.getJavaClass());
	   convertToHTML(cg1.getJavaClass(),"Obf");
	}
	catch(java.io.IOException ioe) {
	    ioe.printStackTrace();
	}
    }

    

    /* This function is called whenever code is added inside in a try-catch block. Modifies the
     * startPC,endPC and handlerPC of the exception table to reflect the changes to the code.
     *
     * @param coe ExceptionTable Object
     * @param coecopy A deep copy of the exception table of the unmodified code.
     * @param cur_pos Position of the bytecode instruction that is modified in the unmodifed code.
     * @param count Number of new instructions added to the method in place of the current instruction.
     * @param addcount A cumulative count of the instructions added to the method.
     */
    private void adjustExceptions(de.fub.bytecode.classfile.CodeException []coe,de.fub.bytecode.classfile.CodeException []coecopy,int cur_pos,int count,int addcount)
    {
	int epc;
	int spc;
	int hpc;

	for (int i=0;i<coe.length;i++)
	{
	    epc=coecopy[i].getEndPC();
	    spc = coecopy[i].getStartPC();
	    hpc = coecopy[i].getHandlerPC();

	    if (cur_pos >= spc && cur_pos <= epc)
	    {

		coe[i].setEndPC(epc+addcount);
		coe[i].setHandlerPC(hpc+addcount);

	    }
	    else if (cur_pos <= epc) {

		    coe[i].setStartPC(spc+addcount);
		    coe[i].setEndPC(epc+addcount);
		    coe[i].setHandlerPC(hpc+addcount);
		}

	    else
	    {
		for (int j=i+1;j<coe.length;j++)
		{
		    int epc1=coecopy[j].getEndPC();
		    int spc1 = coecopy[j].getStartPC();
		    int hpc1 = coecopy[j].getHandlerPC();
		    if ( spc1 == spc && epc1 == epc && cur_pos <= hpc1)
		    {
			coe[j].setHandlerPC(hpc1+addcount);
		    }

		}
	    }

	}
	System.out.println( " EXCEPTION TABLE:");
	for (int i=0;i<coe.length;i++)
	{
	System.out.println(coe[i].getStartPC() +"  "+ coe[i].getEndPC()+"  "+coe[i].getHandlerPC());
	}
    }

}









