package algorithms;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.bcel.classfile.*;
import org.apache.bcel.Repository;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: DataStorage
@ Author: Suma Venkatesh
@ Description:   This algorithm is one kind of Data transformation, which affects how data is stored in the memory.
*/


public class DataStorage {

    public boolean apply(String classname)  throws Exception {
		boolean sucess = false;

		//load class file
		EDU.purdue.cs.bloat.file.ClassFileLoader cfl = new EDU.purdue.cs.bloat.file.ClassFileLoader();  // BLOAT loader
		EDU.purdue.cs.bloat.file.ClassFileLoader classFileLoader = new EDU.purdue.cs.bloat.file.ClassFileLoader();
		EDU.purdue.cs.bloat.reflect.ClassInfo info = null;
		EDU.purdue.cs.bloat.file.ClassFile classFile = (EDU.purdue.cs.bloat.file.ClassFile) cfl.loadClass("examples/"+ classname);
		info = cfl.loadClass("examples/"+classname);
		String tmpclassName = "C:/JHide/examples/"  + classname + "_tmp.class";
		copy("C:/JHide/examples/" + classname + ".class",tmpclassName);
		

        //generate Fields of the chosen JavaClass
        EDU.purdue.cs.bloat.file.Field[] fields =  (EDU.purdue.cs.bloat.file.Field[])classFile.fields();

        //for each of the fields modify their modifiers using bloat reflect.
        for(int i = 0; i < fields.length; i++) {
            System.out.println("Found a Victim Field in " + classname +" to set as public ");
            int modifiers = fields[i].modifiers();
            int notPrivateMask = ~EDU.purdue.cs.bloat.reflect.Modifiers.PRIVATE;
            modifiers &= notPrivateMask;
            int notProtectedMask = ~EDU.purdue.cs.bloat.reflect.Modifiers.PROTECTED;
            modifiers &= notProtectedMask;
            modifiers |= EDU.purdue.cs.bloat.reflect.Modifiers.PUBLIC;
            fields[i].setModifiers(modifiers);
        }

		//commit the changess
        classFile.commit();
        
        File orgFile =	new File("C:/JHide/examples/" + classname+".class");
		File tmpFile =	new File("C:/JHide/examples/" + tmpclassName);
		File obfFile =	new File("C:/JHide/examples/" + classname+"_obf" + ".class");
		orgFile.renameTo(obfFile);
		tmpFile.renameTo(orgFile);
		String obfclassName = obfFile.getName();
		obfclassName = obfclassName.replaceAll(".class","");

		JavaClass clazz = Repository.lookupClass("examples/" + obfclassName);
		clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) +"_obf" +  ".class"));
		obfFile.delete();
   
		convertToHTML(clazz,"Obf");
		
		copy(tmpclassName,"C:/JHide/examples/" + classname + ".class");	
		
		sucess = true;
		return(sucess);

    }
    
    public static void copy(String inFile, String outFile)
    throws IOException {

     FileInputStream fin = null;
     FileOutputStream fout = null;

     try {
       fin  = new FileInputStream(inFile);
       fout = new FileOutputStream(outFile);
       StreamCopier(fin, fout);
     }
     finally {
       try {
         if (fin != null) fin.close();
       }
       catch (IOException e) {System.out.println("Exception " +e );}
       try {
         if (fout != null) fout.close();
        }
       catch (IOException e) { System.out.println("Exception " +e ); }
     }

   }

   public static void StreamCopier(InputStream in, OutputStream out)
      throws IOException {

       synchronized (in) {
         synchronized (out) {

           byte[] buffer = new byte[256];
           while (true) {
             int bytesRead = in.read(buffer);
             if (bytesRead == -1) break;
             out.write(buffer, 0, bytesRead);
           }
         }
       }
   }
   
    public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
	   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
   }

}