package algorithms;
import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import java.io.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: FormatRemoval
@ Author: Suma Venkatesh
@ Description:   This algorithm removes source code formatting like tabulation and carriage returns.
*/
public class FormatRemoval {
	static FileInputStream fin;
	static BufferedReader din;
	static FileOutputStream fout;

    public boolean apply(String classname) {
		boolean sucess = false;
		ClassGen cgen = null;
	     try {

            //lookup for the input class and generate a classgen on it
	    	JavaClass clazz = Repository.lookupClass("examples/" + classname);
	    	cgen = new ClassGen(clazz);

			fin = new FileInputStream("C:/JHide/examples/" + classname +".java");
           	din = new BufferedReader(new InputStreamReader(fin));

			String  outName = "C:/JHide/Obfuscated_Classes/"+ classname+"_obf.txt";
			File writeFileObj = new File(outName);
			fout = new FileOutputStream(writeFileObj);
            String temp =null;

			//for each input line read remove spaces and carriage returns
			while ((temp = din.readLine()) != null) {
				temp =temp.trim();
				fout.write(temp.getBytes());
		    }

			String temp1 = null;
			String type1 = null;
			String type2 = null;
			while ((temp1 = din.readLine()) != null) {
					temp1= temp1.trim();
					int index1 = temp1.indexOf(';');
					int flag = 0;
					int index2 = 0;
					if (index1 == -1) {
					   fout.write(temp1.getBytes());
					}
					while ((index1 != -1) && (index2 != -1))  {
					  if (flag == 0) {
						type1 = temp1.substring(0,index1+1);
						fout.write(type1.getBytes());
						flag = 1;
					  }
					  index2 = temp1.indexOf(' ',index1 + 1);
					  if (index2 != -1) {
						type2 = temp1.substring(index1+1,index2);
						fout.write(type2.getBytes());
					  }
					  else {
						type2 = temp1.substring(index1+1,temp1.length());
						fout.write(type2.getBytes());
					  }
				   	  index1=index2;
					}
			}

			//dump the obfuscated code in obfuscated"_classes dir
			clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) + "_obf"+ ".class"));

			//convert the class to byte code instruction set and format them as HTML
			convertToHTML(clazz,"Obf");

			//set success flag
			sucess = true;


		 }
	     catch(Exception e) {System.out.println("Exception is " + e);}
		 return(sucess);
     }

      // this method converts the inout class to byte code instructions and dumps them as HTML file.
      public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
   		   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
      }


}