package algorithms;


import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import EDU.purdue.cs.bloat.file.ClassFileLoader;
import org.apache.bcel.util.Class2HTML;
import java.io.*;
import java.util.*;

/**
@ Class: InsertDeadCodeFields
@ Author: Suma Venkatesh
@ Description:   This algorithm is one kind of Smoke and Mirror technique which inserts irrelevant code (dead code).
  After obfuscation, the obfuscated code contains an extra field, which has no role in the program.
*/

public class InsertDeadCodeFields {

	public boolean apply(String classname) {
		ClassGen cgen = null;
		boolean sucess = false;
		try {
	    	
	    	String tmpclassName = "examples/" + classname + "_tmp.class";
			copy("examples/" + classname+".class",tmpclassName);
			appendDeadCodeFields("examples/" + classname);
			File orgFile =	new File("examples/" + classname+".class");
			File tmpFile =	new File(tmpclassName);
			File obfFile =	new File("examples/" + classname+"_obf" + ".class");
			orgFile.renameTo(obfFile);
			tmpFile.renameTo(orgFile);
			String obfclassName = obfFile.getName();
			obfclassName = obfclassName.replaceAll(".class","");
			JavaClass clazz = Repository.lookupClass("examples/" + obfclassName);
			clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) +"_obf"+ ".class"));
			obfFile.delete();
			convertToHTML(clazz,"Obf");
			sucess = true;
	     }
	     catch(Exception e) {System.out.println("Exception" +e);return(sucess);}
		return(sucess);
     }

    public static void copy(String inFile, String outFile)
      throws IOException {

       FileInputStream fin = null;
       FileOutputStream fout = null;

       try {
         fin  = new FileInputStream(inFile);
         fout = new FileOutputStream(outFile);
         StreamCopier(fin, fout);
       }
       finally {
         try {
           if (fin != null) fin.close();
         }
         catch (IOException e) {System.out.println("Exception " +e );}
         try {
           if (fout != null) fout.close();
          }
         catch (IOException e) { System.out.println("Exception " +e ); }
       }

     }

     public static void StreamCopier(InputStream in, OutputStream out)
        throws IOException {

         synchronized (in) {
           synchronized (out) {

             byte[] buffer = new byte[256];
             while (true) {
               int bytesRead = in.read(buffer);
               if (bytesRead == -1) break;
               out.write(buffer, 0, bytesRead);
             }
           }
         }
     }

    public static void appendDeadCodeFields(String className)throws Exception {

	    try {


	    String newFieldName;
	    ClassFileLoader cfl = new ClassFileLoader();  // BLOAT loader
	    Random rn = new Random();

		int i = rn.nextInt();
		java.util.GregorianCalendar gc =  new java.util.GregorianCalendar();
		java.util.Random generator = new java.util.Random(gc.getTime().getTime());
		EDU.purdue.cs.bloat.file.ClassFileLoader classFileLoader = new EDU.purdue.cs.bloat.file.ClassFileLoader();
		EDU.purdue.cs.bloat.reflect.ClassInfo info = null;

		newFieldName = "V" + i;

	    EDU.purdue.cs.bloat.file.ClassFile classFile = (EDU.purdue.cs.bloat.file.ClassFile) cfl.loadClass(className);

		info = cfl.loadClass(className);

		EDU.purdue.cs.bloat.context.PersistentBloatContext bloatContext = new EDU.purdue.cs.bloat.context.PersistentBloatContext(classFile.loader());

		EDU.purdue.cs.bloat.editor.ClassEditor classEditor =  new EDU.purdue.cs.bloat.editor.ClassEditor(bloatContext,info);

		if(!classEditor.isAbstract() || !classEditor.isInterface()){

		      EDU.purdue.cs.bloat.editor.ConstantPool constantPool = classEditor.constants();

		      EDU.purdue.cs.bloat.reflect.Constant[] constants = constantPool.constants();

		      EDU.purdue.cs.bloat.file.Field[] fields = (EDU.purdue.cs.bloat.file.Field [])info.fields();
		      if(fields.length > 0){

		      	//choose a random field
		      	int fieldIndex = Math.abs(generator.nextInt()) % fields.length;

		      	//get info about chosen field
		      	EDU.purdue.cs.bloat.editor.FieldEditor fieldEditor = new EDU.purdue.cs.bloat.editor.FieldEditor(classEditor, fields[fieldIndex]);

		      	//add a bogus field
		      	int modifiers = EDU.purdue.cs.bloat.reflect.Modifiers.STATIC;
		      	EDU.purdue.cs.bloat.editor.FieldEditor fieldEditor2 =  new EDU.purdue.cs.bloat.editor.FieldEditor(classEditor,modifiers, EDU.purdue.cs.bloat.editor.Type.INTEGER,newFieldName);
		      	EDU.purdue.cs.bloat.reflect.FieldInfo fieldInfo2 = fieldEditor2.fieldInfo();
		      	fieldEditor.commit();
		      	fieldEditor2.commit();
		      	classEditor.commit();
		      	classEditor = new EDU.purdue.cs.bloat.editor.ClassEditor(bloatContext,info);
		      	EDU.purdue.cs.bloat.file.Method[] methods =(EDU.purdue.cs.bloat.file.Method [])info.methods();
		      	EDU.purdue.cs.bloat.editor.MethodEditor methodEditor = null;

		      	//for each method scan the instruction list for the chosen field
		      	for(int j = 0; j < methods.length; j++){
		      	   methodEditor = new EDU.purdue.cs.bloat.editor.MethodEditor(
		           classEditor, methods[j]);
		      	   //get the code in the method
		      	   java.util.List codeList = methodEditor.code();

		      	   //create a list to store the modified instructions in
		      	   java.util.ArrayList newInstList = new java.util.ArrayList();

		      	   //now scan the codelist
		      	   java.util.Iterator codeIter = codeList.iterator();
		      	   while(codeIter.hasNext()){
		      	      java.lang.Object codeItem = codeIter.next();
		      	      if(codeItem instanceof EDU.purdue.cs.bloat.editor.Instruction){
		      	         EDU.purdue.cs.bloat.editor.Instruction codeInst = (EDU.purdue.cs.bloat.editor.Instruction)codeItem;
		      	         newInstList.add(codeItem);
		      	         int opcode = codeInst.opcodeClass();
		      	         if(opcode == EDU.purdue.cs.bloat.editor.Opcode.opcx_putfield){
		      	            EDU.purdue.cs.bloat.editor.Instruction newInst1 = new EDU.purdue.cs.bloat.editor.Instruction(opcode);
		      	            newInstList.add(newInst1);
		      	         }
		      	         int fieldValue = 2;
		      	         EDU.purdue.cs.bloat.editor.Instruction newInst2 = new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opcx_ldc,new java.lang.Integer(fieldValue));
		      	         newInstList.add(newInst2);
		      	      }else{
		      	         newInstList.add(codeItem);
		      	      }
		      	   }
		      	   methodEditor.setCode(codeList);
		      	   methodEditor.commit();

		        }//end-for
		      }//end-if


		  }//end-if


	  } catch(Exception e) {System.out.println("Exception" +e);  }

 }//end-appendbogusfields

 public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
    Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
 }

}