package algorithms;

import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import java.io.*;
import java.util.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: InsertDeadCodeLoops
@ Author: Suma Venkatesh
@ Description:   This algorithm is one kind of Smoke and Mirror technique which inserts irrelevant code (dead code)
  into loops that will never be executed.
*/

public class InsertDeadCodeLoops {

    java.util.ArrayList predicates[] = new ArrayList[3];
    java.util.ArrayList pred_list = new ArrayList();

	public boolean apply(JavaClass clazz,String classname) {

		ClassGen cgen = null;
		boolean sucess = false;

		try {
			cgen = new ClassGen(clazz);
			ConstantPoolGen cpg = cgen.getConstantPool();
			String tmpclassName = "C:/JHide/examples/"  + classname + "_tmp.class";
			copy("C:/JHide/examples/" + classname + ".class",tmpclassName);
			appendDeadCodeLoops(classname);
			File orgFile =	new File("C:/JHide/examples/" + classname+".class");
			File tmpFile =	new File("C:/JHide/examples/" + tmpclassName);
			File obfFile =	new File("C:/JHide/examples/" + classname+"_obf" + ".class");
			orgFile.renameTo(obfFile);
			tmpFile.renameTo(orgFile);
			String obfclassName = obfFile.getName();
			obfclassName = obfclassName.replaceAll(".class","");

			clazz = Repository.lookupClass("examples/" + obfclassName);
			clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) +"_obf" +  ".class"));
			obfFile.delete();
			convertToHTML(clazz,"Obf");
			copy(tmpclassName,"C:/JHide/examples/" + classname + ".class");	
			sucess = true;
		}
	    catch(Exception e) {e.printStackTrace(); System.out.println("Exception" +e.getMessage()); return(sucess);}
		return(sucess);
	}



	public void bogusPredicates() {

	    	/* A list of carefully chosen  predicates are maintained as a list */
			EDU.purdue.cs.bloat.editor.Instruction iadd=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_iadd);
			EDU.purdue.cs.bloat.editor.Instruction isub=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_isub);
			EDU.purdue.cs.bloat.editor.Instruction imul=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_imul);
			EDU.purdue.cs.bloat.editor.Instruction irem=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_irem);
			EDU.purdue.cs.bloat.editor.Instruction push0=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_ldc,new Integer(0));
			EDU.purdue.cs.bloat.editor.Instruction push2=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_ldc,new Integer(2));
			EDU.purdue.cs.bloat.editor.Instruction push3=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_ldc,new Integer(3));
			EDU.purdue.cs.bloat.editor.Instruction push1=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_ldc,new Integer(1));
			EDU.purdue.cs.bloat.editor.Instruction dup=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_dup);
			EDU.purdue.cs.bloat.editor.Instruction idiv=
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_idiv);
			predicates[0] = new ArrayList();
			predicates[0].add(dup);
			predicates[0].add(dup);
			predicates[0].add(dup);
			predicates[0].add(imul);
			predicates[0].add(imul);
			predicates[0].add(isub);
			predicates[0].add(push3);
			predicates[0].add(irem);
			pred_list.add(predicates[0]) ;
			predicates[1] = new ArrayList();
			predicates[1].add(dup);
			predicates[1].add(push1);
			predicates[1].add(iadd);
			predicates[1].add(imul);
			predicates[1].add(push2);
			predicates[1].add(irem);
			pred_list.add(predicates[1]);
			predicates[2] = new ArrayList();
			predicates[2].add(dup);
			predicates[2].add(imul);
			predicates[2].add(push2);
			predicates[2].add(idiv);
			predicates[2].add(push2);
			predicates[2].add(irem);
			pred_list.add(predicates[2]);
	}

	 public  void appendDeadCodeLoops(String className)throws Exception {

		try {

			bogusPredicates();
			// BLOAT loader
			EDU.purdue.cs.bloat.file.ClassFileLoader cfl = new EDU.purdue.cs.bloat.file.ClassFileLoader();
			EDU.purdue.cs.bloat.file.ClassFileLoader classFileLoader = new EDU.purdue.cs.bloat.file.ClassFileLoader();
			EDU.purdue.cs.bloat.reflect.ClassInfo info = null;
			EDU.purdue.cs.bloat.file.ClassFile classFile = (EDU.purdue.cs.bloat.file.ClassFile) cfl.loadClass("examples/"+ className);
			info = cfl.loadClass("examples/"+className);

			System.out.println("After appendDeadCodeLoops");

			EDU.purdue.cs.bloat.file.Method[] methods  =(EDU.purdue.cs.bloat.file.Method [])info.methods();
			EDU.purdue.cs.bloat.context.PersistentBloatContext bloatContext = new EDU.purdue.cs.bloat.context.PersistentBloatContext(classFile.loader());
			EDU.purdue.cs.bloat.editor.ClassEditor classEditor = new  EDU.purdue.cs.bloat.editor.ClassEditor(bloatContext,info);
			EDU.purdue.cs.bloat.inline.Inline inline = new EDU.purdue.cs.bloat.inline.Inline( bloatContext,20);
			EDU.purdue.cs.bloat.reflect.MethodInfo[] methodInfo =classEditor.methods();
			EDU.purdue.cs.bloat.editor.MethodEditor me = bloatContext.editMethod(methodInfo[0]);
			inline.inline(me);
			System.out.println(" Inlining Complete for Method :: " + methods[0].toString());

			//begin adding predicates
			EDU.purdue.cs.bloat.editor.Instruction push2= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_ldc,new Integer(2));
			EDU.purdue.cs.bloat.editor.Instruction push1= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_ldc,new Integer(1));
			EDU.purdue.cs.bloat.editor.Instruction iadd= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_iadd);
			EDU.purdue.cs.bloat.editor.Instruction imul= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_imul);
			EDU.purdue.cs.bloat.editor.Instruction irem= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_irem);
			EDU.purdue.cs.bloat.editor.Instruction push0= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_ldc,new Integer(0));
			java.util.Random rand = new java.util.Random();
			for (int k=0; k < methods.length; k++) {
				int nameIndex = methods[k].nameIndex();
				EDU.purdue.cs.bloat.editor.MethodEditor methodEditor = new  EDU.purdue.cs.bloat.editor.MethodEditor(classEditor,methods[k]);
				String temp = new String(methodEditor.name());
				int index=0;
				EDU.purdue.cs.bloat.editor.LocalVariable L1 = methodEditor.newLocal(EDU.purdue.cs.bloat.editor.Type.INTEGER);
				EDU.purdue.cs.bloat.editor.LocalVariable L2 = methodEditor.newLocal(EDU.purdue.cs.bloat.editor.Type.INTEGER);
				EDU.purdue.cs.bloat.editor.Instruction istore1=new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Instruction.opcx_istore,L1);
				EDU.purdue.cs.bloat.editor.Instruction istore2=new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Instruction.opcx_istore,L2);
				EDU.purdue.cs.bloat.editor.Instruction loadx= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_iload,L1);
				EDU.purdue.cs.bloat.editor.Instruction loady= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_iload,L2);
				EDU.purdue.cs.bloat.editor.Instruction pushx= new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_iload,L1);
				List il = methodEditor.code();
				int i = 0;
				methodEditor.insertCodeAt(
				new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Instruction.opc_ldc,new Integer(rand.nextInt(100))),1);
				methodEditor.insertCodeAt(istore1,2 );
				java.util.Random rand1 = new java.util.Random();
				while(i<il.size()) {
				  try {
					  EDU.purdue.cs.bloat.editor.Instruction instr = (EDU.purdue.cs.bloat.editor.Instruction)il.get(i);
					  if ( instr.isConditionalJump()) {
						  System.out.println("Inserting Code into cond expr ");
						  index = i+1;
						  EDU.purdue.cs.bloat.editor.Label target = (EDU.purdue.cs.bloat.editor.Label)instr.operand();
						  EDU.purdue.cs.bloat.editor.Instruction icmp = new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_if_icmpne,target);
						  int pred_num = rand1.nextInt(3);
						  methodEditor.insertCodeAt(loadx,index++);
						  ArrayList al = (java.util.ArrayList)pred_list.get(pred_num);
						  int j;
						  for (j =0;j< al.size();j++)  {
								methodEditor.insertCodeAt((EDU.purdue.cs.bloat.editor.Instruction)al.get(j),index++);
						  }
						  methodEditor.insertCodeAt(push0,index++);
						  methodEditor.insertCodeAt(icmp,index++);
						  i=i+j+3;

					  }
				   }catch(Exception e) {}
				   i++;
			   } // end of while

			   methodEditor.commit();

			   methodEditor.code();

			 }// end of for
			 bloatContext.commit();
			 classFile.commit();

			File outputFile = new File("C:/JHide/Obfuscated_Classes/"+ className+"_obf.txt");
			FileWriter out = new FileWriter(outputFile);
			for (int k=0; k < methods.length; k++) {
				out.write(methods[k].code().toString());

			}
			out.close();
		 } catch(Exception e) { e.printStackTrace(); System.out.println("Exception" +e.getMessage()); }


	 }//end-appendboguspredicates
	 
	 public static void copy(String inFile, String outFile)
     throws IOException {

      FileInputStream fin = null;
      FileOutputStream fout = null;

      try {
        fin  = new FileInputStream(inFile);
        fout = new FileOutputStream(outFile);
        StreamCopier(fin, fout);
      }
      finally {
        try {
          if (fin != null) fin.close();
        }
        catch (IOException e) {System.out.println("Exception " +e );}
        try {
          if (fout != null) fout.close();
         }
        catch (IOException e) { System.out.println("Exception " +e ); }
      }

    }

    public static void StreamCopier(InputStream in, OutputStream out)
       throws IOException {

        synchronized (in) {
          synchronized (out) {

            byte[] buffer = new byte[256];
            while (true) {
              int bytesRead = in.read(buffer);
              if (bytesRead == -1) break;
              out.write(buffer, 0, bytesRead);
            }
          }
        }
    }

   	public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
		Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
   }
}