package algorithms;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import org.apache.bcel.Repository;
import org.apache.bcel.util.Class2HTML;


/**
@ Class: InsertDeadCodeMethodArguments
@ Author: Suma Venkatesh
@ Description:   This algorithm is one kind of Smoke and Mirror technique which inserts irrelevant code (dead code)
  into method signatures that will never be executed.
*/


public class InsertDeadCodeMethodArguments {

        //	List of possible types to add to formal parameter lists
		private static EDU.purdue.cs.bloat.editor.Type[] sParamTypes=null;
		private static int MAX_ADDED_ARGS=4;
		private static java.util.Random sRnd=new java.util.Random();
		private EDU.purdue.cs.bloat.editor.EditorContext mCx = null;

	public boolean apply(String classname) {

		ClassGen cgen = null;
		boolean sucess = false;
	    try {
		    JavaClass clazz = Repository.lookupClass("examples/" + classname);
		    cgen = new ClassGen(clazz);
		    String tmpclassName = "C:/JHide/examples/"  + classname + "_tmp.class";
			copy("C:/JHide/examples/" + classname + ".class",tmpclassName);
			
			InsertDeadCodeMethodArguments adder=new InsertDeadCodeMethodArguments();
			adder.init(classname);
			
			File orgFile =	new File("C:/JHide/examples/" + classname+".class");
			File tmpFile =	new File("C:/JHide/examples/" + tmpclassName);
			File obfFile =	new File("C:/JHide/examples/" + classname+"_obf" + ".class");
			orgFile.renameTo(obfFile);
			tmpFile.renameTo(orgFile);
			String obfclassName = obfFile.getName();
			obfclassName = obfclassName.replaceAll(".class","");

			clazz = Repository.lookupClass("examples/" + obfclassName);
			clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) +"_obf" +  ".class"));
			obfFile.delete();
			convertToHTML(clazz,"Obf");
			copy(tmpclassName,"C:/JHide/examples/" + classname + ".class");	
			sucess = true;
	     }
	     catch(Exception e) {System.out.println("Exception " +e ); return(sucess);}
		return(sucess);
     }

     public void init(String className ) {

     try{
		EDU.purdue.cs.bloat.file.ClassFileLoader cfl = new EDU.purdue.cs.bloat.file.ClassFileLoader();  // BLOAT loader
		EDU.purdue.cs.bloat.file.ClassFileLoader classFileLoader = new EDU.purdue.cs.bloat.file.ClassFileLoader();
		EDU.purdue.cs.bloat.file.ClassFile classFile = (EDU.purdue.cs.bloat.file.ClassFile) cfl.loadClass("examples/" + className);
		EDU.purdue.cs.bloat.reflect.ClassInfo info = (EDU.purdue.cs.bloat.reflect.ClassInfo)classFile;
     	mCx =  new EDU.purdue.cs.bloat.context.PersistentBloatContext(classFile.loader());
		java.util.Hashtable methodHash = new java.util.Hashtable();
        SignatureValidator validator =  new SignatureValidator(mCx);
     	EDU.purdue.cs.bloat.file.Method[] methods = (EDU.purdue.cs.bloat.file.Method[])info.methods();
		EDU.purdue.cs.bloat.editor.ClassEditor ce =  new EDU.purdue.cs.bloat.editor.ClassEditor(mCx,info);
		for(int i=0;i<methods.length;i++) {
			   EDU.purdue.cs.bloat.file.Method thisMethod = methods[i];
			   EDU.purdue.cs.bloat.reflect.MethodInfo mi = (EDU.purdue.cs.bloat.reflect.MethodInfo)thisMethod;
			   EDU.purdue.cs.bloat.editor.MethodEditor me = new EDU.purdue.cs.bloat.editor.MethodEditor(ce,mi);
			   System.out.println("method "+me.name());
			   if (me.name().indexOf("main")>-1) continue;
			   EDU.purdue.cs.bloat.editor.MemberRef origMethod = me.memberRef();
			   java.util.Collection overrideTreeMethods = validator.getOverrideTreeMembers(origMethod);
			   if(!overrideTreeMethods.isEmpty()) continue;
			   int j;
			   EDU.purdue.cs.bloat.editor.MemberRef obfuscatedMethod = null;
			   for(j = 0;j<4;j++) {
					   obfuscatedMethod = obfuscateParams(origMethod,methodHash);
					   if(validator.methodExists(obfuscatedMethod)) continue;
					   java.util.Collection clashingMethods = validator.getOverrideTreeMembers(obfuscatedMethod);
					   if(!clashingMethods.isEmpty()) continue;
					   break;
				}
			   if(j == 4) continue;
			   java.util.Iterator overrideTreeMethodsIt = overrideTreeMethods.iterator();
			   methodHash.put(origMethod,obfuscatedMethod);
			   System.out.println("methodHash put "+origMethod);
			   while(overrideTreeMethodsIt.hasNext()) {
				   EDU.purdue.cs.bloat.editor.MemberRef curMR =
				   (EDU.purdue.cs.bloat.editor.MemberRef)overrideTreeMethodsIt.next();
			 	   EDU.purdue.cs.bloat.editor.NameAndType nat =
				   new EDU.purdue.cs.bloat.editor.NameAndType(curMR.nameAndType().name(),
							  obfuscatedMethod.type());
			       EDU.purdue.cs.bloat.editor.MemberRef newMR =
							   new EDU.purdue.cs.bloat.editor.MemberRef(curMR.declaringClass(),nat);
				   methodHash.put(curMR,newMR);
				}
			   EDU.purdue.cs.bloat.editor.MethodEditor newMethod =  new EDU.purdue.cs.bloat.editor.MethodEditor
			   (ce,me.methodInfo().modifiers(),
			   obfuscatedMethod.type().returnType(),
			   obfuscatedMethod.name(),
			   obfuscatedMethod.type().paramTypes(),
			   me.exceptions());
			   copyMethod(me,newMethod);
  			   int firstNewParam =  origMethod.type().indexedParamTypes().length;
			   if(!me.isStatic()) firstNewParam++;
			   int newParamCnt = obfuscatedMethod.type().indexedParamTypes().length - firstNewParam;
			   if(!me.isStatic()) newParamCnt++;
			   fixupSlotAccesses(newMethod,firstNewParam,newParamCnt);
  			   me.delete();
			   me.commit();
			   newMethod.commit();
			   ce.commit();
		 }//for
	     ActualAdder.apply(methodHash,className);

    } catch (Exception e) {
				   e.printStackTrace();
    }
  }

  private EDU.purdue.cs.bloat.editor.Instruction fixInstrSlotNum(EDU.purdue.cs.bloat.editor.Instruction instr, int firstBadSlotNum,int numBadSlots) {
	java.lang.Object operand = instr.operand();
	java.lang.Object newOperand = null;
	int newSlotNum = 0;
    if(operand instanceof EDU.purdue.cs.bloat.editor.LocalVariable) {
	    EDU.purdue.cs.bloat.editor.LocalVariable lv = (EDU.purdue.cs.bloat.editor.LocalVariable)operand;
	    newSlotNum = lv.index();
	    if(newSlotNum>=firstBadSlotNum)
		   newSlotNum += numBadSlots;
		   newOperand = new EDU.purdue.cs.bloat.editor.LocalVariable(lv.name(),lv.type(),newSlotNum);
	} else if(operand instanceof EDU.purdue.cs.bloat.editor.IncOperand) {
	    EDU.purdue.cs.bloat.editor.IncOperand io = (EDU.purdue.cs.bloat.editor.IncOperand)operand;
	    newSlotNum = io.var().index();
	    if(newSlotNum>=firstBadSlotNum)
		   newSlotNum += numBadSlots;
		   EDU.purdue.cs.bloat.editor.LocalVariable lv =
				   new EDU.purdue.cs.bloat.editor.LocalVariable(io.var().name(),
																io.var().type(),
																newSlotNum);
		   newOperand =  new EDU.purdue.cs.bloat.editor.IncOperand(lv,io.incr());
    }

	   return new EDU.purdue.cs.bloat.editor.Instruction(instr.opcodeClass(),
															 newOperand);
  }

  // Look at all the code in the method and fix all the instructions that touch local variable slots.
  private void fixupSlotAccesses(EDU.purdue.cs.bloat.editor.MethodEditor me,int firstNewParam,int newParamCnt) {
        System.out.println("first new: " + firstNewParam + " ; new parameter count: " + newParamCnt);
        for(int j=0;j<me.codeLength();j++) {
		   java.lang.Object o = me.codeElementAt(j);
		   if(o instanceof EDU.purdue.cs.bloat.editor.Instruction) {
			   EDU.purdue.cs.bloat.editor.Instruction instr =  (EDU.purdue.cs.bloat.editor.Instruction)o;
				   if(instr.isLoad() || instr.isStore()) {
					   EDU.purdue.cs.bloat.editor.Instruction newInstr =
						   fixInstrSlotNum(instr,firstNewParam,newParamCnt);
					   me.replaceCodeAt(newInstr,j);
				   } else if(instr.opcodeClass()==EDU.purdue.cs.bloat.editor.Opcode.opcx_iinc) {
					   EDU.purdue.cs.bloat.editor.Instruction newInstr =
						   fixInstrSlotNum(instr,firstNewParam,newParamCnt);
					       me.replaceCodeAt(newInstr,j);
		           }
		   }
		}
  }


  //Given an formal parameter list, return a new formal parameter list that has some random types tacked on to the end of the original list
  private EDU.purdue.cs.bloat.editor.MemberRef obfuscateParams(EDU.purdue.cs.bloat.editor.MemberRef oldMethod,
																  java.util.Hashtable methodHash) {
	 if(methodHash.get(oldMethod) != null)
		 return (EDU.purdue.cs.bloat.editor.MemberRef)methodHash.get(oldMethod);
  	 EDU.purdue.cs.bloat.editor.Type[] oldType = oldMethod.type().paramTypes();
	 EDU.purdue.cs.bloat.editor.Type[] newType = new EDU.purdue.cs.bloat.editor.Type[oldType.length+sRnd.nextInt(MAX_ADDED_ARGS)+1];
	 java.lang.System.arraycopy(oldType,0,newType,0,oldType.length);
	 for(int i=oldType.length;i<newType.length;i++)
		 newType[i] = sParamTypes[sRnd.nextInt(MAX_ADDED_ARGS)];
	 EDU.purdue.cs.bloat.editor.Type newMethodType = EDU.purdue.cs.bloat.editor.Type.getType(newType,oldMethod.type().returnType());
	 EDU.purdue.cs.bloat.editor.NameAndType newMethodName = new EDU.purdue.cs.bloat.editor.NameAndType(oldMethod.name(),newMethodType);
	 return new EDU.purdue.cs.bloat.editor.MemberRef(oldMethod.declaringClass(),newMethodName);
 }

  // Make dest as near to identical to src as possible.  Does not change the formals or return type of dest
  private void copyMethod(EDU.purdue.cs.bloat.editor.MethodEditor src,EDU.purdue.cs.bloat.editor.MethodEditor dest) {
	 dest.setCode(src.code());
	 java.util.Iterator handlerIt = src.tryCatches().iterator();
	 while(handlerIt.hasNext())
		 dest.addTryCatch((EDU.purdue.cs.bloat.editor.TryCatch)handlerIt.next());
	 dest.setAbstract(src.isAbstract());
	 dest.setFinal(src.isFinal());
	 dest.setNative(src.isNative());
	 dest.setPrivate(src.isPrivate());
	 dest.setProtected(src.isProtected());
	 dest.setPublic(src.isPublic());
	 dest.setStatic(src.isStatic());
	 dest.setSynchronized(src.isSynchronized());
	 EDU.purdue.cs.bloat.reflect.MethodInfo srcInfo = src.methodInfo();
	 EDU.purdue.cs.bloat.reflect.MethodInfo destInfo = dest.methodInfo();
	 destInfo.setLineNumbers(srcInfo.lineNumbers());
	 destInfo.setLocals(srcInfo.locals());
	 destInfo.setMaxLocals(srcInfo.maxLocals());
	 destInfo.setMaxStack(srcInfo.maxStack() + 5);
	 dest.commit();
	 System.out.println("orig stack: " + srcInfo.maxLocals() + " ; new stack: " + destInfo.maxLocals());
  }

  public InsertDeadCodeMethodArguments() {
	 sParamTypes = new EDU.purdue.cs.bloat.editor.Type[4];
	 sParamTypes[0] = EDU.purdue.cs.bloat.editor.Type.INTEGER;
	 sParamTypes[1] = EDU.purdue.cs.bloat.editor.Type.FLOAT;
	 sParamTypes[2] = EDU.purdue.cs.bloat.editor.Type.OBJECT;
	 sParamTypes[3] = EDU.purdue.cs.bloat.editor.Type.BOOLEAN;
  }
  public static void copy(String inFile, String outFile)
  throws IOException {

   FileInputStream fin = null;
   FileOutputStream fout = null;

   try {
     fin  = new FileInputStream(inFile);
     fout = new FileOutputStream(outFile);
     StreamCopier(fin, fout);
   }
   finally {
     try {
       if (fin != null) fin.close();
     }
     catch (IOException e) {System.out.println("Exception " +e );}
     try {
       if (fout != null) fout.close();
      }
     catch (IOException e) { System.out.println("Exception " +e ); }
   }

 }

 public static void StreamCopier(InputStream in, OutputStream out)
    throws IOException {

     synchronized (in) {
       synchronized (out) {

         byte[] buffer = new byte[256];
         while (true) {
           int bytesRead = in.read(buffer);
           if (bytesRead == -1) break;
           out.write(buffer, 0, bytesRead);
         }
       }
     }
 }

  public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
	    Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
  }
}