package algorithms;

import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import org.apache.bcel.util.Class2HTML;
import algorithms.random;
import java.io.*;
import java.util.*;


/**
@ Class: LocalVariableReordering
@ Author: Suma Venkatesh
@ Description: This algorithm is one kind of reordering transformations where
  orders of local variables are changed. 
*/

public class LocalVariableReordering {

	   boolean errflag=false;
       Instruction[] in=null ;
	   int arraycount=0;
	   int returnhandle=-1;
	   int no_of_locals=0;
	   int len_of_array=0;
	   int arr1_lvindex=-1;
	   int arr2_lvindex=-1;
	   int arr_assign_start=-1;
	   int arr_assign_end=-1;
	   int lvindex=-1;
	   int poscount=0;
	   int delcount=0;
	   byte arraytype;
	   int increase=0;
	   int cur_mtd=0;

	public boolean apply(String classname) {
		 ClassGen cgen = null;
		 boolean sucess = false;
		 try {

		   	JavaClass clazz = Repository.lookupClass("examples/" + classname);
			cgen = new ClassGen(clazz);
			Method [] methods = cgen.getMethods();

			LocalVariableReordering obj = new LocalVariableReordering();
			obj.modifyLVindices(classname,cgen,methods);

	    	JavaClass c = cgen.getJavaClass();
			c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
			convertToHTML(c,"Obf");
			sucess = true;
	     }

	     catch(Exception e) {System.out.println("Exception" + e.getMessage() + e.fillInStackTrace());return sucess;}
		return sucess;
     }

   	     /**
		  * The main function that coordinates the calls to all other functions which actually do the algorithm
		  */
		public void modifyLVindices(String classname,ClassGen cgen,Method[] methods) throws IOException
		{
			Instruction[] local_in =null;

			InstructionList local_il=null;
			InstructionList il = null;

			int local_pos[],astart_bc=-1,aend_bc=-1,astart_ip=-1,aend_ip=-1;
			ConstantPoolGen  cpg1= cgen.getConstantPool();
			MethodGen mg1;
			int total_incr=0,oldip=-1;
			File outputFile = new File("C:/JHide/Obfuscated_Classes/"+ classname+"_src"+".txt");
			FileWriter out = new FileWriter(outputFile);
			File outputFile1 = new File("C:/JHide/Obfuscated_Classes/"+ classname+"_obf"+".txt");
			FileWriter out1 = new FileWriter(outputFile1);
			for(int i=0;i<methods.length;i++)
			{
					mg1= new MethodGen(methods[i],classname,cpg1);
					if(mg1.getName().equals("<init>") || mg1.getName().equals("<clinit>"))
							continue;
					System.out.println(" Applying Reorder LV for " + mg1.getName());

					int stacksize=mg1.getMaxStack();

					cur_mtd=i;
					no_of_locals = mg1.getMaxLocals();
					String[] str;
					int argscount=0;
					try
					{
							str=mg1.getArgumentNames();
							argscount= str.length  ;
					}catch(Exception e)
					{
							System.out.println(" ***** Error occured while obfuscating .. Reverting back to old file ");
							errflag=true;
					}

					if(methods[i].isStatic() == false)
					{
							System.out.println(" METHOD NAME: " + mg1.getName() + " is virtual so add one to number of args ");
							argscount+=1;
					}
					
					System.out.println(" No of locals : "+ no_of_locals  + " No. of Arguments: "+ argscount);

					local_il = mg1.getInstructionList();
					if(local_il !=null)
							local_in = local_il.getInstructions();
					else
					{       errflag=true;
							return;
					}
					int flag=0;
					for(int j=0;j<local_in.length;j++)
					{
							if(local_in[j] instanceof DSTORE
							|| local_in[j] instanceof LSTORE
							|| local_in[j] instanceof DLOAD
							|| local_in[j] instanceof LLOAD
							|| local_in[j] instanceof DALOAD
							|| local_in[j] instanceof DASTORE
							|| local_in[j] instanceof LASTORE
							|| local_in[j] instanceof LALOAD)
									flag=1;
					}

				CodeExceptionGen ceg[]=mg1.getExceptionHandlers();
				if((no_of_locals - argscount)> 1 && (flag !=1) && ceg.length==0)//&& ceg.length<=1 && ceg.length>0)
				{
					Hashtable ht= random.reorderLVIndexes(no_of_locals,argscount);


					local_il = mg1.getInstructionList();
					local_pos = local_il.getInstructionPositions();
					local_in = local_il.getInstructions();

					CodeException [] coe =cgen.getMethods()[cur_mtd].getCode().getExceptionTable();
					CodeException [] coecopy
							= new CodeException[coe.length];
					for (int coeindex=0;coeindex < coe.length;coeindex++)
					{
							coecopy[coeindex]= coe[coeindex].copy();
					}

					boolean []cantouch= new boolean[local_in.length];
					for(int o=0;o<local_in.length;o++)
					{
							cantouch[o]=true;
					}

					System.out.println(" BEFORE ALL MODIFications ");
					il = mg1.getInstructionList();
					out.write(il.toString());
					


					for(int j=0;j<ht.size();j++)
					{
						if(ht.containsKey(new Integer(j)))
						{
						 total_incr=0;
						 Integer temp =(Integer) (ht.get(new Integer(j)));
						 int newvalue =temp.intValue();

						 for(int k=0;k<local_in.length;k++)
						 {
							
							 System.out.println(" For LV  "+j +" to change to "+ newvalue +" Reading .. " +local_in[k].toString() + " Can Modify this ? " +cantouch[k]);
							 LocalVariableInstruction lvinstr=null;

							 oldip=local_pos[k];
							 if(local_in[k] instanceof ALOAD)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(0,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof ASTORE)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(1,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof DLOAD)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(2,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if (local_in[k] instanceof DSTORE)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(3,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof ILOAD)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(4,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof ISTORE)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(5,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof FLOAD)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(6,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof FSTORE)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(7,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if (local_in[k] instanceof LLOAD)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(8,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof LSTORE)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
										
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(9,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof IINC)
							 {
									if( ((LocalVariableInstruction)local_in[k]).getIndex() ==j && cantouch[k])
									{
										
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(10,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else if(local_in[k] instanceof RET)
							 {
									if( ((RET)local_in[k]).getIndex() ==j && cantouch[k])
									{
											
											System.out.println( " Going to alter Exception Table for " + local_il.findHandle(oldip).toString());
											total_incr=editIndex(11,k, newvalue ,local_il,local_pos);
											cantouch[k]=false;
									}
									else
										continue;
							 }
							 else
								continue;
							
							local_il.setPositions();
							
							System.out.println(" Incr till now : " + total_incr);

							if(total_incr!=0)
							{
								adjustExceptions(coe,coecopy,oldip,total_incr,total_incr);
								System.out.println("instrlist printout after altering");
								InstructionHandle[] tt2 = local_il.getInstructionHandles();
								for(int z=0;z<tt2.length;z++)
									System.out.println(tt2[z].toString());
								cgen.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
								coe =cgen.getMethods()[cur_mtd].getCode().getExceptionTable();
	
								for (int coeindex=0;coeindex < coe.length;coeindex++)
									coecopy[coeindex]= coe[coeindex].copy();
							}
							local_in=local_il.getInstructions();
							local_pos=local_il.getInstructionPositions();
							
						 }  // for i =0 to local_in

						} // if this key is present in the hashtable
					} // for j=0 to hashtable size

					mg1.setInstructionList(local_il);
					mg1.setMaxLocals(no_of_locals);
					mg1.setMaxStack(stacksize);
					mg1.stripAttributes(true);
					cgen.replaceMethod(cgen.getMethods()[cur_mtd],mg1.getMethod());
					cgen.getMethods()[cur_mtd].getCode().setExceptionTable(coe);
					System.out.println( "FINAL EXCEPTION TABLE:");
					for (int g=0;g<coe.length;g++)
						System.out.println(coe[g].getStartPC() +"  "+ coe[g].getEndPC()+"  "+coe[g].getHandlerPC());
						
					cgen.setConstantPool(cpg1);
				}

				System.out.println("***************Method Getcode printout*************");

				out1.write(cgen.getMethods()[cur_mtd].getCode().toString());

				System.out.println("***************88888888888888888888888*************");
	
			}
			out.close();
			out1.close();
		}

		public int editIndex(int instrtype,int k,int newval,InstructionList local_il,int []local_pos)
		{

			int local_incr=0;
			InstructionHandle ih=null;
		 if(instrtype==0)
		 {
			local_il.setPositions();
		
			System.out.println(" insert aload_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new ALOAD(newval));
			local_il.setPositions();
			local_incr+= ( new ALOAD(newval)).getLength();
			System.out.println("Local_incr::"+ local_incr);
		 }
		 else if(instrtype==1)
		 {
			local_il.setPositions();
			
			System.out.println(" insert astore_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new ASTORE(newval));
			local_il.setPositions();
			local_incr+= ( new ASTORE(newval)).getLength();
		 }
		 else if(instrtype==2)
		 {
			local_il.setPositions();
			
			System.out.println(" insert Dload_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new DLOAD(newval));
			local_il.setPositions();
			local_incr+= ( new DLOAD(newval)).getLength();
		 }
		 else if(instrtype==3)
		 {
			local_il.setPositions();
			
			System.out.println(" insert Dstore_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new DSTORE(newval));
			local_il.setPositions();
			local_incr+= ( new DSTORE(newval)).getLength();
		 }
		 else if(instrtype==4)
		 {
			local_il.setPositions();
			
			System.out.println(" insert Iload_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new ILOAD(newval));
			local_il.setPositions();
			local_incr+= ( new ILOAD(newval)).getLength();
		 }
		 else if(instrtype==5)
		 {
			local_il.setPositions();
		
			System.out.println(" insert ISTORE_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new ISTORE(newval));
			local_il.setPositions();
			local_incr+= ( new ISTORE(newval)).getLength();
		 }
		 else if(instrtype==6)
		 {
			local_il.setPositions();
			
			System.out.println(" insert Fload_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new FLOAD(newval));
			local_il.setPositions();
			local_incr+= ( new FLOAD(newval)).getLength();
		 }
		 else if(instrtype==7)
		 {
			local_il.setPositions();
			
			System.out.println(" insert fstore_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new FSTORE(newval));
			local_il.setPositions();
			local_incr+= ( new FSTORE(newval)).getLength();
		 }
		 else if(instrtype==8)
		 {
			local_il.setPositions();
			
			System.out.println(" insert lload_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new LLOAD(newval));
			local_il.setPositions();
			local_incr+= ( new LLOAD(newval)).getLength();
		 }
		 else if(instrtype==9)
		 {
			local_il.setPositions();
			
			System.out.println(" insert lstore_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new LSTORE(newval));
			local_il.setPositions();
			local_incr+= ( new LSTORE(newval)).getLength();
		 }
		 else if(instrtype==10)
		 {
			IINC lvinstr=null;
			lvinstr =(IINC)local_il.findHandle(local_pos[k]+local_incr).getInstruction();
			int iincr =lvinstr.getIncrement();
			local_il.setPositions();
			
			System.out.println(" insert iinc_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new IINC(newval,iincr));
			local_il.setPositions();
			local_incr+= ( new IINC(newval,iincr)).getLength();
		 }
		 else if(instrtype==11)
		 {
			RET lvinstr=null;
			lvinstr =(RET)local_il.findHandle(local_pos[k]+local_incr).getInstruction();
			local_il.setPositions();
			
			System.out.println(" insert ret_newindex before: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());
			ih=local_il.insert(local_il.findHandle(local_pos[k]+local_incr),new RET(newval));
			local_il.setPositions();
			local_incr+= ( new RET(newval)).getLength();
		 }

			int len=-100;
			try{
					local_il.setPositions();

				
					System.out.println(" Trying to redirect all branches that had  " +
					local_il.findHandle(local_pos[k]+local_incr).toString() +  " to " +
					local_il.findHandle(ih.getPosition()).toString());
					local_il.redirectBranches(local_il.findHandle(local_pos[k]+local_incr),local_il.findHandle(ih.getPosition()));

				
					System.out.println(" delete orig: " +local_il.findHandle(local_pos[k]+local_incr).getInstruction().toString());

					len= local_il.findHandle(local_pos[k]+local_incr).getInstruction().getLength();
					local_il.delete(local_il.findHandle(local_pos[k]+local_incr));
					local_incr -= len;
					System.out.println("Local_incr:: after delete "+ local_incr);
					local_il.setPositions();

			}catch(Exception e6)
			{
			 local_incr -= len;
			 local_il.setPositions();
			 ///e6.printStackTrace();
			}

			
			System.out.println(" Local_incr " + local_incr);
			return local_incr;

		}

	    /* This function is called whenever code is added inside in a try-catch block. Modifies the
		 * startPC,endPC and handlerPC of the exception table to reflect the changes to the code.
		 *
		 * @param coe ExceptionTable Object
		 * @param coecopy A deep copy of the exception table of the unmodified code.
		 * @param cur_pos Position of the bytecode instruction that is modified in the unmodifed code.
		 * @param count Number of new instructions added to the method in place of the current instruction.
		 * @param addcount A cumulative count of the instructions added to the method.
		 */
		private void adjustExceptions(CodeException []coe,CodeException []coecopy,int cur_pos,int count,int addcount)
		{
			int epc;
			int spc;
			int hpc;

			for (int i=0;i<coe.length;i++)
			{
				epc=coecopy[i].getEndPC();
				spc = coecopy[i].getStartPC();
				hpc = coecopy[i].getHandlerPC();
				
				System.out.println("IP under question : "+cur_pos+ " Current startpc : "+spc+ " endpc: " +epc+ " handlerPC:"+ hpc);
				if (cur_pos >= spc && cur_pos <= epc)
				{
					coe[i].setEndPC(epc+addcount);
					coe[i].setHandlerPC(hpc+addcount);


				}
				else if (cur_pos <= epc) {

						coe[i].setStartPC(spc+addcount);
						coe[i].setEndPC(epc+addcount);
						coe[i].setHandlerPC(hpc+addcount);
					}

				else
				{
					for (int j=i+1;j<coe.length;j++)
					{
						int epc1=coecopy[j].getEndPC();
						int spc1 = coecopy[j].getStartPC();
						int hpc1 = coecopy[j].getHandlerPC();
						if ( spc1 == spc && epc1 == epc && cur_pos <= hpc1)
						{
							coe[j].setHandlerPC(hpc1+addcount);
						}


					}
				}

			}

			System.out.println( " EXCEPTION TABLE:");
			for (int i=0;i<coe.length;i++)
				System.out.println(coe[i].getStartPC() +"  "+ coe[i].getEndPC()+"  "+coe[i].getHandlerPC());
			}

		public static void printCode(String classname,String msg) throws IOException  {

				File outputFile = new File("C:/JHide/Obfuscated_Classes/"+ classname+".txt");
				FileWriter out = new FileWriter(outputFile);
				out.write(msg.toString());
				out.close();


		}
	    public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
	   		   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
       }




}