package algorithms;

import java.io.BufferedReader;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import java.io.*;
import java.util.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: LoopBlocking
@ Author: Suma Venkatesh
@ Description: Control ordering is a kind of control transformation that alters the order in which statements are executed
  in a program. Loop blocking is one kind of control ordering where nesting is added to loops.
**/

public class LoopBlocking 
{
	static FileInputStream fin;
    static BufferedReader din;
    static FileOutputStream fout;
	String forloop;
	Vector instrs = new Vector();

	public boolean apply(String classname) {

		ClassGen cgen = null;
		boolean sucess = false;

		try {
			String inPath = "C:/JHide/examples/" + classname + ".java";
			String outPath = "C:/JHide/engine/" + classname + ".java";

			loopBlock(classname);
			
			
			sucess = true;

		}
	    catch(Exception e) {System.out.println("Exception" + e.getMessage()); return(sucess);}
		return(sucess);
	}


	 public  void loopBlock(String className)throws Exception {

		try {

			EDU.purdue.cs.bloat.file.ClassFileLoader cfl = new EDU.purdue.cs.bloat.file.ClassFileLoader();  // BLOAT loader
			EDU.purdue.cs.bloat.file.ClassFileLoader classFileLoader = new EDU.purdue.cs.bloat.file.ClassFileLoader();
			EDU.purdue.cs.bloat.reflect.ClassInfo info = null;
			EDU.purdue.cs.bloat.file.ClassFile classFile = (EDU.purdue.cs.bloat.file.ClassFile) cfl.loadClass("examples/"+ className);
			info = cfl.loadClass("examples/"+className);

			EDU.purdue.cs.bloat.file.Method[] methods  =(EDU.purdue.cs.bloat.file.Method [])info.methods();
			EDU.purdue.cs.bloat.context.PersistentBloatContext bloatContext = new EDU.purdue.cs.bloat.context.PersistentBloatContext(classFile.loader());
			EDU.purdue.cs.bloat.editor.ClassEditor classEditor = new  EDU.purdue.cs.bloat.editor.ClassEditor(bloatContext,info);
			EDU.purdue.cs.bloat.inline.Inline inline = new EDU.purdue.cs.bloat.inline.Inline( bloatContext,20);
			EDU.purdue.cs.bloat.reflect.MethodInfo[] methodInfo =classEditor.methods();
			EDU.purdue.cs.bloat.editor.MethodEditor me = bloatContext.editMethod(methodInfo[0]);
			inline.inline(me);
			System.out.println(" Inlining Complete for Method :: " + methods[0].toString());


			for (int k=0; k < methods.length; k++) {
				int nameIndex = methods[k].nameIndex();
				EDU.purdue.cs.bloat.editor.MethodEditor methodEditor = new  EDU.purdue.cs.bloat.editor.MethodEditor(classEditor,methods[k]);

				String temp = new String(methodEditor.name());

				List il = methodEditor.code();

				int i = 0;
				EDU.purdue.cs.bloat.editor.Label target = null;
				EDU.purdue.cs.bloat.editor.Instruction icmp = null;

				while(i<il.size()) {
				  try {
					  EDU.purdue.cs.bloat.editor.Instruction instr = (EDU.purdue.cs.bloat.editor.Instruction)il.get(i);

					  if ( instr.isConditionalJump()) {
						  EDU.purdue.cs.bloat.editor.Instruction loop = instr;
						  target = (EDU.purdue.cs.bloat.editor.Label)instr.operand();
						  icmp = new EDU.purdue.cs.bloat.editor.Instruction(EDU.purdue.cs.bloat.editor.Opcode.opc_if_icmpne,target);

				       }

				       if(target != null) {

						   if(instr != icmp) {
							    System.out.println("instrs inside loop " + instr.toString());

						   }

					   }



						 


				  }catch(Exception e) {}
				   i++;
			   } // end of while

			   methodEditor.commit();

			   methodEditor.code();

			 }     // end of for
			 bloatContext.commit();
			 classFile.commit();

			File outputFile = new File("C:/JHide/Obfuscated_Classes/"+ className+"_obf.txt");
			FileWriter out = new FileWriter(outputFile);


			for (int k=0; k < methods.length; k++) {
				out.write(methods[k].code().toString());

			}
			out.close();


		 } catch(Exception e) { System.out.println("Exception" +e.getMessage()); }


	 }//end-appendboguspredicates



	

   public static void copy(String inFile, String outFile)
         throws IOException {

          FileInputStream fin = null;
          FileOutputStream fout = null;

          try {
            fin  = new FileInputStream(inFile);
            fout = new FileOutputStream(outFile);
            StreamCopier(fin, fout);
          }
          finally {
            try {
              if (fin != null) fin.close();
            }
            catch (IOException e) {System.out.println("Exception " +e );}
            try {
              if (fout != null) fout.close();
             }
            catch (IOException e) { System.out.println("Exception " +e ); }
          }

        }

        public static void StreamCopier(InputStream in, OutputStream out)
           throws IOException {

            synchronized (in) {
              synchronized (out) {

                byte[] buffer = new byte[256];
                while (true) {
                  int bytesRead = in.read(buffer);
                  if (bytesRead == -1) break;
                  out.write(buffer, 0, bytesRead);
                }
              }
            }
        }
		  public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {

		   		   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);


		   }



    




   
}










