package algorithms;

import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import java.io.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: LoopReorder
@ Author: Suma Venkatesh
@ Description:   This algorithm is one kind of preventive transformation which make known
  automatic deobfuscation techniques harder to employ, although they add little or no obfuscation to a program.
*/

public class LoopReorder {
	static FileInputStream fin;
    static BufferedReader din;
    static FileOutputStream fout;

	public boolean apply(String classname) {
		ClassGen cgen = null;
		boolean sucess = false;
		try {
			String inPath = "C:/JHide/examples/" + classname + ".java";
			String outPath = "C:/JHide/engine/" + classname + ".java";
			loopReorder(inPath,outPath);
			JavaClass clazz = Repository.lookupClass("/engine/" + classname);
			clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) + "_obf" + ".class"));
			convertToHTML(clazz,"Obf");
			sucess = true;
		}
	    catch(Exception e) {System.out.println("Exception" + e.getMessage()); return(sucess);}
		return(sucess);
	}
    //changes the order of the loop
     public void loopReorder(String fileName,String outName) throws IOException{
        int flag =0;
        int i =0;
        try {
            fin = new FileInputStream(fileName);
		    din = new BufferedReader(new InputStreamReader(fin));
		    File writeFileObj = new File(outName);
		    fout = new FileOutputStream(writeFileObj);
			String line;
			String type1;
			String type2;
			String var1 =null;
			while ((line = din.readLine()) != null) {
		         line= line.trim();
				 boolean match = line.trim().regionMatches(true,0,"for",0,2);

				 if (!match) {
		              fout.write(line.getBytes());
			     }
				 else  {
					  int index1 = 0;
					  index1 = line.indexOf(")");
					  int index2 = line.indexOf("i",0);
					  String var = line.substring(index2+3,index2+5);
					  int index3 = line.indexOf(";",line.indexOf(var));
					  String line1 = line.substring(index3+1,line.length());
					  int index4 = line1.indexOf(";");
					  String line2 = line1.substring(0,index4);
					  System.out.println(line1 + "###" +line2);
					  String op =  line2.substring(3,4);
					  String Lmt = line2.substring(5,line2.length());
					  if(op.trim().equalsIgnoreCase("<") == true) { //System.out.println("iam here" );
					    op = " > "; }
					  else { op = "<"; }
					  System.out.println("var" + var + "OP" + op +"Lmt" + Lmt);

					  String replace = "for(int " + var.trim()+ "=" + Lmt.trim()+ ";" + var.trim() + op.trim() + "0;"+ var.trim() + "--){" ;
					  System.out.println("replace" + replace);
					  fout.write(replace.getBytes());
				 }
	 		 }
	 	  }
	      catch(Exception e) {
	 	    //System.out.println("Exception is " + e);
	      }
     }

     public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
  	    Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
     }
}