package algorithms.Method2RMadness;
/**
@ Class: Method2RMadness
@ Author: Suma Venkatesh
@ Description: This algorithm hides information hidden in methods by disrupting their signatures, argument orders, 
  and moving or combining them.This algorithm is implemented in Sand Mark and we have replicated the same.

*/

public class Method2RMadness {

	/* Turn to true to print debugging messages. */
	private static final boolean DEBUG = false;

	/* Turn to true to print status output messages as the obfuscator runs. */
	private static final boolean OUTPUT = true;

	/* Required for SandMark's interface. */
	private utils.ConfigProperties myProps = new utils.ConfigProperties();


	/* Runs a quick test of this obfuscator. */
	public boolean driver(String[] args) throws Exception
	{
		boolean sucess = false;
		try
		{
			System.out.println("Iam inside driver" + args[0] );

			utils.ClassFileCollection cfc = new utils.ClassFileCollection();


			Method2RMadness obfuscator = new Method2RMadness();

			
			String className = args[0];
			obfuscator.apply(className);
            sucess = true;


		}
		catch (java.io.IOException e)
		{
			System.err.println("I/O Error: " + e.getMessage());
		}
		return sucess;
	}


	/** Prints the contents of the given class file collection to System.out. */
	private static void printCFC(utils.ClassFileCollection cfc) throws Exception
	{
		java.util.Iterator itr = cfc.classes();
		while (itr.hasNext())
		{
			String className = (String)itr.next();
			System.out.println("Class " + className);
			de.fub.bytecode.classfile.JavaClass jc = cfc.getClass(className);

			de.fub.bytecode.generic.ClassGen cgen = new de.fub.bytecode.generic.ClassGen(jc);
			de.fub.bytecode.generic.ConstantPoolGen cpgen = cgen.getConstantPool();

			

			// print all methods in this class
			int numMethods = cgen.getMethods().length;
			for (int methodNum = 0;  methodNum < numMethods;  methodNum++)
			{
				// reorder each method
				de.fub.bytecode.classfile.Method meth = cgen.getMethodAt(methodNum);
				de.fub.bytecode.generic.MethodGen methGen  = new de.fub.bytecode.generic.MethodGen(meth, className, cpgen);
				System.out.println(meth + "{");
				System.out.println(methGen.getInstructionList() + "\n");
				System.out.println("}");
			}
		}
	}

	
   public de.fub.bytecode.classfile.JavaClass getClass(String classname) throws java.io.IOException {
   		//java.io.File f = new java.io.File("C:/JHide/examples/TestMethod2RMadness.class");
   		java.io.File f = new java.io.File("C:/JHide/examples/" + classname + ".class");

   	    de.fub.bytecode.classfile.ClassParser p = new de.fub.bytecode.classfile.ClassParser(f.getPath());
   	    return p.parse();
   }

	/** Makes public the fields/methods in this ClassFileCollection's classes. */
	public void apply(String args) throws Exception
	{
		// create a class hierarchy for later seeing if methods are renamable
           //CC		utils.ClassHierarchy ch = new utils.ClassHierarchy(cfc, myProps);

		// 1. make all fields/methods public
		de.fub.bytecode.classfile.JavaClass jClass = null;
		utils.ClassFileCollection cfc = new utils.ClassFileCollection();
		jClass = getClass(args);
		cfc.addClass(jClass);

		if (OUTPUT)  System.out.println("Step 1) Publicizer; making fields/methods all public...");
		new Publicizer().apply(cfc);
		System.gc();
		System.runFinalization();

		// 2. replace nonstatic methods with static methods
		if (OUTPUT)  System.out.println("Step 2) StaticSplit; moving dynamic method bodies into static methods...");
		java.util.Iterator itr = cfc.classes();
		StaticSplit split =	new StaticSplit();
		while(itr.hasNext())
			split.apply(cfc, (String)itr.next());
		split = null;
		System.gc();
		System.runFinalization();

		// 3. promote all primitives into wrapper objects
		if (OUTPUT)  System.out.println("Step 3) PrimitivePromoter; wrapping all primitives into object wrappers...");
		new PrimitivePromoter().apply(cfc);
		System.gc();
		System.runFinalization();

		// 4. reorder arguments of static methods
		if (OUTPUT)  System.out.println("Step 4) ParameterReorder; shuffling method argument orders...");
		new ParameterReorderer().apply(cfc);
		System.gc();
		System.runFinalization();

		// 5. convert arguments into Object[]
		if (OUTPUT)  System.out.println("Step 5) SignatureBludgeoner; making all static methods take Object[]...");
		new SignatureBludgeoner().apply(cfc);
		System.gc();
		System.runFinalization();

		// 6. merge static methods into master method
		if (OUTPUT)  System.out.println("Step 6) MethodMerger; combining each class's static methods...");
		new MethodMerger().apply(cfc);
		System.gc();
		System.runFinalization();

		addClass(jClass);
		java.io.File f = new java.io.File("C:/JHide/Obfuscated_Classes/examples/" + args +"_obf.class");

   	    de.fub.bytecode.classfile.ClassParser p = new de.fub.bytecode.classfile.ClassParser(f.getPath());
   	    jClass = p.parse();
		
		convertToHTML(jClass,"Obf");
	}
     public static void convertToHTML(de.fub.bytecode.classfile.JavaClass clazz,String type)   throws java.io.IOException {
		   de.fub.bytecode.util.Class2HTML conObj = new de.fub.bytecode.util.Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
   	 }

	    /**
		 *  Adds or replaces a class in this collection, given a JavaClass.
		 */
	public void addClass(de.fub.bytecode.classfile.JavaClass c) throws java.io.IOException {
		//c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
    }

	

}
