package algorithms.Method2RMadness;

import de.fub.bytecode.generic.InstructionFactory;

public class PrimitivePromoter  implements de.fub.bytecode.Constants
{

    /* Turn to true to print debugging messages. */
    private static final boolean DEBUG = false;

    /* Makes an ICONST_n or BIPUSH n for a given int. */
    private static de.fub.bytecode.generic.Instruction createPushInstruction(int n)
    {
                switch (n)
                {
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                    return new de.fub.bytecode.generic.ICONST(n);
                default:
                    return new de.fub.bytecode.generic.BIPUSH((byte)n);
                }
        }

    /* Returns a hash key for a method. */
    private static String getMethodKey(de.fub.bytecode.classfile.JavaClass jc,
                                       de.fub.bytecode.classfile.Method meth)
    {
        return getMethodKey(jc.getClassName(), meth.getName(), meth.getSignature());
    }

    /* Returns a hash key for a method. */
    private static String getMethodKey(String className, String methodName, String methodSignature)
    {
        return className + "." + methodName + methodSignature;
    }

    private static boolean okToPromote(de.fub.bytecode.generic.MethodGen methGen)
    {
                        return !methGen.isVolatile() && !methGen.isSynchronized() && methGen.isStatic() && !(methGen.getName().equals("main") || methGen.getName().equals("<clinit>"));
                }

                private static String newNameInClass(de.fub.bytecode.generic.ClassGen cgen)
                {
                        de.fub.bytecode.classfile.Method [] methods = cgen.getMethods();
                        String methName = "get";
                        int i = 0;
                        for (int j = 0; j < methods.length; j++)
                        {
                                if (methods[j].getName().equals(methName+i))
                                {
                                        i++;
                                        j = 0;
                                }
                        }
                        return methName + i;
                }

        private static void changeName( de.fub.bytecode.generic.MethodGen methGen,
                                                                                                                                        de.fub.bytecode.generic.ConstantPoolGen cpgen,
                                                                                                                                        String newName)
        {

                //add new method name to the constant pool
                //int newNameIndex = cpgen.addUtf8(newName);

                //lookup method reference for this method
                ///int methodRef = cpgen.lookupMethodref(methGen);

                //de.fub.bytecode.classfile.ConstantMethodref mr =
                //      (de.fub.bytecode.classfile.ConstantMethodref)cpgen.getConstant(methodRef);

                //de.fub.bytecode.classfile.ConstantNameAndType nAt =
                //      (de.fub.bytecode.classfile.ConstantNameAndType)
                //              cpgen.getConstant(mr.getNameAndTypeIndex());

                //nAt.setNameIndex(newNameIndex);

                methGen.setName(newName);
        }


    private static final de.fub.bytecode.generic.Type VOID_TYPE =
        de.fub.bytecode.generic.Type.VOID;
    private static final de.fub.bytecode.generic.ObjectType INTEGER_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Integer;");
    private static final de.fub.bytecode.generic.ObjectType DOUBLE_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Double;");
    private static final de.fub.bytecode.generic.ObjectType FLOAT_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Float;");
    private static final de.fub.bytecode.generic.ObjectType LONG_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Long;");
    private static final de.fub.bytecode.generic.ObjectType CHARACTER_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Character;");
    private static final de.fub.bytecode.generic.ObjectType SHORT_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Short;");
    private static final de.fub.bytecode.generic.ObjectType BYTE_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Byte;");
    private static final de.fub.bytecode.generic.ObjectType BOOLEAN_TYPE =
        (de.fub.bytecode.generic.ObjectType)de.fub.bytecode.generic.Type.getType("Ljava/lang/Boolean;");


    /* Required for SandMark's interface. */
    private utils.ConfigProperties myProps = new utils.ConfigProperties();

    public void apply(utils.ClassFileCollection cfc) throws Exception
    {
        try{
        java.util.HashMap typeTable = new java.util.HashMap();
        typeTable.put(de.fub.bytecode.generic.Type.BOOLEAN, BOOLEAN_TYPE);
        typeTable.put(de.fub.bytecode.generic.Type.BYTE, BYTE_TYPE);
        typeTable.put(de.fub.bytecode.generic.Type.CHAR, CHARACTER_TYPE);
        typeTable.put(de.fub.bytecode.generic.Type.DOUBLE, DOUBLE_TYPE);
        typeTable.put(de.fub.bytecode.generic.Type.FLOAT, FLOAT_TYPE);
        typeTable.put(de.fub.bytecode.generic.Type.INT, INTEGER_TYPE);
        typeTable.put(de.fub.bytecode.generic.Type.LONG, LONG_TYPE);
        typeTable.put(de.fub.bytecode.generic.Type.SHORT, SHORT_TYPE);

        java.util.HashMap changedFields = new java.util.HashMap();
        java.util.HashMap changedMethods = new java.util.HashMap();
        java.util.HashMap originalMethods = new java.util.HashMap();
        java.util.HashMap localVarIndexTable = new java.util.HashMap();

        java.util.ArrayList classes = new java.util.ArrayList();
        java.util.ArrayList classes2 = new java.util.ArrayList();
        java.util.Iterator classItr = cfc.classes();

        while (classItr.hasNext())
            classes.add(classItr.next());

        classItr = classes.iterator();
        while (classItr.hasNext())
        {
            String className = (String)classItr.next();
            int index = className.indexOf(".class");
            if (index  >= 0)
                className = className.substring(0, index);

            de.fub.bytecode.classfile.JavaClass jc = cfc.getClass(className);
            de.fub.bytecode.generic.ClassGen cgen =
                new de.fub.bytecode.generic.ClassGen(jc);
            de.fub.bytecode.generic.ConstantPoolGen cpgen = cgen.getConstantPool();

            // update type of all fields in this class to be wrapped objects
            de.fub.bytecode.classfile.Field [] fields =  jc.getFields();


/*          for (int fi = 0; fi < fields.length; fi++)
            {
                de.fub.bytecode.classfile.Field currField = fields[fi];

                de.fub.bytecode.generic.Type fieldType =
                    de.fub.bytecode.generic.Type.getType(currField.getSignature());

                if (fieldType instanceof de.fub.bytecode.generic.ReferenceType)
                    continue;

                // now we know that this is a primitive type, promote it and add it to
                // the list of changed fields

                if (DEBUG)System.out.println("Field " + currField.getName() + " of type " +
                                                                                                                                        fieldType + " in class " + className);

                if (currField.isFinal())
                        continue;

                de.fub.bytecode.generic.Type newType =
                    (de.fub.bytecode.generic.Type)typeTable.get(fieldType);

                de.fub.bytecode.generic.FieldGen newFieldGen =
                    new de.fub.bytecode.generic.FieldGen(currField, cpgen);

                // apply the changes
                newFieldGen.setType(newType);
                de.fub.bytecode.classfile.Field newField = newFieldGen.getField();
                cgen.replaceField(currField, newField);

                changedFields.put(className + "." + newField.getName(), fieldType);
            }*/

            // update signatures of all methods in this class
            de.fub.bytecode.classfile.Method [] methods = jc.getMethods();
            for (int mi = 0; mi < methods.length; mi++)
            {
                de.fub.bytecode.classfile.Method currMethod = methods[mi];

                //key1 - original method name, original param list
                String key = getMethodKey(jc, currMethod);

                de.fub.bytecode.generic.MethodGen oldMethodGen =
                    new de.fub.bytecode.generic.MethodGen(currMethod, className, cpgen);

                de.fub.bytecode.generic.MethodGen newMethodGen =
                    new de.fub.bytecode.generic.MethodGen(currMethod, className, cpgen);

                if (!okToPromote(newMethodGen))
                        continue;

                boolean changed = true;

                //if (DEBUG) System.out.println("Renaming method " + newMethodGen);
                changeName(newMethodGen, cpgen, newNameInClass(cgen));

                //key2 (for local to class lookups) new method name, original param list
                String key2 = getMethodKey(jc, newMethodGen.getMethod());
                // replace each type in the signature with the new type
                de.fub.bytecode.generic.Type [] argTypes = newMethodGen.getArgumentTypes();


                // map old lvar indeces to new ones
                // (fixes removal of two-word variables double/long)
                int maxIndex = 0;
                for (int ii = 0; ii < argTypes.length; ii++)
                {
                        maxIndex += argTypes[ii].getSize();
                }


                int[] indeces = new int[maxIndex];
                int curr = 0;
                for (int ii = 0; ii < indeces.length; ii++)
                {
                        indeces[ii] = curr;
                        ii += argTypes[curr].getSize() - 1;
                        curr++;
                }


                for (int ti = 0; ti < argTypes.length; ti++)
                {
                    if (!(argTypes[ti] instanceof de.fub.bytecode.generic.ReferenceType))
                    {
                        argTypes[ti] = (de.fub.bytecode.generic.Type)typeTable.get(argTypes[ti]);
                        changed = true;
                    }
                }

                newMethodGen.setArgumentTypes(argTypes);

                de.fub.bytecode.generic.Type retType = newMethodGen.getReturnType();

                if (retType != de.fub.bytecode.generic.Type.VOID &&
                    !(retType instanceof de.fub.bytecode.generic.ReferenceType))
                {
                    newMethodGen.setReturnType((de.fub.bytecode.generic.Type)typeTable.get(retType));
                    changed = true;
                }

                newMethodGen.setMaxStack();
                newMethodGen.setMaxLocals();

                if(changed)
                {
                                if (DEBUG) System.out.println("Applying to: " + newMethodGen);
                    // apply the changes
                    de.fub.bytecode.classfile.Method newMethod = newMethodGen.getMethod();

                    cgen.replaceMethod(currMethod, newMethod);

                                if (DEBUG) System.out.println("KEYS: " + key + "\n" + key2);

                    changedMethods.put(key, newMethodGen);
                    changedMethods.put(key2, newMethodGen);

                    originalMethods.put(newMethodGen, oldMethodGen);
                    // hash in [method string] => [array of new indeces] table
                                // the key needs to be newMethName/newParamTypes
                                localVarIndexTable.put(getMethodKey(jc, newMethod), indeces);
                }
            }


                        cgen.setAccessFlags(cgen.getAccessFlags() | de.fub.bytecode.Constants.ACC_SUPER);
                        cgen.setConstantPool(cpgen);

            de.fub.bytecode.classfile.JavaClass newClass = cgen.getJavaClass();

                        newClass.setAccessFlags(newClass.getAccessFlags() | de.fub.bytecode.Constants.ACC_SUPER);



            classes2.add(newClass);
        }

        // now all fields and method sigs are of object types, but they
        // are still used incorrectly as primitives in bodies of methods;
        // so fix all calls and references to old primitives
        classItr = classes2.iterator();
        while (classItr.hasNext())
        {
                de.fub.bytecode.classfile.JavaClass jc =
                        (de.fub.bytecode.classfile.JavaClass)classItr.next();//cfc.getClass(className);

                String className = jc.getClassName();//(String)classItr.next();

            /*int index = className.indexOf(".class");
            if (index  >= 0)
                                className = className.substring(0, index);*/


            de.fub.bytecode.generic.ClassGen cgen =
                                new de.fub.bytecode.generic.ClassGen(jc);
            de.fub.bytecode.generic.ConstantPoolGen cpgen = cgen.getConstantPool();

            // update bodies of all methods in this class
            de.fub.bytecode.classfile.Method [] methods = jc.getMethods();
            de.fub.bytecode.generic.InstructionFactory ifactory =
                new de.fub.bytecode.generic.InstructionFactory(cgen, cpgen);
            for (int mi = 0; mi < methods.length; mi++)
            {
                de.fub.bytecode.classfile.Method currMethod = methods[mi];

                /* dont try to patch code that ain't there */
                if (currMethod.isAbstract() || currMethod.isInterface())
                        continue;

                String methodKey = getMethodKey(jc, currMethod);
                if (DEBUG) System.out.println("LOOKUPVAR:" + methodKey);
                de.fub.bytecode.generic.MethodGen newMethodGen =
                    new de.fub.bytecode.generic.MethodGen(currMethod, className, cpgen);

                if (DEBUG) System.out.println("patching " + newMethodGen);

                de.fub.bytecode.generic.InstructionList instrList = newMethodGen.getInstructionList();
                for (de.fub.bytecode.generic.InstructionHandle ihandle = instrList.getStart();
                     ihandle != null;
                     ihandle = ihandle.getNext())
                {
                    de.fub.bytecode.generic.Instruction instr = ihandle.getInstruction();
                    short opcode = instr.getOpcode();
                    java.util.ArrayList newInstrs = new java.util.ArrayList();

                    if (instr instanceof de.fub.bytecode.generic.LocalVariableInstruction)
                    {
                        // we have to modify instructions that refer to local
                        // vars/arguments, such as:

                        // IINC, ALOAD,  DLOAD,  FLOAD,  ILOAD,  LLOAD,
                        //       ASTORE, DSTORE, FSTORE, ISTORE, LSTORE

                        de.fub.bytecode.generic.LocalVariableInstruction lvi =
                            (de.fub.bytecode.generic.LocalVariableInstruction)instr;
                        int n = lvi.getIndex();

                        // repair instructions that refer to moved local variables
                        if (localVarIndexTable.containsKey(methodKey))
                        {
                                if (DEBUG) System.out.print("Changing index in param list from " + n);
                                int[] indeces = (int[])localVarIndexTable.get(methodKey);
                                if (n < indeces.length)
                                {
                                        n = indeces[n];
                                        lvi.setIndex(n);
                                }
                                if (DEBUG) System.out.println(" to " + n);
                        }

                        de.fub.bytecode.generic.Type [] argTypes = newMethodGen.getArgumentTypes();
                        int virtualOffset = newMethodGen.isStatic() ? 0 : 1;

                                //if this is a local variable instruction in the param list of an unchanged method
                                //we need to skip the change to the load

                                if ( !okToPromote(newMethodGen))
                                {
                                        // System.out.println("here");
                                        newInstrs.add(instr);
                                        continue;
                                }

                                /*
                                  IINC n c -> NEW Integer, DUP,
                                  ALOAD n, INVOKEVIRTUAL intValue(), PUSH c, IADD,
                                  INVOKESPECIAL <init>(int), ASTORE n
                                */
                        if (instr instanceof de.fub.bytecode.generic.IINC)
                        {
                                de.fub.bytecode.generic.IINC iinc =
                                    (de.fub.bytecode.generic.IINC)instr;
                                int c = iinc.getIncrement();

                                newInstrs.add(ifactory.createNew(INTEGER_TYPE));
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                newInstrs.add(ifactory.createLoad(INTEGER_TYPE, n));
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Integer",
                                                           "intValue",
                                                           de.fub.bytecode.generic.Type.INT,
                                                           de.fub.bytecode.generic.Type.NO_ARGS,
                                                           de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                     );
                                newInstrs.add(createPushInstruction(c));
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.IADD);
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Integer",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                                               {de.fub.bytecode.generic.Type.INT},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                newInstrs.add(InstructionFactory.createStore(INTEGER_TYPE, n));
                        }

                                /*
                                  In the case of a normal object load, the instruction remains
                                  unchanged.
                                */
                        /* *** Would it fix bugs to do an object-type load everywhere and then do a check
                           cast?  Marty's signature blugeoner expects all objects... */
                        else if (instr instanceof de.fub.bytecode.generic.ALOAD)
                        {
                            newInstrs.add(instr);
                        }

                                /*
                                   _LOAD n  -> ALOAD n,
                                               (if _ != A)  // primitive
                                                 INVOKEVIRTUAL _Value()
                                 */
                        else if (instr instanceof de.fub.bytecode.generic.DLOAD)
                        {
                                newInstrs.add(InstructionFactory.createLoad(DOUBLE_TYPE, n));
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Double",
                                                           "doubleValue",
                                                           de.fub.bytecode.generic.Type.DOUBLE,
                                                           de.fub.bytecode.generic.Type.NO_ARGS,
                                                           de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                     );
                        }
                        else if (instr instanceof de.fub.bytecode.generic.FLOAD)
                        {
                                newInstrs.add(ifactory.createLoad(FLOAT_TYPE, n));
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Float",
                                                           "floatValue",
                                                           de.fub.bytecode.generic.Type.FLOAT,
                                                           de.fub.bytecode.generic.Type.NO_ARGS,
                                                           de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                     );
                        }
                        else if (instr instanceof de.fub.bytecode.generic.ILOAD)
                        {
                            //only an idiot would iload 0 on a virtual method... we dont care about idiots

                            //we are not loading one of the arguments to the method, just a normal
                            //local variable
                            if (n >= argTypes.length + virtualOffset)
                            {
                                newInstrs.add(ifactory.createLoad(INTEGER_TYPE, n));
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Integer",
                                                           "intValue",
                                                           de.fub.bytecode.generic.Type.INT,
                                                           de.fub.bytecode.generic.Type.NO_ARGS,
                                                           de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                     );
                            }
                            else // n is an argument
                            {
                                de.fub.bytecode.generic.Type newType = argTypes[n-virtualOffset];
                                if (newType.equals(CHARACTER_TYPE))
                                {
                                    newInstrs.add(ifactory.createLoad(CHARACTER_TYPE, n));

                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Character",
                                                               "charValue",
                                                               de.fub.bytecode.generic.Type.CHAR,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                }
                                else if (newType.equals(INTEGER_TYPE))
                                {
                                    newInstrs.add(ifactory.createLoad(INTEGER_TYPE, n));
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Integer",
                                                               "intValue",
                                                               de.fub.bytecode.generic.Type.INT,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                }
                                else if (newType.equals(BYTE_TYPE))
                                {
                                    newInstrs.add(ifactory.createLoad(BYTE_TYPE, n));
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Byte",
                                                               "byteValue",
                                                               de.fub.bytecode.generic.Type.BYTE,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                }
                                else if (newType.equals(BOOLEAN_TYPE))
                                {
                                    newInstrs.add(ifactory.createLoad(BOOLEAN_TYPE, n));
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Boolean",
                                                               "booleanValue",
                                                               de.fub.bytecode.generic.Type.BOOLEAN,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                }
                                else if (newType.equals(SHORT_TYPE))
                                {
                                    newInstrs.add(ifactory.createLoad(SHORT_TYPE, n));
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Short",
                                                               "shortValue",
                                                               de.fub.bytecode.generic.Type.SHORT,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                }
                                else
                                    throw new IllegalArgumentException("Can't find type for iload " + newType);

                            }
                        }
                        else if (instr instanceof de.fub.bytecode.generic.LLOAD)
                        {
                                newInstrs.add(ifactory.createLoad(LONG_TYPE, n));
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Long",
                                                           "longValue",
                                                           de.fub.bytecode.generic.Type.LONG,
                                                           de.fub.bytecode.generic.Type.NO_ARGS,
                                                           de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                     );
                        }

                                /*
                                   In the case of an ASTORE instruction, the instruction remains
                                   unchanged.
                                */
                        else if (instr instanceof de.fub.bytecode.generic.ASTORE)
                        {
                                newInstrs.add(instr);
                        }
                                /*
                                  _STORE n -> (if _ != A)  // primitive
                                               NEW _Wrapper, (DUP_X1, SWAP    /    DUP, DUP2_X2, POP2),
                                              INVOKESPECIAL <init>(_primitive)
                                              ASTORE n
                                 */

                        else if (instr instanceof de.fub.bytecode.generic.DSTORE)
                        {
                                newInstrs.add(ifactory.createNew(DOUBLE_TYPE));
                                //this is a two-byte type, use the second instruction path
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Double",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                                               {de.fub.bytecode.generic.Type.DOUBLE},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                newInstrs.add(ifactory.createStore(DOUBLE_TYPE, n));
                        }
                        else if (instr instanceof de.fub.bytecode.generic.FSTORE)
                        {
                                newInstrs.add(ifactory.createNew(FLOAT_TYPE));
                                //this is a one-byte type, use the first instruction path
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Float",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                                               {de.fub.bytecode.generic.Type.FLOAT},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                newInstrs.add(ifactory.createStore(FLOAT_TYPE, n));
                        }
                        else if (instr instanceof de.fub.bytecode.generic.ISTORE)
                        {
                            //if this is just a normal local variable
                            if (n >= argTypes.length + virtualOffset)
                            {
                                newInstrs.add(ifactory.createNew(INTEGER_TYPE));
                                //this is a one-byte type, use the first instruction path
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Integer",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                                               {de.fub.bytecode.generic.Type.INT},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                newInstrs.add(ifactory.createStore(INTEGER_TYPE, n));
                            }
                            else //n is a parameter... GARBAGE
                            {
                                de.fub.bytecode.generic.Type newType = argTypes[n-virtualOffset];
                                if (newType.equals(INTEGER_TYPE))
                                {
                                    newInstrs.add(ifactory.createNew(INTEGER_TYPE));
                                    //this is a one-byte type, use the first instruction path
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                    newInstrs.add
                                    (ifactory.createInvoke("java/lang/Integer",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                        {de.fub.bytecode.generic.Type.INT},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                    newInstrs.add(ifactory.createStore(INTEGER_TYPE, n));
                                }
                                else if (newType.equals(CHARACTER_TYPE))
                                {
                                    newInstrs.add(ifactory.createNew(CHARACTER_TYPE));
                                    //this is a one-byte type, use the first instruction path
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Character",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                        {de.fub.bytecode.generic.Type.CHAR},
                                                               de.fub.bytecode.Constants.INVOKESPECIAL)
                                         );
                                    newInstrs.add(ifactory.createStore(CHARACTER_TYPE, n));
                                }
                                else if (newType.equals(BOOLEAN_TYPE))
                                {
                                    newInstrs.add(ifactory.createNew(BOOLEAN_TYPE));
                                    //this is a one-byte type, use the first instruction path
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                    newInstrs.add
                                    (ifactory.createInvoke("java/lang/Boolean",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                        {de.fub.bytecode.generic.Type.BOOLEAN},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                    newInstrs.add(ifactory.createStore(BOOLEAN_TYPE, n));
                                }
                                else if (newType.equals(SHORT_TYPE))
                                {
                                    newInstrs.add(ifactory.createNew(SHORT_TYPE));
                                    //this is a one-byte type, use the first instruction path
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                    newInstrs.add
                                    (ifactory.createInvoke("java/lang/Short",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                        {de.fub.bytecode.generic.Type.SHORT},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                    newInstrs.add(ifactory.createStore(SHORT_TYPE, n));
                                }
                                else if (newType.equals(BYTE_TYPE))
                                {
                                    newInstrs.add(ifactory.createNew(BYTE_TYPE));
                                    //this is a one-byte type, use the first instruction path
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                    newInstrs.add
                                    (ifactory.createInvoke("java/lang/Byte",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                        {de.fub.bytecode.generic.Type.BYTE},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                    newInstrs.add(ifactory.createStore(BYTE_TYPE, n));
                                }
                                else
                                    throw new IllegalArgumentException("Can't istore " + newType);
                            }
                        }
                        else if (instr instanceof de.fub.bytecode.generic.LSTORE)
                        {
                                newInstrs.add(ifactory.createNew(LONG_TYPE));
                                //this is a two-byte type, use the second instruction path
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                                newInstrs.add
                                    (ifactory.createInvoke("java/lang/Long",
                                                           "<init>",
                                                           VOID_TYPE,
                                                           new de.fub.bytecode.generic.Type []
                                                               {de.fub.bytecode.generic.Type.LONG},
                                                           de.fub.bytecode.Constants.INVOKESPECIAL)
                                     );
                                newInstrs.add(ifactory.createStore(LONG_TYPE, n));
                        }

                    }

                    else if (instr instanceof de.fub.bytecode.generic.InvokeInstruction)
                    {
                        // INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL
                        // patch calls to modified methods

                        de.fub.bytecode.generic.InvokeInstruction invoke =
                            (de.fub.bytecode.generic.InvokeInstruction)instr;

                        String methodClassName = invoke.getClassName(cpgen);
                        String methodName = invoke.getMethodName(cpgen);
                        String methodSig = invoke.getSignature(cpgen);
                        String key = getMethodKey(methodClassName, methodName, methodSig);
                        if (DEBUG) System.out.println("LOOKUP: "  + key);
                        if (changedMethods.containsKey(key))
                        {
                            de.fub.bytecode.generic.MethodGen callee =
                                (de.fub.bytecode.generic.MethodGen)changedMethods.get(key);

                            de.fub.bytecode.generic.MethodGen oldCallee =
                                (de.fub.bytecode.generic.MethodGen)originalMethods.get(callee);


                            de.fub.bytecode.generic.Type [] newArgTypes = callee.getArgumentTypes();
                            de.fub.bytecode.generic.Type [] oldArgTypes = oldCallee.getArgumentTypes();

                            de.fub.bytecode.generic.Type  newRetType = callee.getReturnType();
                            de.fub.bytecode.generic.Type  oldRetType = oldCallee.getReturnType();

                        /*
                           if (method was one that we changed)
                             make new array of object[]
                             ---
                               PUSH numargs
                               ANEWARRAY 1

                             for each arg i at index n,
                               promote if necessary
                               put in slot [n] of array
                             ---
                               DUP_X1/2
                               PUSH index
                               DUP2_X1/2
                               POP2
                               if (need to promote)
                                 NEW _Wrapper
                                 (DUP_X1, SWAP    /    DUP, DUP2_X2, POP2)
                                 invoke <init>
                               AASTORE

                             for each index i in array,
                               push array[i]

                               DUP
                               PUSH index
                               AALOAD
                               SWAP


                             POP  // get array off stack

                             invoke
                         */

                            newInstrs.add(createPushInstruction(newArgTypes.length));
                            newInstrs.add(ifactory.createNewArray(de.fub.bytecode.generic.Type.OBJECT, (short)1));
                            for (int typei = oldArgTypes.length - 1; typei >= 0; typei--)
                            {

                                //these types are special when preparing the array to be stored into
                                if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.LONG ||
                                    oldArgTypes[typei] == de.fub.bytecode.generic.Type.DOUBLE)
                                {
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X2);
                                    newInstrs.add(createPushInstruction(typei));
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                                }
                                else
                                {
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                    newInstrs.add(createPushInstruction(typei));
                                    newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X1);
                                }
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);

                                //now we need to see if the type actually needs to be promoted
                                //NEW _Wrapper
                                //(DUP_X1, SWAP    /    DUP, DUP2_X2, POP2)
                                if (!(oldArgTypes[typei] instanceof de.fub.bytecode.generic.ReferenceType))
                                {
                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.INT)
                                    {
                                        newInstrs.add(ifactory.createNew(INTEGER_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Integer",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.INT},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }
                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.BOOLEAN)
                                    {
                                        newInstrs.add(ifactory.createNew(BOOLEAN_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Boolean",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.BOOLEAN},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }
                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.SHORT)
                                    {
                                        newInstrs.add(ifactory.createNew(SHORT_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Short",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.SHORT},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }
                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.BYTE)

                                    {
                                        newInstrs.add(ifactory.createNew(BYTE_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Byte",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.BYTE},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }
                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.CHAR)
                                    {
                                        newInstrs.add(ifactory.createNew(CHARACTER_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Character",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.CHAR},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }

                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.FLOAT)
                                    {
                                        newInstrs.add(ifactory.createNew(FLOAT_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Float",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.FLOAT},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }
                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.LONG)
                                    {
                                        newInstrs.add(ifactory.createNew(LONG_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Long",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.LONG},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }
                                    if (oldArgTypes[typei] == de.fub.bytecode.generic.Type.DOUBLE)
                                    {
                                        newInstrs.add(ifactory.createNew(DOUBLE_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Double",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                     {de.fub.bytecode.generic.Type.DOUBLE},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                    }
                                }
                                newInstrs.add(ifactory.createArrayStore(de.fub.bytecode.generic.Type.OBJECT));
                            }

                                /*
                                  for each index i in array,
                                    push array[i]

                                    DUP
                                    PUSH index
                                    AALOAD
                                    SWAP


                                  POP  // get array off stack

                                  invoke
                                */
                            for (int typei = 0; typei < newArgTypes.length; typei++)
                            {
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                newInstrs.add(createPushInstruction(typei));
                                newInstrs.add(ifactory.createArrayLoad(de.fub.bytecode.generic.Type.OBJECT));
                                newInstrs.add(ifactory.createCast(de.fub.bytecode.generic.Type.OBJECT, newArgTypes[typei]));
                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                            }

                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP);
                            newInstrs.add(ifactory.createInvoke(methodClassName,
                                                                callee.getName(),
                                                                newRetType,
                                                                newArgTypes,
                                                                opcode));

                            //remember to unwrap the changed return type
                            if (!(oldRetType instanceof de.fub.bytecode.generic.ReferenceType))
                            {
                                if (oldRetType == de.fub.bytecode.generic.Type.INT)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Integer",
                                                               "intValue",
                                                               de.fub.bytecode.generic.Type.INT,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                else if (oldRetType == de.fub.bytecode.generic.Type.BOOLEAN)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Boolean",
                                                               "booleanValue",
                                                               de.fub.bytecode.generic.Type.BOOLEAN,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                else if (oldRetType == de.fub.bytecode.generic.Type.SHORT)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Short",
                                                               "shortValue",
                                                               de.fub.bytecode.generic.Type.SHORT,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                else if (oldRetType == de.fub.bytecode.generic.Type.BYTE)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Byte",
                                                               "byteValue",
                                                               de.fub.bytecode.generic.Type.BYTE,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                else if (oldRetType == de.fub.bytecode.generic.Type.CHAR)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Character",
                                                               "charValue",
                                                               de.fub.bytecode.generic.Type.CHAR,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                else if (oldRetType == de.fub.bytecode.generic.Type.FLOAT)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Float",
                                                               "floatValue",
                                                               de.fub.bytecode.generic.Type.FLOAT,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                else if (oldRetType == de.fub.bytecode.generic.Type.DOUBLE)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Double",
                                                               "doubleValue",
                                                               de.fub.bytecode.generic.Type.DOUBLE,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                                else if (oldRetType == de.fub.bytecode.generic.Type.LONG)
                                    newInstrs.add
                                        (ifactory.createInvoke("java/lang/Long",
                                                               "longValue",
                                                               de.fub.bytecode.generic.Type.LONG,
                                                               de.fub.bytecode.generic.Type.NO_ARGS,
                                                               de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                         );
                            }

                        }
                        else
                            newInstrs.add(instr);

                    }
                   /* else if (instr instanceof de.fub.bytecode.generic.FieldInstruction)
                    {
                        de.fub.bytecode.generic.FieldInstruction fi =
                            (de.fub.bytecode.generic.FieldInstruction)instr;
                        String fieldName = fi.getFieldName(cpgen);
                        String fieldClassName = fi.getClassName(cpgen);
                        String key = fieldClassName + "." + fieldName;

                        if (!changedFields.containsKey(key))
                        {
                                        System.out.println(key + " in class " + className);
                            newInstrs.add(instr);
                        }
                        else
                        {
                            de.fub.bytecode.generic.Type fieldType =
                                (de.fub.bytecode.generic.Type)changedFields.get(key);

                            switch (opcode)
                                {

                                // GETFIELD, GETSTATIC, PUTFIELD, PUTSTATIC
                                // patch loads/stores to class's fields
*/
                                /*
                                  GETFIELD n  -> GETFIELD n,
                                                 (if old field was primitive)
                                                   INVOKEVIRTUAL _Value()

                                  GETSTATIC n -> GETSTATIC n,
                                                 (if old field was primitive)
                                                   INVOKEVIRTUAL _Value()

                                */
                        /*      case GETFIELD:
                                case GETSTATIC:

                                    if (fieldType == de.fub.bytecode.generic.Type.INT)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  INTEGER_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  INTEGER_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Integer",
                                                                   "intValue",
                                                                   de.fub.bytecode.generic.Type.INT,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }
                                    else if (fieldType == de.fub.bytecode.generic.Type.SHORT)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  SHORT_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  SHORT_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Short",
                                                                   "shortValue",
                                                                   de.fub.bytecode.generic.Type.SHORT,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }
                                    else if (fieldType == de.fub.bytecode.generic.Type.BOOLEAN)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  BOOLEAN_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  BOOLEAN_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Boolean",
                                                                   "booleanValue",
                                                                   de.fub.bytecode.generic.Type.BOOLEAN,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }
                                    else if (fieldType == de.fub.bytecode.generic.Type.BYTE)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  BYTE_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  BYTE_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Byte",
                                                                   "byteValue",
                                                                   de.fub.bytecode.generic.Type.BYTE,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.CHAR)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  CHARACTER_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  CHARACTER_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Character",
                                                                   "charValue",
                                                                   de.fub.bytecode.generic.Type.CHAR,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }

                                    if (fieldType == de.fub.bytecode.generic.Type.FLOAT)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  FLOAT_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  FLOAT_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Float",
                                                                   "floatValue",
                                                                   de.fub.bytecode.generic.Type.FLOAT,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.DOUBLE)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  DOUBLE_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  DOUBLE_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Double",
                                                                   "doubleValue",
                                                                   de.fub.bytecode.generic.Type.DOUBLE,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.LONG)
                                    {
                                        if (opcode == GETFIELD)
                                            newInstrs.add(ifactory.createGetField(fieldClassName,
                                                                                  fieldName,
                                                                                  LONG_TYPE));
                                        else //opcode == GETSTATIC
                                            newInstrs.add(ifactory.createGetStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  LONG_TYPE));
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Long",
                                                                   "longValue",
                                                                   de.fub.bytecode.generic.Type.LONG,
                                                                   de.fub.bytecode.generic.Type.NO_ARGS,
                                                                   de.fub.bytecode.Constants.INVOKEVIRTUAL)
                                             );
                                    }
                                    break;
*/
                                    /*
                                      PUTFIELD n  -> (if old field was primitive)
                                                       NEW _Wrapper, (DUP_X1, SWAP  /  DUP, DUP2_X2, POP2),
                                                       INVOKESPECIAL <init>(_primitive)
                                                       PUTFIELD n
                                    */
/*
                                case PUTFIELD:
                                case PUTSTATIC:
                                    if (fieldType == de.fub.bytecode.generic.Type.FLOAT)
                                    {
                                        newInstrs.add(ifactory.createNew(FLOAT_TYPE));
                                        //this is a one byte instruction, so do the first option
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Float",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.FLOAT},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  FLOAT_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  FLOAT_TYPE));

                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.INT)
                                    {
                                        newInstrs.add(ifactory.createNew(INTEGER_TYPE));
                                        //this is a one byte instruction, so do the first option
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Integer",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.INT},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  INTEGER_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  INTEGER_TYPE));

                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.BOOLEAN)
                                    {
                                        newInstrs.add(ifactory.createNew(BOOLEAN_TYPE));
                                        //this is a one byte instruction, so do the first option
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Boolean",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.BOOLEAN},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  BOOLEAN_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  BOOLEAN_TYPE));

                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.BYTE)
                                    {
                                        newInstrs.add(ifactory.createNew(BYTE_TYPE));
                                        //this is a one byte instruction, so do the first option
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Byte",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.BYTE},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  BYTE_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  BYTE_TYPE));

                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.SHORT)
                                    {
                                        newInstrs.add(ifactory.createNew(SHORT_TYPE));
                                        //this is a one byte instruction, so do the first option
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Short",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.SHORT},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  SHORT_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  SHORT_TYPE));

                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.CHAR)
                                    {
                                        newInstrs.add(ifactory.createNew(CHARACTER_TYPE));
                                        //this is a one byte instruction, so do the first option
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Character",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.CHAR},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  CHARACTER_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  CHARACTER_TYPE));
                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.DOUBLE)
                                    {
                                        newInstrs.add(ifactory.createNew(DOUBLE_TYPE));
                                        //this is a one byte instruction, so do DUP, DUP2_X2, POP2
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Double",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.DOUBLE},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  DOUBLE_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  DOUBLE_TYPE));

                                    }
                                    if (fieldType == de.fub.bytecode.generic.Type.LONG)
                                    {
                                        newInstrs.add(ifactory.createNew(LONG_TYPE));
                                        //this is a one byte instruction, so do DUP, DUP2_X2, POP2
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                                        newInstrs.add
                                            (ifactory.createInvoke("java/lang/Long",
                                                                   "<init>",
                                                                   VOID_TYPE,
                                                                   new de.fub.bytecode.generic.Type []
                                                                   {de.fub.bytecode.generic.Type.LONG},
                                                                   de.fub.bytecode.Constants.INVOKESPECIAL)
                                             );
                                        if (opcode == PUTFIELD)
                                            newInstrs.add(ifactory.createPutField(fieldClassName,
                                                                                  fieldName,
                                                                                  LONG_TYPE));
                                        else //opcode == PUTSTATIC
                                            newInstrs.add(ifactory.createPutStatic(fieldClassName,
                                                                                  fieldName,
                                                                                  LONG_TYPE));

                                    }
                                    break;
                                }
                        }
                    }*/
                    else if (instr instanceof de.fub.bytecode.generic.ReturnInstruction)
                    {
                                        if (!okToPromote(newMethodGen))
                                        {
                                                newInstrs.add(instr);
                                                continue;
                                        }



                        // make it return an object reference instead of old
                        // primitive type

                        if (instr instanceof de.fub.bytecode.generic.ARETURN ||
                            instr instanceof de.fub.bytecode.generic.RETURN)
                        {
                            // don't modify object / void returns
                            newInstrs.add(instr);
                        }
                        else if (instr instanceof de.fub.bytecode.generic.DRETURN)
                        {
                            newInstrs.add(ifactory.createNew(DOUBLE_TYPE));
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                            newInstrs.add
                                (ifactory.createInvoke("java/lang/Double",
                                                       "<init>",
                                                       VOID_TYPE,
                                                       new de.fub.bytecode.generic.Type []
                                    {de.fub.bytecode.generic.Type.DOUBLE},
                                                       de.fub.bytecode.Constants.INVOKESPECIAL)
                                 );
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.ARETURN);
                        }
                        else if (instr instanceof de.fub.bytecode.generic.LRETURN)
                        {
                            newInstrs.add(ifactory.createNew(LONG_TYPE));
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP);
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP2_X2);
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.POP2);
                            newInstrs.add
                                (ifactory.createInvoke("java/lang/Long",
                                                       "<init>",
                                                       VOID_TYPE,
                                                       new de.fub.bytecode.generic.Type []
                                    {de.fub.bytecode.generic.Type.LONG},
                                                       de.fub.bytecode.Constants.INVOKESPECIAL)
                                 );
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.ARETURN);
                        }
                        else if (instr instanceof de.fub.bytecode.generic.IRETURN)
                        {
                                        de.fub.bytecode.generic.Type retType = newMethodGen.getReturnType();

                                        if (retType.equals(INTEGER_TYPE))
                                        {
                                                newInstrs.add(ifactory.createNew(INTEGER_TYPE));
                                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                                newInstrs.add
                                                                                                (ifactory.createInvoke("java/lang/Integer",
                                                                                                "<init>",
                                                                                                VOID_TYPE,
                                                                                                new de.fub.bytecode.generic.Type []
                                                                                                        {de.fub.bytecode.generic.Type.INT},
                                                                                                de.fub.bytecode.Constants.INVOKESPECIAL)
                                         );
                                 }
                                 else if (retType.equals(CHARACTER_TYPE))
                                        {
                                                        newInstrs.add(ifactory.createNew(CHARACTER_TYPE));
                                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                                        newInstrs.add
                                                                                                        (ifactory.createInvoke("java/lang/Character",
                                                                                                        "<init>",
                                                                                                        VOID_TYPE,
                                                                                                        new de.fub.bytecode.generic.Type []
                                                                                                                {de.fub.bytecode.generic.Type.CHAR},
                                                                                                        de.fub.bytecode.Constants.INVOKESPECIAL)
                                                 );
                                         }
                                else if (retType.equals(BOOLEAN_TYPE))
                                {
                                        newInstrs.add(ifactory.createNew(BOOLEAN_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                                                                        (ifactory.createInvoke("java/lang/Boolean",
                                                                                        "<init>",
                                                                                        VOID_TYPE,
                                                                                        new de.fub.bytecode.generic.Type []
                                                                                                {de.fub.bytecode.generic.Type.BOOLEAN},
                                                                                        de.fub.bytecode.Constants.INVOKESPECIAL)
                                 );
                         }
                         else if (retType.equals(SHORT_TYPE))
                                {
                                        newInstrs.add(ifactory.createNew(SHORT_TYPE));
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                        newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                        newInstrs.add
                                                                                        (ifactory.createInvoke("java/lang/Short",
                                                                                        "<init>",
                                                                                        VOID_TYPE,
                                                                                        new de.fub.bytecode.generic.Type []
                                                                                                {de.fub.bytecode.generic.Type.SHORT},
                                                                                        de.fub.bytecode.Constants.INVOKESPECIAL)
                                 );
                         }
                         else if (retType.equals(BYTE_TYPE))
                                        {
                                                newInstrs.add(ifactory.createNew(BYTE_TYPE));
                                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                                                newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                                                newInstrs.add
                                                                                                (ifactory.createInvoke("java/lang/Byte",
                                                                                                "<init>",
                                                                                                VOID_TYPE,
                                                                                                new de.fub.bytecode.generic.Type []
                                                                                                        {de.fub.bytecode.generic.Type.BYTE},
                                                                                                de.fub.bytecode.Constants.INVOKESPECIAL)
                                         );
                                 }
                                else
                                {
                                        throw new IllegalArgumentException("ireturn expecting integer type got: " + retType);
                                }

                         newInstrs.add(de.fub.bytecode.generic.InstructionConstants.ARETURN);
                        }
                        else if (instr instanceof de.fub.bytecode.generic.FRETURN)
                        {
                            newInstrs.add(ifactory.createNew(FLOAT_TYPE));
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.DUP_X1);
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.SWAP);
                            newInstrs.add
                                (ifactory.createInvoke("java/lang/Float",
                                                       "<init>",
                                                       VOID_TYPE,
                                                       new de.fub.bytecode.generic.Type []
                                    {de.fub.bytecode.generic.Type.FLOAT},
                                                       de.fub.bytecode.Constants.INVOKESPECIAL)
                                 );
                            newInstrs.add(de.fub.bytecode.generic.InstructionConstants.ARETURN);
                        }
                    }

                    // *** put the new instructions in the instruction list :)
                    int numInstrs = newInstrs.size();
                    if (numInstrs >  0)
                    {

                        ihandle.setInstruction((de.fub.bytecode.generic.Instruction)newInstrs.get(0));
                        for (int ii = 1; ii < numInstrs; ii++)
                        {
                            de.fub.bytecode.generic.Instruction currInstr =
                                (de.fub.bytecode.generic.Instruction)newInstrs.get(ii);
                            instrList.append(ihandle, currInstr);
                            ihandle = ihandle.getNext();
                        }
                    }
                }



                // apply the changes
                newMethodGen.setInstructionList(instrList);
                newMethodGen.setMaxStack();
                newMethodGen.setMaxLocals();

                de.fub.bytecode.classfile.Method newMethod = newMethodGen.getMethod();
                cgen.replaceMethod(currMethod, newMethod);
            }

                        cgen.setAccessFlags(cgen.getAccessFlags() | de.fub.bytecode.Constants.ACC_SUPER);

/*                      de.fub.bytecode.generic.ClassGen accSupClassGen =
                                new de.fub.bytecode.generic.ClassGen(cgen.getClassName(),
                                                                                                                                                                                 cgen.getSuperclassName(),
                                                                                                                                                                                 cgen.getFileName(),
                                                                                                                                                                                 (cgen.getAccessFlags() | de.fub.bytecode.Constants.ACC_SUPER),
                                                                                                                                                                                 cgen.getInterfaceNames());
                        accSupClassGen.setConstantPool(cpgen);
                        accSupClassGen.setMethods(cgen.getMethods());

                        de.fub.bytecode.classfile.Field [] copyFields = cgen.getFields();

                        for (int fi = 0; fi < copyFields.length; fi++)
                                accSupClassGen.addField(copyFields[fi]);

*/

            de.fub.bytecode.classfile.JavaClass newClass = cgen.getJavaClass();

            cfc.addClass(newClass);
        }
        }
        catch(Exception e)
            {e.printStackTrace();}
        }

   
    /* Runs a quick test of this obfuscator. */
        public static void main(String[] args) throws Exception {
                if (args.length < 1) {
                        System.out.println("Usage: PrimitivePromoter JAR_FILE");
                        System.exit(1);
                }

                try {
                        utils.ClassFileCollection cfc = new utils.ClassFileCollection(args[0]);
                       PrimitivePromoter promoter =  new PrimitivePromoter();
                        promoter.apply(cfc);
                        
                        cfc.saveJar("HARDCODE.jar");
                } catch (java.io.IOException e) {
                        System.err.println("I/O Error: " + e.getMessage());
                }
        }


}

