

package algorithms ;
import EDU.purdue.cs.bloat.util.*;
import java.util.*;

import algorithms.Gnode;
/**
@ Class: MethodCloning
@ Author: Suma Venkatesh
@ Description: Control Aggregation is a kind of control transformation changes the way in which program statements 
  are grouped together. Cloned methods transformations are one kind of control aggregation                                          *
*/

public class MethodCloning  {
    private EDU.purdue.cs.bloat.file.ClassFile classFile=null;
    private EDU.purdue.cs.bloat.file.ClassFile superClassFile=null;
    private EDU.purdue.cs.bloat.file.ClassFile subClassFile=null;

    private EDU.purdue.cs.bloat.reflect.ClassInfo classInfo=null;
    private EDU.purdue.cs.bloat.reflect.ClassInfo superInfo=null;
    private EDU.purdue.cs.bloat.reflect.ClassInfo subInfo=null;

    private EDU.purdue.cs.bloat.file.ClassFileLoader cfl=null;
    private EDU.purdue.cs.bloat.file.ClassFileLoader subLoader=null;
    private EDU.purdue.cs.bloat.file.ClassFileLoader superLoader=null;

    //private utils.DependencyGraph depGraph=null;
    private EDU.purdue.cs.bloat.util.Graph dep=null;

    private utils.Editor editor=null;
    private EDU.purdue.cs.bloat.editor.ClassEditor classEditor=null;

    private EDU.purdue.cs.bloat.file.Method[] methods=null;
    private EDU.purdue.cs.bloat.file.Field[] fields=null;

    private java.util.List superClassList=null;
    private java.util.List subClassList=null;

    private String className=null;
    private String myVarName=null;

    private int canSplit=0;int count=0;
    private int count_name;

    private ArrayList[] level=null;
    private EDU.purdue.cs.bloat.file.ClassFileLoader[] loader=null;
    private EDU.purdue.cs.bloat.reflect.ClassInfo[] info=null;
    private EDU.purdue.cs.bloat.file.ClassFile[] newclassFile=null;
    private int[] type_index=null;

    private void  top_sort()   {

		count =0;
		EDU.purdue.cs.bloat.util.Graph d=dep;
		java.util.ArrayList c=new java.util.ArrayList();
		java.util.List list = dep.preOrder();
        java.util.ListIterator li = list.listIterator();

	 	/*************************************************************************
		 * BLOAT Graph's roots()function doesn't work; so an equal implementation*
		 * is as given below 													 *
		 *************************************************************************/
            while(li.hasNext())
            {
                  Gnode gn = (Gnode)li.next();

				  if(d.preds(gn).isEmpty())
		  		  {
		      		c.add(gn);
		  		  }

          		  java.util.ListIterator li2 = list.listIterator();
                  while (li2.hasNext())
                  {
                        Gnode gn2 = (Gnode)li2.next();
						if ( dep.hasEdge((GraphNode)gn,(GraphNode)gn2))
			   			{} 
                  }

	    	}

		java.util.Set s = d.keySet();
		java.util.Iterator rootIterator = c.iterator();
       	java.util.Iterator keyIterator = s.iterator();
		int i=0;
		int cop =d.size();
		level = new ArrayList[d.size()];

		while(!c.isEmpty())
		{
	    	level[i] = new ArrayList();
		    java.util.Iterator tempiter= c.iterator();


		    while(rootIterator.hasNext())
		    {

		       Gnode gn = (Gnode)rootIterator.next();
		       while(keyIterator.hasNext())
		       {

			     Object tempkey= keyIterator.next();
			     Gnode keynode= (Gnode)d.getNode(tempkey);

				   if(gn.getName().equals(keynode.getName()))
				   {

				       level[i].add(gn.getName());
				       d.removeNode(tempkey);
		       		   break;
	       	       }

	       	   }

			   keyIterator = d.keySet().iterator();
	         }

		    c.clear();
		    list = dep.preOrder();
		    li = list.listIterator();
		    while(li.hasNext())
            {
                  Gnode gn = (Gnode)li.next();

				  if(d.preds(gn).isEmpty())
				  {
				      c.add(gn);
				  }
		    }

		   rootIterator = c.iterator();
	       count++;
	       i++;

        }// end of while

        if(d.size()>0)
        {
                level[count] = new ArrayList();
           while(keyIterator.hasNext())
	       {

			   Object tempkey= keyIterator.next();
			   Gnode keynode= (Gnode)d.getNode(tempkey);
			   level[count].add(keynode.getName());
               keyIterator.remove();

	       }
                 count++;
        }
		i=0;

        if(count > 1 )
                canSplit =1;

    }
    /**
	 *  Extracts a class as a BLOAT ClassFile.
	 */
	public EDU.purdue.cs.bloat.file.ClassFile getClassFile(String classname) throws ClassNotFoundException {
		EDU.purdue.cs.bloat.file.ClassFileLoader cfl = new EDU.purdue.cs.bloat.file.ClassFileLoader();  // BLOAT loader
		EDU.purdue.cs.bloat.file.ClassFile classFile = (EDU.purdue.cs.bloat.file.ClassFile) cfl.loadClass("examples/"+ classname);

	    return (classFile);
    }


    private void splitmethods(utils.ClassFileCollection cfc, String classname)
    {
	String classpath="";
	try {
	    className = classname;
   	    classFile = getClassFile(classname);

	    classInfo = classFile.loader().loadClass(classname);
	    System.out.println("Iam here in init" + count);
	    java.util.List classes = new java.util.ArrayList();
	    classes.add(classname);


	    editor = new utils.Editor(classFile.loader(),classes);
	    classEditor = new EDU.purdue.cs.bloat.editor.ClassEditor(editor,classInfo);

	    cfl = cfc.getLoader();
	    EDU.purdue.cs.bloat.editor.Type[] type=classEditor.interfaces();

	    /* We dont split classes which already have multiple inheritance */
        if(type.length>0){
				 System.out.println("Iam here");
		return;
	    }

	  


	    System.gc();
	    top_sort();
        if(canSplit==1){
          canSplit=0;
		newclassFile = new EDU.purdue.cs.bloat.file.ClassFile[count];
		loader = new EDU.purdue.cs.bloat.file.ClassFileLoader[count];
		info = new  EDU.purdue.cs.bloat.reflect.ClassInfo[count];
        type_index = new  int[count];
		classpath = cfc.getClassPath();

		for(int i=0;i<count-1;i++){
		    cloneClass(classpath,i);
		    System.out.println("Cloning " + i);
		    trimClass(i);
		}

		System.out.println("Cloning " + (count-1));
		trimClass(count-1);

		try {

		    for(int x=0;x<count-1;x++){
			

			EDU.purdue.cs.bloat.file.ClassFile cf = cfc.getClassFile(className+String.valueOf(x)+".class");
			cfc.addClass(cf);
			de.fub.bytecode.classfile.JavaClass jClass = getClass(className+String.valueOf(x)+".class");
			/*addClass(jClass);
			convertToHTML(jClass,"Obf");*/
	    }
	}
	catch (Exception e){
	    System.out.println("Exception inside:::" + e);
	}
  }
}
catch (ClassNotFoundException ex){
    //System.out.println("Exception :::"+ ex.getMessage());
}
 }

    /***********************************************************************
     * trimclass trims the classfile 's contents to hold only those fields *
     * and methods that the topological sort of the DG asks it to have .   *
     ***********************************************************************/

    void trimClass(int i)
    {
	EDU.purdue.cs.bloat.file.ClassFile tempclassfile;
	EDU.purdue.cs.bloat.reflect.ClassInfo tempclassinfo;
        int s=2;

        if (i==count-1){
	    tempclassfile = classFile;
	    tempclassinfo = classInfo;
	}
	else{
	    tempclassfile = newclassFile[i];
	    tempclassinfo = info[i];
	}

	java.util.List classes = new java.util.ArrayList();
	utils.Editor neweditor = new utils.Editor(tempclassfile.loader(),classes);
	EDU.purdue.cs.bloat.editor.ClassEditor newclassEditor = new EDU.purdue.cs.bloat.editor.ClassEditor(neweditor,tempclassinfo);
	EDU.purdue.cs.bloat.editor.ConstantPool constantPool = newclassEditor.constants();
	EDU.purdue.cs.bloat.reflect.Constant[] constants = constantPool.constants();
	EDU.purdue.cs.bloat.reflect.Constant[] newConstants = new EDU.purdue.cs.bloat.reflect.Constant[constants.length+s];


	EDU.purdue.cs.bloat.editor.FieldEditor newfe=null;
    EDU.purdue.cs.bloat.reflect.ClassInfo newinfo = null;
    EDU.purdue.cs.bloat.reflect.FieldInfo finfo = null;
	EDU.purdue.cs.bloat.editor.MethodEditor newme=null;
	ListIterator li = level[i].listIterator();
	fields = (EDU.purdue.cs.bloat.file.Field[])tempclassfile.fields();
	methods = (EDU.purdue.cs.bloat.file.Method[])tempclassfile.methods();
    int flag=0;
	for ( int j=0;j<fields.length;j++){
	    newfe = new EDU.purdue.cs.bloat.editor.FieldEditor(newclassEditor,fields[j]);
        newinfo = fields[j].declaringClass();

	    flag = 0;

	    li = level[i].listIterator();
	    while(li.hasNext()){
	    	String temp = (String)li.next();
	    	if ( newfe.name().equals(temp)){
	    		flag = 1;
	    	}
	    }

	    if (flag==0)
		{
		    newfe.delete();
		}

		    newfe.commit();
	 }
	for ( int j=0;j<methods.length;j++)
	{
	    newme = new EDU.purdue.cs.bloat.editor.MethodEditor(newclassEditor,methods[j]);
	    flag = 0;
	    String temp = new String(newme.name());
	    if( (temp.compareTo("<init>") == 0 ) ||(temp.compareTo("<clinit>")==0 )) //(temp.compareTo("main") == 0) ||
			continue;
        if (temp.compareTo("main") == 0 && i == count-1)
            continue;
        li = level[i].listIterator();
	    while(li.hasNext())
	    {
			String temp1 = (String)li.next();
			if ( newme.name().equals(temp1))
			{
			    flag = 1;
			}

	    }

	    if (flag==0)
	    {
			newme.delete();
	    }

    	newme.commit();
	}
    if(i== count-1)
     {
	for(int k = 0; k < constants.length; k++)
	        newConstants[k] = constants[k];
	
			// add a new entry at the end of the array containing the desired new name of the class.
	        String newName = new String(className+String.valueOf(i-1));
	        newConstants[constants.length] = new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.UTF8, className);
	        // change the classindex to point to the new names of the class.
	        newConstants[tempclassfile.classIndex()] =
	        	new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.CLASS, new Integer(constants.length));
	        newConstants[constants.length+1] =
	        	new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.UTF8,className+String.valueOf(i-1) );
	        newConstants[tempclassfile.superclassIndex()] =
	        	new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.CLASS, new Integer(constants.length+1));
	        // save the new constants and write out the class to the name file.
	        tempclassfile.setConstants(newConstants);
	        tempclassfile.commit();
	}
	editor.commit();
	tempclassfile.commit();

   }


    /**********************************************************************
     * cloneClass creates copies of the original class by copying all the *
     * constants in the constantPool of the original file				  *
     **********************************************************************/
    public void cloneClass(String classPath,int i)
    {
      try {
			  loader[i] = new EDU.purdue.cs.bloat.file.ClassFileLoader();
			  loader[i].setClassPath(classPath);
			  info[i] = loader[i].loadClass(className);
      	  }
      catch (ClassNotFoundException ex)
      	  {
      			System.err.println(ex.getMessage());
      	  }

      newclassFile[i] = (EDU.purdue.cs.bloat.file.ClassFile)info[i];

      EDU.purdue.cs.bloat.editor.ConstantPool constantPool = classEditor.constants();
      EDU.purdue.cs.bloat.reflect.Constant[] constants = constantPool.constants();
      EDU.purdue.cs.bloat.reflect.Constant[] newConstants=null ;
      int s;

      if ( i == 0 )
        s=1;
      else s=2;

      newConstants= new EDU.purdue.cs.bloat.reflect.Constant[constants.length+s];
      // Copy all the old entries into the new array.
      for(int k = 0; k < constants.length; k++)
         newConstants[k] = constants[k];

      // add a new entry at the end of the array containing the desired new name
      // of the class.
      String newName="";

      newName = new String(className+String.valueOf(i));

      newConstants[constants.length] = new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.UTF8, newName);


      // change the classindex to point to the new names of the class.
      if ( i!=count-1)
      	newConstants[newclassFile[i].classIndex()] =
      	   new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.CLASS, new Integer(constants.length));

      if ( i!=0){
	 	newConstants[constants.length+1] =
	 	    new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.UTF8,className+String.valueOf(i-1) );
	 	newConstants[newclassFile[i].superclassIndex()] =
	 	    new EDU.purdue.cs.bloat.reflect.Constant(EDU.purdue.cs.bloat.reflect.Constant.CLASS, new Integer(constants.length+1));
      }
      // save the new constants and write out the class to the name file.
      newclassFile[i].setConstants(newConstants);
      newclassFile[i].commit();
   }

    
    public de.fub.bytecode.classfile.JavaClass getClass(String classname) throws java.io.IOException {
		java.io.File f = new java.io.File("C:/JavaMark/examples/TestClassSplitter.class");
	    de.fub.bytecode.classfile.ClassParser p = new de.fub.bytecode.classfile.ClassParser(f.getPath());
	    return p.parse();
   }
   public static void convertToHTML(de.fub.bytecode.classfile.JavaClass clazz,String type)   throws java.io.IOException {
   	   de.fub.bytecode.util.Class2HTML conObj = new de.fub.bytecode.util.Class2HTML(clazz,"C:/JavaMark/Obfuscated_Classes/HTMLFiles/" + type);
   }

    /**
     *  Adds or replaces a class in this collection, given a JavaClass.
   	 */
   	public void addClass(de.fub.bytecode.classfile.JavaClass c) throws java.io.IOException {
   		c.dump(new java.io.File("C:/JavaMark/Obfuscated_Classes/examples/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
    }
    

    /**

	@param	classname
    */
    public boolean apply(String classname) throws Exception
    {
		boolean sucess = false;
		utils.ClassFileCollection cfc = new utils.ClassFileCollection();
		de.fub.bytecode.classfile.JavaClass jClass = null;
		jClass = getClass(classname);
		cfc.addClass(jClass);

        count = 0;
        canSplit = 0;
        level = null;
	    splitmethods(cfc,classname);
	    System.out.println("After Intitialize" );
	    
		sucess = true;
		return sucess;
    }

    




}
