package algorithms;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import org.apache.bcel.util.Class2HTML;


/**
@ Class: MethodInLiner
@ Author: Suma Venkatesh
@ Description:   By using this algorithm entire method body is substituted for the method call
*/

public class MethodInLiner {

	public boolean apply(String classname ) {
		ClassGen cgen = null;
		boolean sucess = false;
		try {
			JavaClass clazz = Repository.lookupClass("examples/" + classname);
		    cgen = new ClassGen(clazz);
			inlineMethod(classname);
			sucess = true;
		}
	    catch(Exception e) {System.out.println("Exception" +e.getMessage()+e.fillInStackTrace()); return(sucess);}
		return(sucess);
	}



	 public void inlineMethod(String className)throws Exception {
		try {
			EDU.purdue.cs.bloat.file.ClassFileLoader cfl = new EDU.purdue.cs.bloat.file.ClassFileLoader();  // BLOAT loader
			EDU.purdue.cs.bloat.file.ClassFileLoader classFileLoader = new EDU.purdue.cs.bloat.file.ClassFileLoader();
			EDU.purdue.cs.bloat.reflect.ClassInfo info = null;
			EDU.purdue.cs.bloat.file.ClassFile classFile = (EDU.purdue.cs.bloat.file.ClassFile) cfl.loadClass("examples/" + className);
			
			String tmpclassName = "C:/JHide/examples/"  + className + "_tmp.class";
		
			File orgFile =	new File("C:/JHide/examples/" + className+".class");
			File tmpFile =	new File("C:/JHide/examples/" + tmpclassName);
			
			
			info = cfl.loadClass("examples/"+ className);

            //Parse the instructions in the JavaClass for methods which have a method call from one method to another.
			EDU.purdue.cs.bloat.file.Method[] methods  =(EDU.purdue.cs.bloat.file.Method [])info.methods();
			EDU.purdue.cs.bloat.context.PersistentBloatContext bloatContext = new EDU.purdue.cs.bloat.context.PersistentBloatContext(classFile.loader());
			EDU.purdue.cs.bloat.editor.ClassEditor classEditor = new  EDU.purdue.cs.bloat.editor.ClassEditor(bloatContext,info);
			EDU.purdue.cs.bloat.inline.Inline inline = new EDU.purdue.cs.bloat.inline.Inline( bloatContext,20);
			for (int k=0; k < methods.length; k++) {

				EDU.purdue.cs.bloat.reflect.MethodInfo[] methodInfo =classEditor.methods();
				EDU.purdue.cs.bloat.editor.MethodEditor me = bloatContext.editMethod(methodInfo[k]);
				//call inline of bloat api call.
				inline.inline(me);
				System.out.println(" Inlining Complete for Method :: " + methods[k].toString());
				me.commit();
				System.out.println(methods[k].code().toString());
			}
			bloatContext.commit();
			classFile.commit();


			JavaClass clazz =  Repository.lookupClass("examples/" + className);
			clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
			
			tmpFile.renameTo(orgFile);
			convertToHTML(clazz,"Obf");


		 } catch(Exception e) { System.out.println("Exception" +e.getMessage() + e.fillInStackTrace()); }


	 }//MethodInLiner
	 
	 public static void copy(String inFile, String outFile)
     throws IOException {

      FileInputStream fin = null;
      FileOutputStream fout = null;

      try {
        fin  = new FileInputStream(inFile);
        fout = new FileOutputStream(outFile);
        StreamCopier(fin, fout);
      }
      finally {
        try {
          if (fin != null) fin.close();
        }
        catch (IOException e) {System.out.println("Exception " +e );}
        try {
          if (fout != null) fout.close();
         }
        catch (IOException e) { System.out.println("Exception " +e ); }
      }

    }

    public static void StreamCopier(InputStream in, OutputStream out)
       throws IOException {

        synchronized (in) {
          synchronized (out) {

            byte[] buffer = new byte[256];
            while (true) {
              int bytesRead = in.read(buffer);
              if (bytesRead == -1) break;
              out.write(buffer, 0, bytesRead);
            }
          }
        }
    }


	 public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
	  		   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);

	 }


}