package algorithms ;

/**
@ Class: NodeSplitter
@ Author: Suma Venkatesh
@ Description: This algorithm splits data structures like arrays and places them in two separate class files
*/

public class NodeSplitter {

    private de.fub.bytecode.generic.ClassGen cg1;
    private de.fub.bytecode.generic.ClassGen cg2;
    private de.fub.bytecode.generic.ClassGen cg3;
    private de.fub.bytecode.generic.FieldGen fg1;
    private de.fub.bytecode.generic.FieldGen fg2;
    private de.fub.bytecode.generic.ConstantPoolGen cpg1;
    private de.fub.bytecode.generic.ConstantPoolGen cpg2;
    private de.fub.bytecode.generic.ConstantPoolGen cpg3;
    private de.fub.bytecode.classfile.JavaClass jc1;
    private de.fub.bytecode.classfile.JavaClass jc2;

    private de.fub.bytecode.classfile.Field field1[];
    private de.fub.bytecode.classfile.Field field2[];
    private de.fub.bytecode.classfile.Method methods1[];
    private de.fub.bytecode.classfile.Method methods2[];
    private String classname1,classname2,fname;
    int count=0;
    String signature=null;
    java.util.ArrayList indexlist[];

    public void splitNodes(String classname) {
	   System.out.println("Processing "+classname);
       classname1 = classname;
       classname2 = classname+"1";
       fname = "next";
       try {
       		jc1 = getClass(classname);
       		jc2 = getClass(classname);
       }
       catch(java.io.IOException ioe) {
       		ioe.printStackTrace();
       }
       cg1 = new de.fub.bytecode.generic.ClassGen(jc1);
       cg2 = new de.fub.bytecode.generic.ClassGen(jc2);
       cg2.setClassName(classname2);

       field1 = cg1.getFields();
       field2 = cg2.getFields();
       methods2 = cg2.getMethods();
       methods1 = cg1.getMethods();
       cpg1 = cg1.getConstantPool();

    }

    private void trimFields() {
        
    	count = field1.length;
        for ( int i=0;i< count/2 ; i++)	{
	   	    cg2.removeField(field2[i]);
        }
        for (int i=count/2;i<count;i++)	{
	        cg1.removeField(field1[i]);
        }
        for (int i=0;i<methods2.length;i++)	{
        	cg2.removeMethod(methods2[i]);
        }
        cg2.addEmptyConstructor(de.fub.bytecode.Constants.ACC_PUBLIC);
    }
    private void addNewField() {
    	de.fub.bytecode.generic.ObjectType type = new de.fub.bytecode.generic.ObjectType(classname2);
    	fg1 = new de.fub.bytecode.generic.FieldGen(de.fub.bytecode.Constants.ACC_PUBLIC,type,fname,cpg1);
		cg1.addField(fg1.getField());
		cpg1.addMethodref(classname2,"<init>","()V");
		signature = fg1.getSignature();
		cpg1.addFieldref(classname1,fname,signature);
		int classref = cpg1.lookupClass(classname2);
		int index = cpg1.lookupFieldref(classname1,fname,signature);
		int methodref = cpg1.lookupMethodref(classname2,"<init>","()V");
		de.fub.bytecode.generic.MethodGen mg = null;
		indexlist = new java.util.ArrayList[count/2 +1];
		for (int i=count/2;i<count;i++)
	        {
		    int temp1 = cpg1.lookupFieldref(classname1,field1[i].getName(),field1[i].getSignature());
		    int temp2 =cpg1.addFieldref(classname2,field1[i].getName(),field1[i].getSignature());
		    indexlist[i-count/2] = new java.util.ArrayList();
		    indexlist[i-count/2].add(new Integer(temp1));
		    indexlist[i-count/2].add(new Integer(temp2));
		}

		for (int i=0;i<methods1.length;i++) {
		     if ( methods1[i].getName().equals("<init>") ) {
	
				 mg = new de.fub.bytecode.generic.MethodGen(methods1[i],classname1,cpg1);
				 de.fub.bytecode.generic.InstructionList il = mg.getInstructionList();
				 System.out.println(il.toString());
				 de.fub.bytecode.generic.InstructionList ilnew = new de.fub.bytecode.generic.InstructionList();
				 ilnew.append(new de.fub.bytecode.generic.ALOAD(0));
				 ilnew.append(new de.fub.bytecode.generic.NEW(classref));
				 ilnew.append(new de.fub.bytecode.generic.DUP());
				 ilnew.append(new de.fub.bytecode.generic.INVOKESPECIAL(methodref));
				 ilnew.append(new de.fub.bytecode.generic.PUTFIELD(index));
				 il.insert(il.findHandle(4),ilnew);
		
				 mg.setInstructionList(il);
				 mg.setMaxStack();
		
				 cg1.replaceMethod(methods1[i],mg.getMethod());
	
		     }
	
		}
		cg1.setConstantPool(cpg1);
    }

    private void dump()
    {
		try{
		    addClass(cg1.getJavaClass());
		    addClass(cg2.getJavaClass());
		    convertToHTML(cg1.getJavaClass(),"Obf");
		    convertToHTML(cg2.getJavaClass(),"Obf");
	
		}
		catch(java.io.IOException ioe) {
		    ioe.printStackTrace();
		}
    }
    private void adjustReadReferences() {
	    de.fub.bytecode.generic.MethodGen mg = null;
		de.fub.bytecode.generic.InstructionList il = null;
		de.fub.bytecode.generic.Instruction inst[] = null;
		int pos[] = null;
		boolean flag=false;
		int addcount = 0;
		int newindex=cpg1.lookupFieldref(classname1,fname,signature);
		for (int i=count/2;i<count;i++)	{

		    int index = cpg1.lookupFieldref(classname1,field1[i].getName(),field1[i].getSignature());
		    methods1 = cg1.getMethods();
	    for (int j=0;j<methods1.length;j++) {
			mg = new de.fub.bytecode.generic.MethodGen(methods1[j],classname1,cpg1);
		    il = mg.getInstructionList();
			inst = il.getInstructions();
			pos=il.getInstructionPositions();
			addcount=0;
		for (int k=0;k<inst.length;k++){

		    // Check if the opcode is Getstatic or GetField Instruction
		    int opcode = inst[k].getOpcode();
		    if (opcode == 180||opcode == 178) {
			de.fub.bytecode.generic.CPInstruction cpi =
			    (de.fub.bytecode.generic.CPInstruction)inst[k];

			int length1,length2;
			if (cpi.getIndex()==index) {
			    de.fub.bytecode.generic.InstructionList ilnew=
				new de.fub.bytecode.generic.InstructionList();
			    Integer replindex = (Integer)indexlist[i-count/2].get(1);
			    if ( opcode == 180)
			    {
				ilnew.append(new de.fub.bytecode.generic.GETFIELD(newindex));


				//Integer replindex = (Integer)indexlist[i-count/2].get(1);

				ilnew.append(new de.fub.bytecode.generic.GETFIELD(replindex.intValue()));


				length1 = (new de.fub.bytecode.generic.GETFIELD(newindex)).getLength();

				length2 = (new de.fub.bytecode.generic.GETFIELD(replindex.intValue())).getLength();
			    }
			    else
			    {
				ilnew.append(new de.fub.bytecode.generic.GETSTATIC(replindex.intValue()));
				length1 = (new de.fub.bytecode.generic.GETSTATIC(replindex.intValue())).getLength();
				length2=0;
			    }
			    try {
			    il.delete(il.findHandle(pos[k]+addcount));
			    }
			    catch(Exception e){
				e.printStackTrace();
			    }

			    il.insert(il.findHandle(pos[k]+addcount),ilnew);

			    addcount+=length1+length2-cpi.getLength();
			    flag =true;


			}
		    }

		}
		if (flag){
		    mg.setInstructionList(il);
		    mg.setMaxStack();
		    cg1.replaceMethod(methods1[j],mg.getMethod());
		    flag = false;
		}
     }
	}
   }
 
    private void adjustWriteReferences()   {
			de.fub.bytecode.generic.MethodGen mg = null;
			de.fub.bytecode.generic.InstructionList il = null;
			de.fub.bytecode.generic.Instruction inst[] = null;
			int pos[];
			boolean flag=false;
			int newindex=cpg1.lookupFieldref(classname1,fname,signature);
			for (int i=count/2;i<count;i++)
			{
		
			    int index = cpg1.lookupFieldref(classname1,field1[i].getName(),field1[i].getSignature());
			    methods1 = cg1.getMethods();
			    for (int j=0;j<methods1.length;j++)
			    {
				mg = new de.fub.bytecode.generic.MethodGen(methods1[j],classname1,cpg1);
			    	il = mg.getInstructionList();
				inst = il.getInstructions();
				pos=il.getInstructionPositions();
				int addcount=0;
				for (int k=0;k<inst.length;k++)
				{
		
				    // Check if the opcode is putfield or putstatic Instruction
				    int opcode = inst[k].getOpcode();
				    if (opcode == 181 || opcode == 179) {
					de.fub.bytecode.generic.CPInstruction cpi =
					    (de.fub.bytecode.generic.CPInstruction)inst[k];
		
					int length1,length2,length3;
					if (cpi.getIndex()==index) {
					    de.fub.bytecode.generic.InstructionList ilnew=
						new de.fub.bytecode.generic.InstructionList();
					    Integer replindex = (Integer)indexlist[i-count/2].get(1);
					    if ( opcode == 181)
					    {
						ilnew.append(new de.fub.bytecode.generic.SWAP());
		
						//Integer replindex = (Integer)indexlist[i-count/2].get(1);
						ilnew.append(new de.fub.bytecode.generic.GETFIELD(newindex));
						ilnew.append(new de.fub.bytecode.generic.SWAP());
						ilnew.append(new de.fub.bytecode.generic.PUTFIELD(replindex.intValue()));
		
					        length1 = (new de.fub.bytecode.generic.GETFIELD(newindex)).getLength();
						length2 = (new de.fub.bytecode.generic.PUTFIELD(replindex.intValue())).getLength();
						length3=2;
					    }
					    else
					    {
						ilnew.append(new de.fub.bytecode.generic.PUTSTATIC(replindex.intValue()));
						length2 = (new de.fub.bytecode.generic.PUTSTATIC(replindex.intValue())).getLength();
						length1=0;
						length3 = 0;
					    }
					    try {
						 il.delete(il.findHandle(pos[k]+addcount));
					    }
					    catch(Exception e){
						e.printStackTrace();
					    }
		
					    il.insert(il.findHandle(pos[k]+addcount),ilnew);
		
					    addcount+=length1+length2+length3-cpi.getLength();
					    flag =true;
		
		
					}
				  }
		
				}
				if (flag){
				   
				    mg.setInstructionList(il);
				    mg.setMaxStack();
				    cg1.replaceMethod(methods1[j],mg.getMethod());
		
				    flag = false;
				}
			    }
			}
    }

    
    public boolean apply(String classname) throws Exception {
			boolean sucess = false;
			
			de.fub.bytecode.classfile.JavaClass jClass = null;
			jClass = getClass(classname);
			splitNodes(classname);
			trimFields();
			addNewField();
			adjustReadReferences();
			adjustWriteReferences();
			dump();
			sucess = true;
			return sucess;

    }
    public de.fub.bytecode.classfile.JavaClass getClass(String classname) throws java.io.IOException {
			//java.io.File f = new java.io.File("C:/JHide/examples/TestNodeSplitter.class");
			java.io.File f = new java.io.File("C:/JHide/examples/" + classname + ".class");
		    de.fub.bytecode.classfile.ClassParser p = new de.fub.bytecode.classfile.ClassParser(f.getPath());
		    return p.parse();
	}
	public static void convertToHTML(de.fub.bytecode.classfile.JavaClass clazz,String type)   throws java.io.IOException {
	   	    de.fub.bytecode.util.Class2HTML conObj = new de.fub.bytecode.util.Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
	}

	/**
	 *  Adds or replaces a class in this collection, given a JavaClass.
	 */
	public void addClass(de.fub.bytecode.classfile.JavaClass c) throws java.io.IOException {
			c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
	}
	

   

}









