package algorithms;

import org.apache.bcel.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import java.util.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: ParameterReordering
@ Author: Suma Venkatesh
@ Description:   This algorithm changes the orders of method parameters.
*/

public class ParameterReordering {

	public boolean apply(String classname) {
		ClassGen cgen = null;
		boolean sucess = false;
		try {
			 JavaClass clazz = Repository.lookupClass("examples/" + classname);
			 cgen = new ClassGen(clazz);
 	    	 ConstantPoolGen cpg = cgen.getConstantPool();
	         cgen = reorderParameteres(cgen,cpg,classname);

			 JavaClass c = cgen.getJavaClass();
			 c.dump(new java.io.File("C:/JHide/Obfuscated_Classes",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf" +".class"));
			 convertToHTML(c,"Obf");
			 sucess = true;

	     }
	     catch(Exception e) {return(sucess);}
		 return(sucess);

     }

     public static ClassGen reorderParameteres(ClassGen cgen,ConstantPoolGen cpg,String className) {

		 int numMethods = cgen.getMethods().length;
		  for (int methodNum = 0;  methodNum < numMethods;  methodNum++) {
			  Method meth = cgen.getMethodAt(methodNum);
			  MethodGen methGen  = new MethodGen(meth, className, cpg);

			  String[] oldArgNames = methGen.getArgumentNames();
			  Type[] oldArgTypes   = methGen.getArgumentTypes();
			  int numArgs = oldArgNames.length;

			  // don't rearrange parameters for methods with less than 2 args
			  if (numArgs <= 1) {
			     continue;
              }

              ArrayList argNums = new ArrayList();
              for (int ii = 0; ii < numArgs; ii++)
			      argNums.add(new Integer(ii));
			  Collections.shuffle(argNums);

			  String[] newArgNames = new String[numArgs];
			  Type[] newArgTypes = new Type[numArgs];
			  int[] indeces = new int[numArgs];
			  int[] newIndeces = new int[numArgs];
			  for (int oldIndex = 0; oldIndex < numArgs; oldIndex++)  {
			      Integer inewIndex = (Integer)argNums.get(oldIndex);
			      int newIndex = inewIndex.intValue();
			      // remap the arguments by their new indeces
			      indeces[newIndex] = oldIndex;
			      newIndeces[oldIndex] = newIndex;
			      newArgNames[newIndex] = oldArgNames[oldIndex];
			      newArgTypes[newIndex] = oldArgTypes[oldIndex];
			  }
			   // apply the changes to the arg names/types
			  methGen.setArgumentNames(newArgNames);
              methGen.setArgumentTypes(newArgTypes);
              Method newMeth = methGen.getMethod();
              cgen.replaceMethod(meth, newMeth);

	      }

		  return(cgen);



     }
   public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
 	   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
   }

}