package algorithms;

import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: ScramblingIdentifier
@ Author: Suma Venkatesh
@ Description:   This algorithm change the identifiers or variables in a program to less meaningful ones.
*/


public class ScramblingIdentifier {

	public boolean apply(JavaClass clazz) {
		ClassGen cgen = null;
		String classname = null;
		boolean sucess = false;

		try {
			//generate classgen on the inout class file
			cgen = new ClassGen(clazz);
			ConstantPoolGen cpg = cgen.getConstantPool();
			classname = clazz.getClassName();

			//rename the identifiers
			renameFields(cgen.getFields(),cgen,cpg,classname);

			//dump the obfuscated class in obfuscated_classes dir
			JavaClass c = cgen.getJavaClass();
			c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf"+ ".class"));

			//convert the class into byte code instruction set and dump them as HTML file
			convertToHTML(c,"Obf");

			sucess = true;
		 }
		 catch(Exception e) {
			 System.out.println("Exception : " + e);
	      }
		return(sucess);
	 }

	 public static void renameFields(Field[] fields,ClassGen cgen,ConstantPoolGen cpg,String className) {

			 String oldName = null;
			 String fieldType = null;
			 String newName = null;

			 //for each of the fields in the class get field name and assign a new name
			 for(int i=0; i < fields.length; i++) {
				oldName = fields[i].getName();
				FieldGen field = new FieldGen(fields[i], cpg);
				fieldType = field.getSignature();
				newName = "V" + i;
				field.setName(newName);
				//replace the old fields with new ones
				cgen.replaceField(fields[i], field.getField());

				//lookup for the old field references and change them
				int fieldRefIndex = cpg.lookupFieldref(className,oldName,fieldType);
				ConstantFieldref fieldRef = (ConstantFieldref)cpg.getConstant(fieldRefIndex);
				fieldRef.setNameAndTypeIndex(cpg.addNameAndType(newName,fieldType));

				//set the modified constant pool
				cgen.setConstantPool(cpg);
			}

	}

    //converts the input class to set of byte code intructions and dumps them as HTML file.
    public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
   		   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
    }
}