package algorithms;

/** This is a helper class which has methods that call Kelly's Stack Simulator to
  * simulate the stack and get the necessary instruction handles
  */
public class arr {

   private static boolean DEBUG = false;

   public static boolean chekifarrayinreturn(de.fub.bytecode.generic.InstructionHandle ih1,
    					   int lvi,utils.stacksimulator.StackSimulator ss)
    {
	utils.stacksimulator.Context c = ss.getInstructionContext(ih1);
	int size=c.getStackSize();

	for(int i=0;i<size;i++)
	{
		utils.stacksimulator.StackData []sd = c.getStackAt(i);
		de.fub.bytecode.generic.InstructionHandle ih = sd[0].getInstruction();

		if(DEBUG)
		System.out.println("At stack posn " + i +" " +ih.getInstruction().toString());

		de.fub.bytecode.generic.Instruction in=ih.getInstruction();
		if(in instanceof de.fub.bytecode.generic.ALOAD
			&& ((de.fub.bytecode.generic.ALOAD)in).getIndex()==lvi)
		{
			if(DEBUG)
			System.out.println(" Returning False ");
			return false;
		}

	}
	if(DEBUG)
		System.out.println(" Returning True ");
	return true;
    }
    public static boolean chekifarrayinstaticmtd(de.fub.bytecode.generic.InstructionHandle ih1,
    					   int lvi,int num_args,utils.stacksimulator.StackSimulator ss)
    {
	utils.stacksimulator.Context c = ss.getInstructionContext(ih1);
	int size=c.getStackSize();

	if(DEBUG)
	System.out.println("No of parameters for the method : "+size+" but number of args ="+num_args);

	for(int i=0;i<num_args;i++)
	{
		utils.stacksimulator.StackData []sd = c.getStackAt(i);
		de.fub.bytecode.generic.InstructionHandle ih = sd[0].getInstruction();

		if(DEBUG)
		System.out.println("At stack posn " + i +" " +ih.getInstruction().toString());

		de.fub.bytecode.generic.Instruction in=ih.getInstruction();
		if(in instanceof de.fub.bytecode.generic.ALOAD
			&& ((de.fub.bytecode.generic.ALOAD)in).getIndex()==lvi)
		{
			if(DEBUG)
			System.out.println(" Returning False ");
			return false;
		}

	}

	if(DEBUG)
	System.out.println(" Returning True ");

	return true;
    }

    public static boolean chekifarrayinobjectsmtd(de.fub.bytecode.generic.InstructionHandle ih1,
    					   int lvi,int num_args,utils.stacksimulator.StackSimulator ss)
    						/*de.fub.bytecode.generic.MethodGen mg,
						de.fub.bytecode.generic.ConstantPoolGen cpg)*/
    {

	utils.stacksimulator.Context c = ss.getInstructionContext(ih1);
	int size=c.getStackSize();

	for(int i=0;i<num_args;i++)
	{
		utils.stacksimulator.StackData []sd = c.getStackAt(i);
		de.fub.bytecode.generic.InstructionHandle ih = sd[0].getInstruction();
  		if(DEBUG)
		System.out.println("At stack posn " + i +" " +ih.getInstruction().toString());
		de.fub.bytecode.generic.Instruction in=ih.getInstruction();
		if(in instanceof de.fub.bytecode.generic.ALOAD
			&& ((de.fub.bytecode.generic.ALOAD)in).getIndex()==lvi)
		{

			if(DEBUG)
			System.out.println(" Returning False ");

			return false;
		}

	}

	if(DEBUG)
	System.out.println(" Returning True ");

	return true;
    }



    public static de.fub.bytecode.generic.InstructionHandle  getNameofArray(de.fub.bytecode.generic.InstructionHandle ih2,
										de.fub.bytecode.generic.MethodGen mg,
										de.fub.bytecode.generic.ConstantPoolGen cpg)
    {
	utils.stacksimulator.StackSimulator ss =
	    new utils.stacksimulator.StackSimulator(mg,cpg);
	utils.stacksimulator.Context c = ss.getInstructionContext(ih2);

	if(DEBUG)
	{
		System.out.println(" Instruction Handle : (DEBUG) "+ ih2.toString());
		System.out.println(" *********** CONTEXT ::::::::::::: (DEBUG)");
		System.out.println(c.toString());
	}
	utils.stacksimulator.StackData []sd = c.getStackAt(2);

	if(DEBUG)
	{
		for(int i=0;i<sd.length;i++)
		{
		System.out.println("*********** STACKDATA *********** (DEBUG)");
		System.out.println(sd[i].toString());
		}
	}

	de.fub.bytecode.generic.InstructionHandle ih = sd[0].getInstruction();

	if(DEBUG)
	System.out.println(ih.getInstruction().toString());

	return ih;
    }
    public static de.fub.bytecode.generic.InstructionHandle  getIndexInstructions(de.fub.bytecode.generic.InstructionHandle ih2,
										de.fub.bytecode.generic.MethodGen mg,
										de.fub.bytecode.generic.ConstantPoolGen cpg)
    {
	utils.stacksimulator.StackSimulator ss =
	    new utils.stacksimulator.StackSimulator(mg,cpg);
	utils.stacksimulator.Context c = ss.getInstructionContext(ih2);
	if(DEBUG)
	{
		System.out.println(" Instruction Handle : (DEBUG) "+ ih2.toString());
		System.out.println(" *********** CONTEXT ::::::::::::: (DEBUG)");
		System.out.println(c.toString());
	}

	utils.stacksimulator.StackData []sd = c.getStackAt(1);

	if(DEBUG)
	{
		for(int i=0;i<sd.length;i++)
		{
		System.out.println("*********** STACKDATA *********** (DEBUG)");
		System.out.println(sd[i].toString());
		}
	}

	de.fub.bytecode.generic.InstructionHandle ih = sd[0].getInstruction();

	if(DEBUG)
	System.out.println(ih.getInstruction().toString());

	return ih;
    }

    public static de.fub.bytecode.generic.InstructionHandle[]  getValueInstructions(de.fub.bytecode.generic.InstructionHandle ih1,
    										de.fub.bytecode.generic.InstructionHandle ih2,
										de.fub.bytecode.generic.MethodGen mg,
										de.fub.bytecode.generic.ConstantPoolGen cpg)
    {
	utils.stacksimulator.StackSimulator ss =
	    new utils.stacksimulator.StackSimulator(mg,cpg);
	utils.stacksimulator.Context c = ss.getInstructionContext(ih2);
	utils.stacksimulator.StackData []sd1 = c.getStackAt(0);

	utils.stacksimulator.StackData []sd2 = c.getStackAt(1);
	de.fub.bytecode.generic.InstructionHandle []ih =
	    new de.fub.bytecode.generic.InstructionHandle[2];
	ih[1]= sd1[0].getInstruction();
	ih[0] = sd2[0].getInstruction();
	if(DEBUG)
	{
		System.out.println(" VALUE ::::::::::" + ih[1].getInstruction().toString());
       		System.out.println(ih[0].getInstruction().toString());
		System.out.println(ih[1].getNext().getInstruction().toString());
	}
	return ih;
    }

}


