package engine;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;


/*
@ Class: ObfuscationView
@ Author: Suma Venkatesh
@ Description:   This class is the Java Swing class which creates the GUI for JHide.
  It provides the obfuscation and view interfaces.
*/


public class ObfuscationView extends JPanel {

	static private final String newline = "\n";
	JLabel heading;
	public String classname =null;
	public String algname =null;
	File file;
	private javax.swing.JEditorPane jEditorPane = null;

	public ObfuscationView() throws java.io.IOException {

		JTabbedPane tabbedPane = new JTabbedPane();
		ImageIcon icon = new ImageIcon("middle.gif");

		Component panel1 = Obfuscate();
		tabbedPane.addTab("Obfuscate", icon, panel1, "Click here to Obfuscate");
		tabbedPane.setSelectedIndex(0);

		Component panel3 = View();
		tabbedPane.addTab("View", icon, panel3, "Click here to view obfuscation");

		//Add the tabbed pane to this panel.
		setLayout(new GridLayout(1,1));

		add(tabbedPane);
	}


	public Component Obfuscate() throws java.io.IOException {



		String[] algorithms = { "FormatRemoval","ScramblingIdentifier","InsertDeadCodeLoops","InsertDeadCodeMethodArguments","InsertDeadCodeFields","InsertDeadCodeMethods","LoopFission","DataStorage",
				 				"LoopReorder","SplittingVariables","MethodsMerging","ParameterMerging","ClassesMerging","ParameterReordering","MethodInLiner","LocalVariableReordering","ConstantsPoolReordering",
								"NewAlgorithm","LoopUnroll","AlterIfElse","HighLevelLanguageBreaking","NodeSplitter","DataAggregation","ClassSplitter","NameOverloading","Method2RMadness","MethodCloning","LoopBlocking","DataEncoding","DataOrdering"};


		//Create a file chooser
		final JFileChooser fc = new JFileChooser();

		JLabel label1 = new JLabel("Select the source file to obfuscate ");
		label1.setBounds(20,20,200,20);
		//Create the open button
		ImageIcon openIcon = new ImageIcon("open.gif");
		JButton openButton = new JButton("", openIcon);

		openButton.setBounds(240,20,40,20);
		openButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int returnVal = fc.showOpenDialog(ObfuscationView.this);
					if (returnVal == JFileChooser.APPROVE_OPTION) {
						file = fc.getSelectedFile();
						//this is where a real application would open the file.
						System.out.println("#################Opened File::############# " + file.getName() + "." + newline);
						classname = file.getName();

					} else {
						System.out.println("Open command cancelled by user." + newline);
					}
				}
		});

		JComboBox algorithmsList = new JComboBox(algorithms);
		algorithmsList.setBounds(240,60,200,20);
		algorithmsList.setSelectedIndex(0);

		algorithmsList.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						JComboBox cb = (JComboBox)e.getSource();
						algname = (String)cb.getSelectedItem();
						System.out.println("###################You selected algorithm###############" + algname);
					}
		});

		JButton b = new JButton("<html><center><font color=#ffffff><b>Obfuscate</b></font></center></html>");
		b.setBounds(20,100,200,20);
		b.setVerticalTextPosition(AbstractButton.CENTER);
		b.setHorizontalTextPosition(AbstractButton.LEADING);
		b.setActionCommand("Obfuscate");
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					if ("Obfuscate".equals(e.getActionCommand())) {

						ApplyTransformations obj = new ApplyTransformations();
						boolean sucess = false;
						sucess = obj.callEngine(classname,algname);
						if(sucess) {
							System.out.println("####Done Obfuscation####" + algname + "######on class######" + classname);
						}else { System.out.println("####Obfuscation Failed####" + algname + "####on class####" + classname ); }
					}
				} catch(Exception ex) { ex.printStackTrace() ;System.out.println("Exception" + ex); }
			}
		});

		JPanel panel = new JPanel();
		panel.setLayout(null);

		JLabel label = new JLabel("Select the Obfuscation Algorithm ");
		label.setBounds(20,60,200,20);

		panel.add(label1);
		panel.add(openButton);
		panel.add(label);
		panel.add(algorithmsList);
		panel.add(b);

		return panel;
	}

	protected Component View() throws java.io.IOException ,java.io.FileNotFoundException {

				JPanel panel = new JPanel(false);
				 //Create a file chooser
				JButton ButtonA = new JButton("View Source Code");
				ButtonA.setBounds(20,20,200,20);
				ButtonA.addActionListener(new ActionListener() {
					 public void actionPerformed(ActionEvent e) {
						 try {
						 	classname = classname.substring(0,classname.indexOf(".")).trim();
							System.out.println("#########Viewing changes in code for class ########"+ classname);


							if(algname.equalsIgnoreCase("FormatRemoval")) {
								JFrame frame = new JFrame("Source Code Editing");
								JPanel panel = new JPanel();
								panel.setLayout(new GridLayout(2,0,15,5));
								JTextArea text_area = new JTextArea("Original",10,40);


								//for specific examples
								String  outName = "C:/JHide/examples/"+ classname +".java";

								//for general sample
								File file = new File(outName);
								FileInputStream input_file = new FileInputStream(file);
								byte[] file_data = new byte[(int) file.length()];
								input_file.read(file_data);
								text_area.insert(new String(file_data), 0);
								panel.add(text_area);

								JTextArea text_area1 = new JTextArea("Obfuscated", 10,40);
								String  outName1 = "C:/JHide/Obfuscated_Classes/"+ classname+"_obf.txt";
								File file1= new File(outName1);
								FileInputStream input_file1 = new FileInputStream(file1);
								byte[] file_data1 = new byte[(int) file1.length()];
								input_file1.read(file_data1);
								text_area1.insert(new String(file_data1), 0);
								panel.add(text_area1);
								frame.getContentPane().add(panel);
								frame.pack();
								frame.setVisible(true);

						    }
							else if(algname.equalsIgnoreCase("ConstantsPoolReordering")) {
								System.out.println("######No changes in source code view #############");

						    }
							
							
						    else if(algname.equalsIgnoreCase("ClassesMerging")) {
									classname = classname.substring(0, classname.indexOf("A"));

									Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/examples/" + classname+ "A.class");
									Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/examples/" + classname+ "B.class");
									Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/examples/" + classname+ "_obf.class");

							}
						    else if(algname.equalsIgnoreCase("NodeSplitter")) {
								   	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/examples/" + classname+ ".class");
								   	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/examples/" + classname+ "_obf.class");
								 	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/" + classname+ "1_obf.class");							

						    }
						    else if(algname.equalsIgnoreCase("ClassSplitter")) {
							   	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/examples/" + classname+ ".class");
							   	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/examples/" + classname+ "_obf.class");
							 	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/examples/" + classname+ "1_obf.class");							

					        }
						    else if(algname.equalsIgnoreCase("MethodCloning")) {
							   	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/examples/" + classname+ ".class");
							   	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/examples/" + classname+ "1_obf.class");
							 	Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/examples/" + classname+ "2_obf.class");							

					        }
							else {
									Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/examples/" + classname + ".class");
									Runtime.getRuntime().exec("C:/Program Files/decomp/DJ " + "C:/JHide/Obfuscated_Classes/examples/"  + classname + "_obf.class");
							}
							
					}
					catch(Exception ex) {System.out.println("Exception:"+ex); }
				}
				});



				JButton ButtonB = new JButton("View Byte Code ");
				ButtonB.setBounds(20,60,200,20);
				ButtonB.addActionListener(new ActionListener() {
					 public void actionPerformed(ActionEvent e) {

							try {
								if(algname.equalsIgnoreCase("ClassesMerging")) {

									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname +"A"+ "_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname + "B"+ "_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "_code.html");
								}
								else if(algname.equalsIgnoreCase("ClassesMerging")) {

									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname +"A"+ "_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname + "B"+ "_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "_code.html");
								}
								else if(algname.equalsIgnoreCase("NodeSplitter")) {

									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname +"_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "_code.html");
									
								}
								else if(algname.equalsIgnoreCase("ClassSplitter")) {
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname +"_code.html");
									//Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "1_code.html");
									
						        }
								else if(algname.equalsIgnoreCase("MethodCloning")) {
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname +"_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "1_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "2_code.html");
									
						        }
			
								else if(algname.equalsIgnoreCase("ConstantsPoolReordering")) {
									JFrame frame = new JFrame("Byte Code Editing");
									JPanel panel = new JPanel();
									panel.setLayout(new GridLayout(2,0,15,5));
									JTextArea text_area = new JTextArea("Original",10,40);

									//for specific examples
									String  outName = "C:/JHide/Obfuscated_Classes/"+ classname+"_src.txt";

									//for general sample
									File file = new File(outName);
									FileInputStream input_file = new FileInputStream(file);
									byte[] file_data = new byte[(int) file.length()];
									input_file.read(file_data);
									text_area.insert(new String(file_data), 0);
									panel.add(text_area);

									JTextArea text_area1 = new JTextArea("Obfuscated", 10,40);
									String  outName1 = "C:/JHide/Obfuscated_Classes/"+ classname+"_obf.txt";
									File file1= new File(outName1);
									FileInputStream input_file1 = new FileInputStream(file1);
									byte[] file_data1 = new byte[(int) file1.length()];
									input_file1.read(file_data1);
									text_area1.insert(new String(file_data1), 0);
									panel.add(text_area1);
									frame.getContentPane().add(panel);
									frame.pack();
									frame.setVisible(true);

							    }
								else {
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Srcexamples." + classname + "_code.html");
									Runtime.getRuntime().exec("C:/Program Files/Internet Explorer/IEXPLORE.EXE " + "C:/JHide/Obfuscated_Classes/HTMLFiles/Obfexamples." + classname + "_code.html");
								}

							} catch(Exception ex) {
							  System.out.println("Exception" + ex);
							}


					 }
				});

				panel.setLayout(null);
				panel.add(ButtonA);
				panel.add(ButtonB);


				return panel;
	}



	public static void main(String s[]) throws java.io.IOException{
		JFrame frame = new JFrame("Welcome To JHide");

		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {System.exit(0);}
		});


		frame.setContentPane(new ObfuscationView());
		frame.setSize(500,500);
		frame.setVisible(true);
	}



	/**
	 * This method initializes jEditorPane
	 *
	 * @return javax.swing.JEditorPane
	 */
	private javax.swing.JEditorPane getJEditorPane() {
		if(jEditorPane == null) {
			jEditorPane = new javax.swing.JEditorPane();
		}
		return jEditorPane;
	}
}